// THIS FILE IS AUTOMATICALLY GENERATED.
/***
 * Web Browser Interface for JSX
 *
 * @author DeNA, Co., Ltd.
 * @see http://www.w3.org/
 */
import "js.jsx";

/**
 * Document Object Model in Web Browsers
 */
final class dom {
	delete function constructor() { }

	/**
	 * The top-level Window object.
	 */
    static const window   = js.global["window"]   as __noconvert__ Window;
	/**
	 * The top-level HTMLDocument object.
	 */
	static const document = js.global["document"] as __noconvert__ HTMLDocument;
	/**
	 * same as <code>dom.document.getElementById(id)</code>, except returns
	 * <code>HTMLElement</code>.
	 */
	static function id(id : string) : HTMLElement {
		return dom.document.getElementById(id) as HTMLElement;
	}

	/**
	 * same as <code>dom.document.getElement(id)</code>, except returns
	 * <code>HTMLElement</code>.
	 */
	static function getElementById(id : string) : HTMLElement {
		return dom.document.getElementById(id) as HTMLElement;
	}

	/**
	 * same as <code>dom.document.createElement(id)</code>, except returns
	 * <code>HTMLElement</code>.
	 */
	static function createElement(tag : string) : HTMLElement {
		return dom.document.createElement(tag) as __noconvert__ HTMLElement;
	}

}

/** @see http://www.w3.org/TR/dom/ */
native final class DOMException {

	static __readonly__ var INDEX_SIZE_ERR : number/*unsigned short*/;
	       __readonly__ var INDEX_SIZE_ERR : number/*unsigned short*/;
	static __readonly__ var DOMSTRING_SIZE_ERR : number/*unsigned short*/;
	       __readonly__ var DOMSTRING_SIZE_ERR : number/*unsigned short*/;
	// historical
	static __readonly__ var HIERARCHY_REQUEST_ERR : number/*unsigned short*/;
	       __readonly__ var HIERARCHY_REQUEST_ERR : number/*unsigned short*/;
	static __readonly__ var WRONG_DOCUMENT_ERR : number/*unsigned short*/;
	       __readonly__ var WRONG_DOCUMENT_ERR : number/*unsigned short*/;
	static __readonly__ var INVALID_CHARACTER_ERR : number/*unsigned short*/;
	       __readonly__ var INVALID_CHARACTER_ERR : number/*unsigned short*/;
	static __readonly__ var NO_DATA_ALLOWED_ERR : number/*unsigned short*/;
	       __readonly__ var NO_DATA_ALLOWED_ERR : number/*unsigned short*/;
	// historical
	static __readonly__ var NO_MODIFICATION_ALLOWED_ERR : number/*unsigned short*/;
	       __readonly__ var NO_MODIFICATION_ALLOWED_ERR : number/*unsigned short*/;
	static __readonly__ var NOT_FOUND_ERR : number/*unsigned short*/;
	       __readonly__ var NOT_FOUND_ERR : number/*unsigned short*/;
	static __readonly__ var NOT_SUPPORTED_ERR : number/*unsigned short*/;
	       __readonly__ var NOT_SUPPORTED_ERR : number/*unsigned short*/;
	static __readonly__ var INUSE_ATTRIBUTE_ERR : number/*unsigned short*/;
	       __readonly__ var INUSE_ATTRIBUTE_ERR : number/*unsigned short*/;
	// historical
	static __readonly__ var INVALID_STATE_ERR : number/*unsigned short*/;
	       __readonly__ var INVALID_STATE_ERR : number/*unsigned short*/;
	static __readonly__ var SYNTAX_ERR : number/*unsigned short*/;
	       __readonly__ var SYNTAX_ERR : number/*unsigned short*/;
	static __readonly__ var INVALID_MODIFICATION_ERR : number/*unsigned short*/;
	       __readonly__ var INVALID_MODIFICATION_ERR : number/*unsigned short*/;
	static __readonly__ var NAMESPACE_ERR : number/*unsigned short*/;
	       __readonly__ var NAMESPACE_ERR : number/*unsigned short*/;
	static __readonly__ var INVALID_ACCESS_ERR : number/*unsigned short*/;
	       __readonly__ var INVALID_ACCESS_ERR : number/*unsigned short*/;
	static __readonly__ var VALIDATION_ERR : number/*unsigned short*/;
	       __readonly__ var VALIDATION_ERR : number/*unsigned short*/;
	// historical
	static __readonly__ var TYPE_MISMATCH_ERR : number/*unsigned short*/;
	       __readonly__ var TYPE_MISMATCH_ERR : number/*unsigned short*/;
	// historical; use TypeError instead
	static __readonly__ var SECURITY_ERR : number/*unsigned short*/;
	       __readonly__ var SECURITY_ERR : number/*unsigned short*/;
	static __readonly__ var NETWORK_ERR : number/*unsigned short*/;
	       __readonly__ var NETWORK_ERR : number/*unsigned short*/;
	static __readonly__ var ABORT_ERR : number/*unsigned short*/;
	       __readonly__ var ABORT_ERR : number/*unsigned short*/;
	static __readonly__ var URL_MISMATCH_ERR : number/*unsigned short*/;
	       __readonly__ var URL_MISMATCH_ERR : number/*unsigned short*/;
	static __readonly__ var QUOTA_EXCEEDED_ERR : number/*unsigned short*/;
	       __readonly__ var QUOTA_EXCEEDED_ERR : number/*unsigned short*/;
	static __readonly__ var TIMEOUT_ERR : number/*unsigned short*/;
	       __readonly__ var TIMEOUT_ERR : number/*unsigned short*/;
	static __readonly__ var INVALID_NODE_TYPE_ERR : number/*unsigned short*/;
	       __readonly__ var INVALID_NODE_TYPE_ERR : number/*unsigned short*/;
	static __readonly__ var DATA_CLONE_ERR : number/*unsigned short*/;
	       __readonly__ var DATA_CLONE_ERR : number/*unsigned short*/;
	var code : number/*unsigned short*/;

} // end of DOMException

/** @see http://www.w3.org/TR/dom/ */
native final class DOMError {

	__readonly__ var name : string/*DOMString*/;

} // end of DOMError

/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
native class Event {

	/** @see http://www.w3.org/TR/dom/ */
	function constructor(type : string/*DOMString*/);
	/** @see http://www.w3.org/TR/dom/ */
	function constructor(
		type : string/*DOMString*/,
		eventInitDict : EventInit
	);

	/** @see http://www.w3.org/TR/dom/ */
	__readonly__ var type : string/*DOMString*/;
	/** @see http://www.w3.org/TR/dom/ */
	__readonly__ var target : Nullable.<EventTarget>;
	/** @see http://www.w3.org/TR/dom/ */
	__readonly__ var currentTarget : Nullable.<EventTarget>;
	/** @see http://www.w3.org/TR/dom/ */
	static __readonly__ var NONE : number/*unsigned short*/;
	/** @see http://www.w3.org/TR/dom/ */
	       __readonly__ var NONE : number/*unsigned short*/;
	/** @see http://www.w3.org/TR/dom/ */
	static __readonly__ var CAPTURING_PHASE : number/*unsigned short*/;
	/** @see http://www.w3.org/TR/dom/ */
	       __readonly__ var CAPTURING_PHASE : number/*unsigned short*/;
	/** @see http://www.w3.org/TR/dom/ */
	static __readonly__ var AT_TARGET : number/*unsigned short*/;
	/** @see http://www.w3.org/TR/dom/ */
	       __readonly__ var AT_TARGET : number/*unsigned short*/;
	/** @see http://www.w3.org/TR/dom/ */
	static __readonly__ var BUBBLING_PHASE : number/*unsigned short*/;
	/** @see http://www.w3.org/TR/dom/ */
	       __readonly__ var BUBBLING_PHASE : number/*unsigned short*/;
	/** @see http://www.w3.org/TR/dom/ */
	__readonly__ var eventPhase : number/*unsigned short*/;
	/** @see http://www.w3.org/TR/dom/ */
	function stopPropagation() : void;
	/** @see http://www.w3.org/TR/dom/ */
	function stopImmediatePropagation() : void;
	/** @see http://www.w3.org/TR/dom/ */
	__readonly__ var bubbles : boolean;
	/** @see http://www.w3.org/TR/dom/ */
	__readonly__ var cancelable : boolean;
	/** @see http://www.w3.org/TR/dom/ */
	function preventDefault() : void;
	/** @see http://www.w3.org/TR/dom/ */
	__readonly__ var defaultPrevented : boolean;
	/** @see http://www.w3.org/TR/dom/ */
	__readonly__ var isTrusted : boolean;
	/** @see http://www.w3.org/TR/dom/ */
	__readonly__ var timeStamp : number/*DOMTimeStamp*/;
	/** @see http://www.w3.org/TR/dom/ */
	function initEvent(
		type : string/*DOMString*/,
		bubbles : boolean,
		cancelable : boolean
	) : void;

	// PhaseType
	// Introduced in DOM Level 3:

} // end of Event

native class EventInit {

	/** @see http://www.w3.org/TR/dom/ */
	var bubbles : boolean;
	/** @see http://www.w3.org/TR/dom/ */
	var cancelable : boolean;


} // end of EventInit

/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
native final class CustomEvent extends Event {

	/** @see http://www.w3.org/TR/dom/ */
	function constructor(type : string/*DOMString*/);
	/** @see http://www.w3.org/TR/dom/ */
	function constructor(
		type : string/*DOMString*/,
		eventInitDict : CustomEventInit
	);

	/** @see http://www.w3.org/TR/dom/ */
	__readonly__ var detail : variant/*any*/;


	// Originally introduced (and deprecated) in DOM Level 3:
	function initCustomEvent(
		typeArg : string/*DOMString*/,
		canBubbleArg : boolean,
		cancelableArg : boolean,
		detailArg : variant/*any*/
	) : void;

} // end of CustomEvent

/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
native final class CustomEventInit extends EventInit {

	/** @see http://www.w3.org/TR/dom/ */
	var detail : variant/*any*/;

	// Attributes from Event:
	// inherits var bubbles : boolean;
	// inherits var cancelable : boolean;
	// Attributes for CustomEvent:

} // end of CustomEventInit

/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
native __fake__ class EventTarget {

	/** @see http://www.w3.org/TR/dom/ */
	function addEventListener(
		type : string/*DOMString*/,
		callback : Nullable.<function(:Event):void>/*EventListener?*/
	) : void;
	/** @see http://www.w3.org/TR/dom/ */
	function addEventListener(
		type : string/*DOMString*/,
		callback : Nullable.<function(:Event):void>/*EventListener?*/,
		capture : boolean
	) : void;
	/** @see http://www.w3.org/TR/dom/ */
	function removeEventListener(
		type : string/*DOMString*/,
		callback : Nullable.<function(:Event):void>/*EventListener?*/
	) : void;
	/** @see http://www.w3.org/TR/dom/ */
	function removeEventListener(
		type : string/*DOMString*/,
		callback : Nullable.<function(:Event):void>/*EventListener?*/,
		capture : boolean
	) : void;
	/** @see http://www.w3.org/TR/dom/ */
	function dispatchEvent(event : Event) : boolean;

	// Modified in DOM Level 3:

} // end of EventTarget

/** @see http://www.w3.org/TR/dom/ */
native final class MutationObserver {

	function constructor(
		callback : function(mutations:MutationRecord[],
		observer:MutationObserver):void/*MutationCallback*/
	);

	function observe(
		target : Node,
		options : MutationObserverInit
	) : void;
	function disconnect() : void;
	function takeRecords() : MutationRecord[];

} // end of MutationObserver

/** @see http://www.w3.org/TR/dom/ */
native final class MutationObserverInit {

	var childList : boolean;
	var attributes : boolean;
	var characterData : boolean;
	var subtree : boolean;
	var attributeOldValue : boolean;
	var characterDataOldValue : boolean;
	var attributeFilter : string[]/*sequence<DOMString>*/;

} // end of MutationObserverInit

/** @see http://www.w3.org/TR/dom/ */
native final class MutationRecord {

	__readonly__ var type : string/*DOMString*/;
	__readonly__ var target : Node;
	__readonly__ var addedNodes : NodeList;
	__readonly__ var removedNodes : NodeList;
	__readonly__ var previousSibling : Nullable.<Node>;
	__readonly__ var nextSibling : Nullable.<Node>;
	__readonly__ var attributeName : Nullable.<string>/*DOMString?*/;
	__readonly__ var attributeNamespace : Nullable.<string>/*DOMString?*/;
	__readonly__ var oldValue : Nullable.<string>/*DOMString?*/;

} // end of MutationRecord

/** @see http://www.w3.org/TR/dom/ */
native class Node extends EventTarget {

	static __readonly__ var ELEMENT_NODE : number/*unsigned short*/;
	       __readonly__ var ELEMENT_NODE : number/*unsigned short*/;
	static __readonly__ var ATTRIBUTE_NODE : number/*unsigned short*/;
	       __readonly__ var ATTRIBUTE_NODE : number/*unsigned short*/;
	// historical
	static __readonly__ var TEXT_NODE : number/*unsigned short*/;
	       __readonly__ var TEXT_NODE : number/*unsigned short*/;
	static __readonly__ var CDATA_SECTION_NODE : number/*unsigned short*/;
	       __readonly__ var CDATA_SECTION_NODE : number/*unsigned short*/;
	// historical
	static __readonly__ var ENTITY_REFERENCE_NODE : number/*unsigned short*/;
	       __readonly__ var ENTITY_REFERENCE_NODE : number/*unsigned short*/;
	// historical
	static __readonly__ var ENTITY_NODE : number/*unsigned short*/;
	       __readonly__ var ENTITY_NODE : number/*unsigned short*/;
	// historical
	static __readonly__ var PROCESSING_INSTRUCTION_NODE : number/*unsigned short*/;
	       __readonly__ var PROCESSING_INSTRUCTION_NODE : number/*unsigned short*/;
	static __readonly__ var COMMENT_NODE : number/*unsigned short*/;
	       __readonly__ var COMMENT_NODE : number/*unsigned short*/;
	static __readonly__ var DOCUMENT_NODE : number/*unsigned short*/;
	       __readonly__ var DOCUMENT_NODE : number/*unsigned short*/;
	static __readonly__ var DOCUMENT_TYPE_NODE : number/*unsigned short*/;
	       __readonly__ var DOCUMENT_TYPE_NODE : number/*unsigned short*/;
	static __readonly__ var DOCUMENT_FRAGMENT_NODE : number/*unsigned short*/;
	       __readonly__ var DOCUMENT_FRAGMENT_NODE : number/*unsigned short*/;
	static __readonly__ var NOTATION_NODE : number/*unsigned short*/;
	       __readonly__ var NOTATION_NODE : number/*unsigned short*/;
	// historical
	__readonly__ var nodeType : number/*unsigned short*/;
	__readonly__ var nodeName : string/*DOMString*/;
	__readonly__ var baseURI : Nullable.<string>/*DOMString?*/;
	__readonly__ var ownerDocument : Nullable.<Document>;
	__readonly__ var parentNode : Nullable.<Node>;
	__readonly__ var parentElement : Nullable.<Element>;
	function hasChildNodes() : boolean;
	__readonly__ var childNodes : NodeList;
	__readonly__ var firstChild : Nullable.<Node>;
	__readonly__ var lastChild : Nullable.<Node>;
	__readonly__ var previousSibling : Nullable.<Node>;
	__readonly__ var nextSibling : Nullable.<Node>;
	var nodeValue : Nullable.<string>/*DOMString?*/;
	var textContent : Nullable.<string>/*DOMString?*/;
	function insertBefore(node : Node, child : Nullable.<Node>) : Node;
	function appendChild(node : Node) : Node;
	function replaceChild(node : Node, child : Node) : Node;
	function removeChild(child : Node) : Node;
	function normalize() : void;
	function cloneNode() : Node;
	function cloneNode(deep : boolean) : Node;
	function isEqualNode(node : Nullable.<Node>) : boolean;
	static __readonly__ var DOCUMENT_POSITION_DISCONNECTED : number/*unsigned short*/;
	       __readonly__ var DOCUMENT_POSITION_DISCONNECTED : number/*unsigned short*/;
	static __readonly__ var DOCUMENT_POSITION_PRECEDING : number/*unsigned short*/;
	       __readonly__ var DOCUMENT_POSITION_PRECEDING : number/*unsigned short*/;
	static __readonly__ var DOCUMENT_POSITION_FOLLOWING : number/*unsigned short*/;
	       __readonly__ var DOCUMENT_POSITION_FOLLOWING : number/*unsigned short*/;
	static __readonly__ var DOCUMENT_POSITION_CONTAINS : number/*unsigned short*/;
	       __readonly__ var DOCUMENT_POSITION_CONTAINS : number/*unsigned short*/;
	static __readonly__ var DOCUMENT_POSITION_CONTAINED_BY : number/*unsigned short*/;
	       __readonly__ var DOCUMENT_POSITION_CONTAINED_BY : number/*unsigned short*/;
	static __readonly__ var DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC : number/*unsigned short*/;
	       __readonly__ var DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC : number/*unsigned short*/;
	function compareDocumentPosition(
		other : Node
	) : number/*unsigned short*/;
	function contains(other : Nullable.<Node>) : boolean;
	function lookupPrefix(
		namespace : Nullable.<string>/*DOMString?*/
	) : Nullable.<string>/*DOMString?*/;
	function lookupNamespaceURI(
		prefix : Nullable.<string>/*DOMString?*/
	) : Nullable.<string>/*DOMString?*/;
	function isDefaultNamespace(
		namespace : Nullable.<string>/*DOMString?*/
	) : boolean;

} // end of Node

/** @see http://www.w3.org/TR/dom/ */
native class Document extends Node {

	function constructor();

	__readonly__ var implementation : DOMImplementation;
	__readonly__ var URL : string/*DOMString*/;
	__readonly__ var documentURI : string/*DOMString*/;
	__readonly__ var compatMode : string/*DOMString*/;
	__readonly__ var characterSet : string/*DOMString*/;
	__readonly__ var contentType : string/*DOMString*/;
	__readonly__ var doctype : Nullable.<DocumentType>;
	__readonly__ var documentElement : Nullable.<Element>;
	function getElementsByTagName(
		localName : string/*DOMString*/
	) : HTMLCollection;
	function getElementsByTagNameNS(
		namespace : Nullable.<string>/*DOMString?*/,
		localName : string/*DOMString*/
	) : HTMLCollection;
	function getElementsByClassName(
		classNames : string/*DOMString*/
	) : HTMLCollection;
	function getElementById(
		elementId : string/*DOMString*/
	) : Nullable.<Element>;
	function createElement(localName : string/*DOMString*/) : Element;
	function createElementNS(
		namespace : Nullable.<string>/*DOMString?*/,
		qualifiedName : string/*DOMString*/
	) : Element;
	function createDocumentFragment() : DocumentFragment;
	function createTextNode(data : string/*DOMString*/) : Text;
	function createComment(data : string/*DOMString*/) : Comment;
	function createProcessingInstruction(
		target : string/*DOMString*/,
		data : string/*DOMString*/
	) : ProcessingInstruction;
	function importNode(node : Node) : Node;
	function importNode(node : Node, deep : boolean) : Node;
	function adoptNode(node : Node) : Node;
	function createEvent(interface : string/*DOMString*/) : Event;
	function createRange() : Range;
	// NodeFilter.SHOW_ALL = 0xFFFFFFFF
	function createNodeIterator(root : Node) : NodeIterator;
	function createNodeIterator(
		root : Node,
		whatToShow : number/*unsigned long*/
	) : NodeIterator;
	function createNodeIterator(
		root : Node,
		whatToShow : number/*unsigned long*/,
		filter : Nullable.<NodeFilter>
	) : NodeIterator;
	function createTreeWalker(root : Node) : TreeWalker;
	function createTreeWalker(
		root : Node,
		whatToShow : number/*unsigned long*/
	) : TreeWalker;
	function createTreeWalker(
		root : Node,
		whatToShow : number/*unsigned long*/,
		filter : Nullable.<NodeFilter>
	) : TreeWalker;
	// NEW
	function prepend(...nodes : Node) : void;
	function prepend(...nodes : string/*DOMString*/) : void;
	function append(...nodes : Node) : void;
	function append(...nodes : string/*DOMString*/) : void;

	// implements DocumentEvent

	// Modified in DOM Level 3:

	/** @see http://dev.w3.org/csswg/cssom/ */
	__readonly__ var styleSheets : StyleSheetList;
	/** @see http://dev.w3.org/csswg/cssom/ */
	var selectedStyleSheetSet : Nullable.<string>/*DOMString?*/;
	/** @see http://dev.w3.org/csswg/cssom/ */
	__readonly__ var lastStyleSheetSet : Nullable.<string>/*DOMString?*/;
	/** @see http://dev.w3.org/csswg/cssom/ */
	__readonly__ var preferredStyleSheetSet : Nullable.<string>/*DOMString?*/;
	/** @see http://dev.w3.org/csswg/cssom/ */
	__readonly__ var styleSheetSets : DOMStringList;
	/** @see http://dev.w3.org/csswg/cssom/ */
	function enableStyleSheetsForSet(
		name : Nullable.<string>/*DOMString?*/
	) : void;

	/** @see http://dev.w3.org/csswg/cssom-view/ */
	function elementFromPoint(
		x : number/*float*/,
		y : number/*float*/
	) : Nullable.<Element>;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	function caretPositionFromPoint(
		x : number/*float*/,
		y : number/*float*/
	) : Nullable.<CaretPosition>;

	/** @see http://www.w3.org/TR/touch-events/ */
	function createTouch(
		view : AbstractView,
		target : EventTarget,
		identifier : number/*long*/,
		pageX : number/*long*/,
		pageY : number/*long*/,
		screenX : number/*long*/,
		screenY : number/*long*/
	) : Touch;
	/** @see http://www.w3.org/TR/touch-events/ */
	function createTouchList(touches : Touch[]) : TouchList;
	/** @see http://www.w3.org/TR/touch-events/ */
	function createTouchList(touch : Touch) : TouchList;

	/** @see http://www.w3.org/TR/selectors-api/ */
	function querySelector(
		selectors : string/*DOMString*/
	) : Nullable.<Element>;
	/** @see http://www.w3.org/TR/selectors-api/ */
	function querySelectorAll(
		selectors : string/*DOMString*/
	) : NodeList;

} // end of Document

/** @see http://www.w3.org/TR/dom/ */
native final class XMLDocument extends Document {

	/** @see http://www.w3.org/TR/html5/single-page.html */
	function load(url : string/*DOMString*/) : boolean;

} // end of XMLDocument

/** @see http://www.w3.org/TR/dom/ */
native final class DOMImplementation {

	function createDocumentType(
		qualifiedName : string/*DOMString*/,
		publicId : string/*DOMString*/,
		systemId : string/*DOMString*/
	) : DocumentType;
	function createDocument(
		namespace : Nullable.<string>/*DOMString?*/,
		qualifiedName : string/*DOMString*/,
		doctype : Nullable.<DocumentType>
	) : XMLDocument;
	function createHTMLDocument() : Document;
	function createHTMLDocument(title : string/*DOMString*/) : Document;
	function hasFeature(
		feature : string/*DOMString*/,
		version : string/*DOMString*/
	) : boolean;

} // end of DOMImplementation

/** @see http://www.w3.org/TR/dom/ */
native final class DocumentFragment extends Node {

	// NEW
	function prepend(...nodes : Node) : void;
	function prepend(...nodes : string/*DOMString*/) : void;
	function append(...nodes : Node) : void;
	function append(...nodes : string/*DOMString*/) : void;

	/** @see http://www.w3.org/TR/selectors-api/ */
	function querySelector(
		selectors : string/*DOMString*/
	) : Nullable.<Element>;
	/** @see http://www.w3.org/TR/selectors-api/ */
	function querySelectorAll(
		selectors : string/*DOMString*/
	) : NodeList;

} // end of DocumentFragment

/** @see http://www.w3.org/TR/dom/ */
native final class DocumentType extends Node {

	__readonly__ var name : string/*DOMString*/;
	__readonly__ var publicId : string/*DOMString*/;
	__readonly__ var systemId : string/*DOMString*/;
	// NEW
	function before(...nodes : Node) : void;
	function before(...nodes : string/*DOMString*/) : void;
	function after(...nodes : Node) : void;
	function after(...nodes : string/*DOMString*/) : void;
	function replace(...nodes : Node) : void;
	function replace(...nodes : string/*DOMString*/) : void;
	function remove() : void;

} // end of DocumentType

/** @see http://www.w3.org/TR/dom/ */
native class Element extends Node {

	__readonly__ var namespaceURI : Nullable.<string>/*DOMString?*/;
	__readonly__ var prefix : Nullable.<string>/*DOMString?*/;
	__readonly__ var localName : string/*DOMString*/;
	__readonly__ var tagName : string/*DOMString*/;
	var id : string/*DOMString*/;
	var className : string/*DOMString*/;
	__readonly__ var classList : DOMTokenList;
	__readonly__ var attributes : Attr[];
	function getAttribute(
		name : string/*DOMString*/
	) : Nullable.<string>/*DOMString?*/;
	function getAttributeNS(
		namespace : Nullable.<string>/*DOMString?*/,
		localName : string/*DOMString*/
	) : Nullable.<string>/*DOMString?*/;
	function setAttribute(
		name : string/*DOMString*/,
		value : string/*DOMString*/
	) : void;
	function setAttributeNS(
		namespace : Nullable.<string>/*DOMString?*/,
		name : string/*DOMString*/,
		value : string/*DOMString*/
	) : void;
	function removeAttribute(name : string/*DOMString*/) : void;
	function removeAttributeNS(
		namespace : Nullable.<string>/*DOMString?*/,
		localName : string/*DOMString*/
	) : void;
	function hasAttribute(name : string/*DOMString*/) : boolean;
	function hasAttributeNS(
		namespace : Nullable.<string>/*DOMString?*/,
		localName : string/*DOMString*/
	) : boolean;
	function getElementsByTagName(
		localName : string/*DOMString*/
	) : HTMLCollection;
	function getElementsByTagNameNS(
		namespace : Nullable.<string>/*DOMString?*/,
		localName : string/*DOMString*/
	) : HTMLCollection;
	function getElementsByClassName(
		classNames : string/*DOMString*/
	) : HTMLCollection;
	__readonly__ var children : HTMLCollection;
	__readonly__ var firstElementChild : Nullable.<Element>;
	__readonly__ var lastElementChild : Nullable.<Element>;
	__readonly__ var previousElementSibling : Nullable.<Element>;
	__readonly__ var nextElementSibling : Nullable.<Element>;
	__readonly__ var childElementCount : number/*unsigned long*/;
	// NEW
	function prepend(...nodes : Node) : void;
	function prepend(...nodes : string/*DOMString*/) : void;
	function append(...nodes : Node) : void;
	function append(...nodes : string/*DOMString*/) : void;
	function before(...nodes : Node) : void;
	function before(...nodes : string/*DOMString*/) : void;
	function after(...nodes : Node) : void;
	function after(...nodes : string/*DOMString*/) : void;
	function replace(...nodes : Node) : void;
	function replace(...nodes : string/*DOMString*/) : void;
	function remove() : void;

	/** @see http://www.w3.org/TR/DOM-Parsing/ */
	var innerHTML : string/*DOMString*/;
	/** @see http://www.w3.org/TR/DOM-Parsing/ */
	var outerHTML : string/*DOMString*/;
	/** @see http://www.w3.org/TR/DOM-Parsing/ */
	function insertAdjacentHTML(
		position : string/*DOMString*/,
		text : string/*DOMString*/
	) : void;

	/** @see http://dev.w3.org/csswg/cssom-view/ */
	function getClientRects() : ClientRectList;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	function getBoundingClientRect() : ClientRect;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	function scrollIntoView() : void;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	function scrollIntoView(top : boolean) : void;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	var scrollTop : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	var scrollLeft : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var scrollWidth : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var scrollHeight : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var clientTop : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var clientLeft : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var clientWidth : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var clientHeight : number/*long*/;

	/** @see http://www.w3.org/TR/selectors-api/ */
	function querySelector(
		selectors : string/*DOMString*/
	) : Nullable.<Element>;
	/** @see http://www.w3.org/TR/selectors-api/ */
	function querySelectorAll(
		selectors : string/*DOMString*/
	) : NodeList;

} // end of Element

/** @see http://www.w3.org/TR/dom/ */
native final class Attr {

	__readonly__ var name : string/*DOMString*/;
	var value : string/*DOMString*/;
	__readonly__ var namespaceURI : Nullable.<string>/*DOMString?*/;
	__readonly__ var prefix : Nullable.<string>/*DOMString?*/;
	__readonly__ var localName : string/*DOMString*/;

} // end of Attr

/** @see http://www.w3.org/TR/dom/ */
native class CharacterData extends Node {

	var data : string/*DOMString*/;
	__readonly__ var length : number/*unsigned long*/;
	function substringData(
		offset : number/*unsigned long*/,
		count : number/*unsigned long*/
	) : string/*DOMString*/;
	function appendData(data : string/*DOMString*/) : void;
	function insertData(
		offset : number/*unsigned long*/,
		data : string/*DOMString*/
	) : void;
	function deleteData(
		offset : number/*unsigned long*/,
		count : number/*unsigned long*/
	) : void;
	function replaceData(
		offset : number/*unsigned long*/,
		count : number/*unsigned long*/,
		data : string/*DOMString*/
	) : void;
	// NEW
	function before(...nodes : Node) : void;
	function before(...nodes : string/*DOMString*/) : void;
	function after(...nodes : Node) : void;
	function after(...nodes : string/*DOMString*/) : void;
	function replace(...nodes : Node) : void;
	function replace(...nodes : string/*DOMString*/) : void;
	function remove() : void;

} // end of CharacterData

/** @see http://www.w3.org/TR/dom/ */
native final class Text extends CharacterData {

	function splitText(offset : number/*unsigned long*/) : Text;
	__readonly__ var wholeText : string/*DOMString*/;

	/** @see http://www.w3.org/TR/DOM-Parsing/ */
	var serializeAsCDATA : boolean;

} // end of Text

/** @see http://www.w3.org/TR/dom/ */
native final class ProcessingInstruction extends CharacterData {

	__readonly__ var target : string/*DOMString*/;

} // end of ProcessingInstruction

/** @see http://www.w3.org/TR/dom/ */
native final class Comment extends CharacterData {
}

/** @see http://www.w3.org/TR/dom/ */
native final class Range {

	__readonly__ var startContainer : Node;
	__readonly__ var startOffset : number/*unsigned long*/;
	__readonly__ var endContainer : Node;
	__readonly__ var endOffset : number/*unsigned long*/;
	__readonly__ var collapsed : boolean;
	__readonly__ var commonAncestorContainer : Node;
	function setStart(
		refNode : Node,
		offset : number/*unsigned long*/
	) : void;
	function setEnd(
		refNode : Node,
		offset : number/*unsigned long*/
	) : void;
	function setStartBefore(refNode : Node) : void;
	function setStartAfter(refNode : Node) : void;
	function setEndBefore(refNode : Node) : void;
	function setEndAfter(refNode : Node) : void;
	function collapse(toStart : boolean) : void;
	function selectNode(refNode : Node) : void;
	function selectNodeContents(refNode : Node) : void;
	static __readonly__ var START_TO_START : number/*unsigned short*/;
	       __readonly__ var START_TO_START : number/*unsigned short*/;
	static __readonly__ var START_TO_END : number/*unsigned short*/;
	       __readonly__ var START_TO_END : number/*unsigned short*/;
	static __readonly__ var END_TO_END : number/*unsigned short*/;
	       __readonly__ var END_TO_END : number/*unsigned short*/;
	static __readonly__ var END_TO_START : number/*unsigned short*/;
	       __readonly__ var END_TO_START : number/*unsigned short*/;
	function compareBoundaryPoints(
		how : number/*unsigned short*/,
		sourceRange : Range
	) : number/*short*/;
	function deleteContents() : void;
	function extractContents() : DocumentFragment;
	function cloneContents() : DocumentFragment;
	function insertNode(node : Node) : void;
	function surroundContents(newParent : Node) : void;
	function cloneRange() : Range;
	function detach() : void;
	function isPointInRange(
		node : Node,
		offset : number/*unsigned long*/
	) : boolean;
	function comparePoint(
		node : Node,
		offset : number/*unsigned long*/
	) : number/*short*/;
	function intersectsNode(node : Node) : boolean;

	/** @see http://www.w3.org/TR/DOM-Parsing/ */
	function createContextualFragment(
		fragment : string/*DOMString*/
	) : DocumentFragment;

	/** @see http://dev.w3.org/csswg/cssom-view/ */
	function getClientRects() : ClientRectList;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	function getBoundingClientRect() : ClientRect;

} // end of Range

/** @see http://www.w3.org/TR/dom/ */
native final class NodeIterator {

	__readonly__ var root : Node;
	__readonly__ var referenceNode : Nullable.<Node>;
	__readonly__ var pointerBeforeReferenceNode : boolean;
	__readonly__ var whatToShow : number/*unsigned long*/;
	__readonly__ var filter : Nullable.<NodeFilter>;
	function nextNode() : Nullable.<Node>;
	function previousNode() : Nullable.<Node>;
	function detach() : void;

} // end of NodeIterator

/** @see http://www.w3.org/TR/dom/ */
native final class TreeWalker {

	__readonly__ var root : Node;
	__readonly__ var whatToShow : number/*unsigned long*/;
	__readonly__ var filter : Nullable.<NodeFilter>;
	var currentNode : Node;
	function parentNode() : Nullable.<Node>;
	function firstChild() : Nullable.<Node>;
	function lastChild() : Nullable.<Node>;
	function previousSibling() : Nullable.<Node>;
	function nextSibling() : Nullable.<Node>;
	function previousNode() : Nullable.<Node>;
	function nextNode() : Nullable.<Node>;

} // end of TreeWalker

/** @see http://www.w3.org/TR/dom/ */
native final class NodeFilter {

	// Constants for acceptNode()
	static __readonly__ var FILTER_ACCEPT : number/*unsigned short*/;
	       __readonly__ var FILTER_ACCEPT : number/*unsigned short*/;
	static __readonly__ var FILTER_REJECT : number/*unsigned short*/;
	       __readonly__ var FILTER_REJECT : number/*unsigned short*/;
	static __readonly__ var FILTER_SKIP : number/*unsigned short*/;
	       __readonly__ var FILTER_SKIP : number/*unsigned short*/;
	// Constants for whatToShow
	static __readonly__ var SHOW_ALL : number/*unsigned long*/;
	       __readonly__ var SHOW_ALL : number/*unsigned long*/;
	static __readonly__ var SHOW_ELEMENT : number/*unsigned long*/;
	       __readonly__ var SHOW_ELEMENT : number/*unsigned long*/;
	static __readonly__ var SHOW_ATTRIBUTE : number/*unsigned long*/;
	       __readonly__ var SHOW_ATTRIBUTE : number/*unsigned long*/;
	// historical
	static __readonly__ var SHOW_TEXT : number/*unsigned long*/;
	       __readonly__ var SHOW_TEXT : number/*unsigned long*/;
	static __readonly__ var SHOW_CDATA_SECTION : number/*unsigned long*/;
	       __readonly__ var SHOW_CDATA_SECTION : number/*unsigned long*/;
	// historical
	static __readonly__ var SHOW_ENTITY_REFERENCE : number/*unsigned long*/;
	       __readonly__ var SHOW_ENTITY_REFERENCE : number/*unsigned long*/;
	// historical
	static __readonly__ var SHOW_ENTITY : number/*unsigned long*/;
	       __readonly__ var SHOW_ENTITY : number/*unsigned long*/;
	// historical
	static __readonly__ var SHOW_PROCESSING_INSTRUCTION : number/*unsigned long*/;
	       __readonly__ var SHOW_PROCESSING_INSTRUCTION : number/*unsigned long*/;
	static __readonly__ var SHOW_COMMENT : number/*unsigned long*/;
	       __readonly__ var SHOW_COMMENT : number/*unsigned long*/;
	static __readonly__ var SHOW_DOCUMENT : number/*unsigned long*/;
	       __readonly__ var SHOW_DOCUMENT : number/*unsigned long*/;
	static __readonly__ var SHOW_DOCUMENT_TYPE : number/*unsigned long*/;
	       __readonly__ var SHOW_DOCUMENT_TYPE : number/*unsigned long*/;
	static __readonly__ var SHOW_DOCUMENT_FRAGMENT : number/*unsigned long*/;
	       __readonly__ var SHOW_DOCUMENT_FRAGMENT : number/*unsigned long*/;
	static __readonly__ var SHOW_NOTATION : number/*unsigned long*/;
	       __readonly__ var SHOW_NOTATION : number/*unsigned long*/;
	// historical

	function acceptNode(node : Node) : number/*unsigned short*/;

} // end of NodeFilter

/** @see http://www.w3.org/TR/dom/ */
native class NodeList {

	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<Node>;
	/* getter */
	function item(index : number/*unsigned long*/) : Nullable.<Node>;
	__readonly__ var length : number/*unsigned long*/;

} // end of NodeList

/** @see http://www.w3.org/TR/dom/ */
native class HTMLCollection {

	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<Element>;
	/* getter */
	function item(index : number/*unsigned long*/) : Nullable.<Element>;
	function __native_index_operator__(
		name : string/*DOMString*/
	) : Nullable.<Object>/*object?*/;
	/* getter */
	function namedItem(
		name : string/*DOMString*/
	) : Nullable.<Object>/*object?*/;
	// only returns Element

} // end of HTMLCollection

/** @see http://www.w3.org/TR/dom/ */
native final __fake__ class DOMStringList {

	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<string>/*DOMString?*/;
	/* getter */
	function item(
		index : number/*unsigned long*/
	) : Nullable.<string>/*DOMString?*/;
	function contains(string : string/*DOMString*/) : boolean;

} // end of DOMStringList

/** @see http://www.w3.org/TR/dom/ */
native class DOMTokenList {

	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<string>/*DOMString?*/;
	/* getter */
	function item(
		index : number/*unsigned long*/
	) : Nullable.<string>/*DOMString?*/;
	function contains(token : string/*DOMString*/) : boolean;
	function add(...tokens : string/*DOMString...*/) : void;
	function remove(...tokens : string/*DOMString...*/) : void;
	function toggle(token : string/*DOMString*/) : boolean;
	function toggle(
		token : string/*DOMString*/,
		force : boolean
	) : boolean;

} // end of DOMTokenList

/** @see http://www.w3.org/TR/dom/ */
native final class DOMSettableTokenList extends DOMTokenList {

	var value : string/*DOMString*/;

} // end of DOMSettableTokenList

/** @see http://www.w3.org/TR/DOM-Level-2-Views/idl/views.idl */
native final __fake__ class AbstractView {

	__readonly__ var document : DocumentView;

} // end of AbstractView

/** @see http://www.w3.org/TR/DOM-Level-2-Views/idl/views.idl */
native final __fake__ class DocumentView {

	__readonly__ var defaultView : AbstractView;

} // end of DocumentView

/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
native __fake__ class DocumentEvent {

	// Modified in DOM Level 3:
	function createEvent(eventInterface : string/*DOMString*/) : Event;

} // end of DocumentEvent

/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
native class UIEvent extends Event {

	__readonly__ var view : Nullable.<AbstractView>;
	__readonly__ var detail : number/*long*/;
	// Deprecated in DOM Level 3:
	function initUIEvent(
		typeArg : string/*DOMString*/,
		canBubbleArg : boolean,
		cancelableArg : boolean,
		viewArg : Nullable.<AbstractView>,
		detailArg : number/*long*/
	) : void;
	function constructor(typeArg : string/*DOMString*/);
	function constructor(
		typeArg : string/*DOMString*/,
		dictUIEventInit : UIEventInit
	);

} // end of UIEvent

/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
native final class FocusEvent extends UIEvent {

	__readonly__ var relatedTarget : Nullable.<EventTarget>;
	function constructor(typeArg : string/*DOMString*/);
	function constructor(
		typeArg : string/*DOMString*/,
		focusEventInitDict : FocusEventInit
	);

	// Originally introduced (and deprecated) in DOM Level 3:
	function initFocusEvent(
		typeArg : string/*DOMString*/,
		canBubbleArg : boolean,
		cancelableArg : boolean,
		viewArg : Nullable.<AbstractView>,
		detailArg : number/*long*/,
		relatedTargetArg : Nullable.<EventTarget>
	) : void;

} // end of FocusEvent

/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
native class MouseEvent extends UIEvent {

	__readonly__ var screenX : number/*long*/;
	__readonly__ var screenY : number/*long*/;
	__readonly__ var clientX : number/*long*/;
	__readonly__ var clientY : number/*long*/;
	__readonly__ var ctrlKey : boolean;
	__readonly__ var shiftKey : boolean;
	__readonly__ var altKey : boolean;
	__readonly__ var metaKey : boolean;
	__readonly__ var button : number/*unsigned short*/;
	__readonly__ var buttons : number/*unsigned short*/;
	__readonly__ var relatedTarget : Nullable.<EventTarget>;
	// Deprecated in DOM Level 3:
	function initMouseEvent(
		typeArg : string/*DOMString*/,
		canBubbleArg : boolean,
		cancelableArg : boolean,
		viewArg : Nullable.<AbstractView>,
		detailArg : number/*long*/,
		screenXArg : number/*long*/,
		screenYArg : number/*long*/,
		clientXArg : number/*long*/,
		clientYArg : number/*long*/,
		ctrlKeyArg : boolean,
		altKeyArg : boolean,
		shiftKeyArg : boolean,
		metaKeyArg : boolean,
		buttonArg : number/*unsigned short*/,
		relatedTargetArg : Nullable.<EventTarget>
	) : void;
	// Introduced in DOM Level 3:
	function getModifierState(keyArg : string/*DOMString*/) : boolean;
	function constructor(typeArg : string/*DOMString*/);
	function constructor(
		typeArg : string/*DOMString*/,
		mouseEventInitDict : MouseEventInit
	);


	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var pageX : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var pageY : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var x : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var y : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var offsetX : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var offsetY : number/*long*/;

	/** @see http://www.w3.org/TR/2dcontext/ */
	__readonly__ var region : Nullable.<string>/*DOMString?*/;

} // end of MouseEvent

/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
native final class WheelEvent extends MouseEvent {

	// DeltaModeCode
	static __readonly__ var DOM_DELTA_PIXEL : number/*unsigned long*/;
	       __readonly__ var DOM_DELTA_PIXEL : number/*unsigned long*/;
	static __readonly__ var DOM_DELTA_LINE : number/*unsigned long*/;
	       __readonly__ var DOM_DELTA_LINE : number/*unsigned long*/;
	static __readonly__ var DOM_DELTA_PAGE : number/*unsigned long*/;
	       __readonly__ var DOM_DELTA_PAGE : number/*unsigned long*/;
	__readonly__ var deltaX : number/*double*/;
	__readonly__ var deltaY : number/*double*/;
	__readonly__ var deltaZ : number/*double*/;
	__readonly__ var deltaMode : number/*unsigned long*/;
	function constructor(typeArg : string/*DOMString*/);
	function constructor(
		typeArg : string/*DOMString*/,
		wheelEventInitDict : WheelEventInit
	);

	// Originally introduced (and deprecated) in DOM Level 3:
	function initWheelEvent(
		typeArg : string/*DOMString*/,
		canBubbleArg : boolean,
		cancelableArg : boolean,
		viewArg : Nullable.<AbstractView>,
		detailArg : number/*long*/,
		screenXArg : number/*long*/,
		screenYArg : number/*long*/,
		clientXArg : number/*long*/,
		clientYArg : number/*long*/,
		buttonArg : number/*unsigned short*/,
		relatedTargetArg : Nullable.<EventTarget>,
		modifiersListArg : string/*DOMString*/,
		deltaXArg : number/*double*/,
		deltaYArg : number/*double*/,
		deltaZArg : number/*double*/,
		deltaMode : number/*unsigned long*/
	) : void;

} // end of WheelEvent

/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
native final class KeyboardEvent extends UIEvent {

	// KeyLocationCode
	static __readonly__ var DOM_KEY_LOCATION_STANDARD : number/*unsigned long*/;
	       __readonly__ var DOM_KEY_LOCATION_STANDARD : number/*unsigned long*/;
	static __readonly__ var DOM_KEY_LOCATION_LEFT : number/*unsigned long*/;
	       __readonly__ var DOM_KEY_LOCATION_LEFT : number/*unsigned long*/;
	static __readonly__ var DOM_KEY_LOCATION_RIGHT : number/*unsigned long*/;
	       __readonly__ var DOM_KEY_LOCATION_RIGHT : number/*unsigned long*/;
	static __readonly__ var DOM_KEY_LOCATION_NUMPAD : number/*unsigned long*/;
	       __readonly__ var DOM_KEY_LOCATION_NUMPAD : number/*unsigned long*/;
	static __readonly__ var DOM_KEY_LOCATION_MOBILE : number/*unsigned long*/;
	       __readonly__ var DOM_KEY_LOCATION_MOBILE : number/*unsigned long*/;
	static __readonly__ var DOM_KEY_LOCATION_JOYSTICK : number/*unsigned long*/;
	       __readonly__ var DOM_KEY_LOCATION_JOYSTICK : number/*unsigned long*/;
	__readonly__ var char : string/*DOMString*/;
	__readonly__ var key : string/*DOMString*/;
	__readonly__ var location : number/*unsigned long*/;
	__readonly__ var ctrlKey : boolean;
	__readonly__ var shiftKey : boolean;
	__readonly__ var altKey : boolean;
	__readonly__ var metaKey : boolean;
	__readonly__ var repeat : boolean;
	__readonly__ var locale : string/*DOMString*/;
	function getModifierState(keyArg : string/*DOMString*/) : boolean;
	function constructor(typeArg : string/*DOMString*/);
	function constructor(
		typeArg : string/*DOMString*/,
		keyboardEventInitDict : KeyboardEventInit
	);

	// Originally introduced (and deprecated) in DOM Level 3:
	function initKeyboardEvent(
		typeArg : string/*DOMString*/,
		canBubbleArg : boolean,
		cancelableArg : boolean,
		viewArg : Nullable.<AbstractView>,
		charArg : string/*DOMString*/,
		keyArg : string/*DOMString*/,
		locationArg : number/*unsigned long*/,
		modifiersListArg : string/*DOMString*/,
		repeat : boolean,
		localeArg : string/*DOMString*/
	) : void;

	// The following support legacy user agents:
	__readonly__ var charCode : number/*unsigned long*/;
	__readonly__ var keyCode : number/*unsigned long*/;
	__readonly__ var which : number/*unsigned long*/;

} // end of KeyboardEvent

/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
native final class CompositionEvent extends UIEvent {

	__readonly__ var data : Nullable.<string>/*DOMString?*/;
	__readonly__ var locale : string/*DOMString*/;
	function constructor(typeArg : string/*DOMString*/);
	function constructor(
		typeArg : string/*DOMString*/,
		compositionEventInitDict : CompositionEventInit
	);

	// Originally introduced (and deprecated) in DOM Level 3:
	function initCompositionEvent(
		typeArg : string/*DOMString*/,
		canBubbleArg : boolean,
		cancelableArg : boolean,
		viewArg : Nullable.<AbstractView>,
		dataArg : Nullable.<string>/*DOMString?*/,
		localeArg : string/*DOMString*/
	) : void;

} // end of CompositionEvent

/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
native final class MutationEvent extends Event {

	// attrChangeType
	static __readonly__ var MODIFICATION : number/*unsigned short*/;
	       __readonly__ var MODIFICATION : number/*unsigned short*/;
	static __readonly__ var ADDITION : number/*unsigned short*/;
	       __readonly__ var ADDITION : number/*unsigned short*/;
	static __readonly__ var REMOVAL : number/*unsigned short*/;
	       __readonly__ var REMOVAL : number/*unsigned short*/;
	__readonly__ var relatedNode : Nullable.<Node>;
	__readonly__ var prevValue : string/*DOMString*/;
	__readonly__ var newValue : string/*DOMString*/;
	__readonly__ var attrName : string/*DOMString*/;
	__readonly__ var attrChange : number/*unsigned short*/;
	function initMutationEvent(
		typeArg : string/*DOMString*/,
		canBubbleArg : boolean,
		cancelableArg : boolean,
		relatedNodeArg : Nullable.<Node>,
		prevValueArg : string/*DOMString*/,
		newValueArg : string/*DOMString*/,
		attrNameArg : string/*DOMString*/,
		attrChangeArg : number/*unsigned short*/
	) : void;

} // end of MutationEvent

native class UIEventInit extends EventInit {

	// Attributes from Event:
	// inherits var bubbles : boolean;
	// inherits var cancelable : boolean;
	// Attributes for UIEvent:
	/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
	var view : Nullable.<AbstractView>;
	/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
	var detail : number/*long*/;

} // end of UIEventInit

/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
native final class FocusEventInit {

	// Attributes from Event:
	var bubbles : boolean;
	var cancelable : boolean;
	// Attributes from UIEvent:
	var view : Nullable.<AbstractView>;
	var detail : number/*long*/;
	// Attributes for FocusEvent:
	var relatedTarget : Nullable.<EventTarget>;

} // end of FocusEventInit

/** @see http://www.w3.org/TR/2dcontext/ */
native final class MouseEventInit extends UIEventInit {

	// Attributes from Event:
	// inherits var bubbles : boolean;
	// inherits var cancelable : boolean;
	// Attributes from UIEvent:
	// inherits var view : Nullable.<AbstractView>;
	// inherits var detail : number/*long*/;
	// Attributes for MouseEvent:
	/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
	var screenX : number/*long*/;
	/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
	var screenY : number/*long*/;
	/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
	var clientX : number/*long*/;
	/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
	var clientY : number/*long*/;
	/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
	var ctrlKey : boolean;
	/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
	var shiftKey : boolean;
	/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
	var altKey : boolean;
	/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
	var metaKey : boolean;
	/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
	var button : number/*unsigned short*/;
	// Note: "buttons" was not previously initializable through initMouseEvent!
	/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
	var buttons : number/*unsigned short*/;
	/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
	var relatedTarget : Nullable.<EventTarget>;


	var region : Nullable.<string>/*DOMString?*/;

} // end of MouseEventInit

/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
native final class WheelEventInit {

	// Attributes from Event:
	var bubbles : boolean;
	var cancelable : boolean;
	// Attributes from UIEvent:
	var view : Nullable.<AbstractView>;
	var detail : number/*long*/;
	// Attributes from MouseEvent:
	var screenX : number/*long*/;
	var screenY : number/*long*/;
	var clientX : number/*long*/;
	var clientY : number/*long*/;
	var ctrlKey : boolean;
	var shiftKey : boolean;
	var altKey : boolean;
	var metaKey : boolean;
	var button : number/*unsigned short*/;
	// Note: "buttons" was not previously initializable through initMouseEvent!
	var buttons : number/*unsigned short*/;
	var relatedTarget : Nullable.<EventTarget>;
	// Attributes for WheelEvent:
	var deltaX : number/*double*/;
	var deltaY : number/*double*/;
	var deltaZ : number/*double*/;
	var deltaMode : number/*unsigned long*/;

} // end of WheelEventInit

/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
native final class KeyboardEventInit {

	// Attributes from Event:
	var bubbles : boolean;
	var cancelable : boolean;
	// Attributes from UIEvent:
	var view : Nullable.<AbstractView>;
	var detail : number/*long*/;
	// Attributes for KeyboardEvent:
	var char : string/*DOMString*/;
	var key : string/*DOMString*/;
	var location : number/*unsigned long*/;
	var ctrlKey : boolean;
	var shiftKey : boolean;
	var altKey : boolean;
	var metaKey : boolean;
	var repeat : boolean;
	var locale : string/*DOMString*/;
	// (Legacy) key attributes for KeyboardEvent:
	var charCode : number/*unsigned long*/;
	var keyCode : number/*unsigned long*/;
	var which : number/*unsigned long*/;

} // end of KeyboardEventInit

/** @see http://www.w3.org/TR/DOM-Level-3-Events/ */
native final class CompositionEventInit {

	// Attributes from Event:
	var bubbles : boolean;
	var cancelable : boolean;
	// Attributes from UIEvent:
	var view : Nullable.<AbstractView>;
	var detail : number/*long*/;
	// Attributes for CompositionEvent:
	var data : Nullable.<string>/*DOMString?*/;
	var locale : string/*DOMString*/;

} // end of CompositionEventInit

/** @see http://www.w3.org/TR/progress-events/ */
native final class ProgressEvent extends Event {

	function constructor(type : string/*DOMString*/);
	function constructor(
		type : string/*DOMString*/,
		eventInitDict : ProgressEventInit
	);

	__readonly__ var lengthComputable : boolean;
	__readonly__ var loaded : number/*unsigned long long*/;
	__readonly__ var total : number/*unsigned long long*/;

} // end of ProgressEvent

/** @see http://www.w3.org/TR/DOM-Parsing/ */
native final class DOMParser {

	function constructor();

	function parseFromString(
		str : string/*DOMString*/,
		type : string/*SupportedType*/
	) : Document;

} // end of DOMParser

/** @see http://www.w3.org/TR/DOM-Parsing/ */
native final class XMLSerializer {

	function constructor();

	function serializeToString(root : Node) : string/*DOMString*/;

} // end of XMLSerializer

native final class ProgressEventInit extends EventInit {

	var lengthComputable : boolean;
	var loaded : number/*unsigned long long*/;
	var total : number/*unsigned long long*/;

} // end of ProgressEventInit

/** @see http://www.w3.org/TR/XMLHttpRequest/ */
native __fake__ class XMLHttpRequestEventTarget extends EventTarget {

	// event handlers
	var onloadstart : Nullable.<function(:Event):void>/*EventHandler*/;
	var onprogress : Nullable.<function(:Event):void>/*EventHandler*/;
	var onabort : Nullable.<function(:Event):void>/*EventHandler*/;
	var onerror : Nullable.<function(:Event):void>/*EventHandler*/;
	var onload : Nullable.<function(:Event):void>/*EventHandler*/;
	var ontimeout : Nullable.<function(:Event):void>/*EventHandler*/;
	var onloadend : Nullable.<function(:Event):void>/*EventHandler*/;

} // end of XMLHttpRequestEventTarget

/** @see http://www.w3.org/TR/XMLHttpRequest/ */
native final class XMLHttpRequestUpload extends XMLHttpRequestEventTarget {
}

/** @see http://www.w3.org/TR/XMLHttpRequest/ */
native final class XMLHttpRequestOptions {

	var anon : boolean;

} // end of XMLHttpRequestOptions

/** @see http://www.w3.org/TR/XMLHttpRequest/ */
native final class XMLHttpRequest extends XMLHttpRequestEventTarget {

	function constructor();
	function constructor(options : XMLHttpRequestOptions);

	// event handler
	var onreadystatechange : Nullable.<function(:Event):void>/*EventHandler*/;
	// states
	static __readonly__ var UNSENT : number/*unsigned short*/;
	       __readonly__ var UNSENT : number/*unsigned short*/;
	static __readonly__ var OPENED : number/*unsigned short*/;
	       __readonly__ var OPENED : number/*unsigned short*/;
	static __readonly__ var HEADERS_RECEIVED : number/*unsigned short*/;
	       __readonly__ var HEADERS_RECEIVED : number/*unsigned short*/;
	static __readonly__ var LOADING : number/*unsigned short*/;
	       __readonly__ var LOADING : number/*unsigned short*/;
	static __readonly__ var DONE : number/*unsigned short*/;
	       __readonly__ var DONE : number/*unsigned short*/;
	__readonly__ var readyState : number/*unsigned short*/;
	// request
	function open(
		method : string/*ByteString*/,
		url : string/*DOMString*/
	) : void;
	function open(
		method : string/*ByteString*/,
		url : string/*DOMString*/,
		async : boolean
	) : void;
	function open(
		method : string/*ByteString*/,
		url : string/*DOMString*/,
		async : boolean,
		user : Nullable.<string>/*DOMString?*/
	) : void;
	function open(
		method : string/*ByteString*/,
		url : string/*DOMString*/,
		async : boolean,
		user : Nullable.<string>/*DOMString?*/,
		password : Nullable.<string>/*DOMString?*/
	) : void;
	function setRequestHeader(
		header : string/*ByteString*/,
		value : string/*ByteString*/
	) : void;
	var timeout : number/*unsigned long*/;
	var withCredentials : boolean;
	__readonly__ var upload : XMLHttpRequestUpload;
	function send() : void;
	function send(data : ArrayBufferView) : void;
	function send(data : Blob) : void;
	function send(data : Document) : void;
	function send(data : string/*DOMString*/) : void;
	function send(data : FormData) : void;
	function abort() : void;
	// response
	__readonly__ var status : number/*unsigned short*/;
	__readonly__ var statusText : string/*ByteString*/;
	function getResponseHeader(
		header : string/*ByteString*/
	) : Nullable.<string>/*ByteString?*/;
	function getAllResponseHeaders() : string/*ByteString*/;
	function overrideMimeType(mime : string/*DOMString*/) : void;
	var responseType : string/*XMLHttpRequestResponseType*/;
	__readonly__ var response : variant/*any*/;
	__readonly__ var responseText : string/*DOMString*/;
	__readonly__ var responseXML : Nullable.<Document>;

} // end of XMLHttpRequest

/** @see http://www.w3.org/TR/XMLHttpRequest/ */
native final class FormData {

	function constructor();
	function constructor(form : HTMLFormElement);

	function append(name : string/*DOMString*/, value : Blob) : void;
	function append(
		name : string/*DOMString*/,
		value : Blob,
		filename : string/*DOMString*/
	) : void;
	function append(
		name : string/*DOMString*/,
		value : string/*DOMString*/
	) : void;

} // end of FormData

/** @see http://dev.w3.org/csswg/cssom/ */
native final class MediaList {

	function constructor(text : string/*DOMString*/);

	var mediaText : string/*DOMString*/;
	__readonly__ var length : number/*unsigned long*/;
	function item(
		index : number/*unsigned long*/
	) : string/*DOMString*/;
	function appendMedium(medium : string/*DOMString*/) : void;
	function deleteMedium(medium : string/*DOMString*/) : void;

} // end of MediaList

/** @see http://dev.w3.org/csswg/cssom/ */
native class StyleSheet {

	__readonly__ var type : string/*DOMString*/;
	__readonly__ var href : Nullable.<string>/*DOMString?*/;
	__readonly__ var ownerNode : Node;
	__readonly__ var parentStyleSheet : Nullable.<StyleSheet>;
	__readonly__ var title : Nullable.<string>/*DOMString?*/;
	__readonly__ var media : MediaList;
	var disabled : boolean;

} // end of StyleSheet

/** @see http://dev.w3.org/csswg/cssom/ */
native final class CSSStyleSheet extends StyleSheet {

	__readonly__ var ownerRule : Nullable.<CSSRule>;
	__readonly__ var cssRules : CSSRuleList;
	function insertRule(
		rule : string/*DOMString*/,
		index : number/*unsigned long*/
	) : number/*unsigned long*/;
	function deleteRule(index : number/*unsigned long*/) : void;

} // end of CSSStyleSheet

/** @see http://dev.w3.org/csswg/cssom/ */
native __fake__ class LinkStyle {

	__readonly__ var sheet : StyleSheet;

} // end of LinkStyle

/** @see http://dev.w3.org/csswg/cssom/ */
native class CSSRule {

	static __readonly__ var STYLE_RULE : number/*unsigned short*/;
	       __readonly__ var STYLE_RULE : number/*unsigned short*/;
	static __readonly__ var CHARSET_RULE : number/*unsigned short*/;
	       __readonly__ var CHARSET_RULE : number/*unsigned short*/;
	static __readonly__ var IMPORT_RULE : number/*unsigned short*/;
	       __readonly__ var IMPORT_RULE : number/*unsigned short*/;
	static __readonly__ var MEDIA_RULE : number/*unsigned short*/;
	       __readonly__ var MEDIA_RULE : number/*unsigned short*/;
	static __readonly__ var FONT_FACE_RULE : number/*unsigned short*/;
	       __readonly__ var FONT_FACE_RULE : number/*unsigned short*/;
	static __readonly__ var PAGE_RULE : number/*unsigned short*/;
	       __readonly__ var PAGE_RULE : number/*unsigned short*/;
	static __readonly__ var NAMESPACE_RULE : number/*unsigned short*/;
	       __readonly__ var NAMESPACE_RULE : number/*unsigned short*/;
	__readonly__ var type : number/*unsigned short*/;
	var cssText : string/*DOMString*/;
	__readonly__ var parentRule : Nullable.<CSSRule>;
	__readonly__ var parentStyleSheet : Nullable.<CSSStyleSheet>;

} // end of CSSRule

/** @see http://dev.w3.org/csswg/cssom/ */
native final class CSSStyleRule extends CSSRule {

	var selectorText : string/*DOMString*/;
	__readonly__ var style : CSSStyleDeclaration;

} // end of CSSStyleRule

/** @see http://dev.w3.org/csswg/cssom/ */
native final class CSSImportRule extends CSSRule {

	__readonly__ var href : string/*DOMString*/;
	__readonly__ var media : MediaList;
	__readonly__ var styleSheet : CSSStyleSheet;

} // end of CSSImportRule

/** @see http://dev.w3.org/csswg/cssom/ */
native final class CSSMediaRule extends CSSRule {

	__readonly__ var media : MediaList;
	__readonly__ var cssRules : CSSRuleList;
	function insertRule(
		rule : string/*DOMString*/,
		index : number/*unsigned long*/
	) : number/*unsigned long*/;
	function deleteRule(index : number/*unsigned long*/) : void;

} // end of CSSMediaRule

/** @see http://dev.w3.org/csswg/cssom/ */
native final class CSSFontFaceRule extends CSSRule {

	__readonly__ var style : CSSStyleDeclaration;

} // end of CSSFontFaceRule

/** @see http://dev.w3.org/csswg/cssom/ */
native final class CSSPageRule extends CSSRule {

	var selectorText : string/*DOMString*/;
	__readonly__ var style : CSSStyleDeclaration;

} // end of CSSPageRule

/** @see http://dev.w3.org/csswg/cssom/ */
native final class CSSNamespaceRule extends CSSRule {

	__readonly__ var namespaceURI : string/*DOMString*/;
	__readonly__ var prefix : Nullable.<string>/*DOMString?*/;

} // end of CSSNamespaceRule

/** @see http://dev.w3.org/csswg/cssom/ */
native final class CSSStyleDeclaration {

	var cssText : string/*DOMString*/;
	__readonly__ var length : number/*unsigned long*/;
	function item(
		index : number/*unsigned long*/
	) : string/*DOMString*/;
	function getPropertyValue(
		property : string/*DOMString*/
	) : string/*DOMString*/;
	function getPropertyPriority(
		property : string/*DOMString*/
	) : string/*DOMString*/;
	function setProperty(
		property : string/*DOMString*/,
		value : string/*DOMString*/
	) : void;
	function setProperty(
		property : string/*DOMString*/,
		value : string/*DOMString*/,
		priority : string/*DOMString*/
	) : void;
	function removeProperty(
		property : string/*DOMString*/
	) : string/*DOMString*/;
	__readonly__ var parentRule : Nullable.<CSSRule>;

	var alignmentBaseline : Nullable.<string>;
	var background : Nullable.<string>;
	var backgroundAttachment : Nullable.<string>;
	var backgroundClip : Nullable.<string>;
	var backgroundColor : Nullable.<string>;
	var backgroundImage : Nullable.<string>;
	var backgroundOrigin : Nullable.<string>;
	var backgroundPosition : Nullable.<string>;
	var backgroundPositionX : Nullable.<string>;
	var backgroundPositionY : Nullable.<string>;
	var backgroundRepeat : Nullable.<string>;
	var backgroundRepeatX : Nullable.<string>;
	var backgroundRepeatY : Nullable.<string>;
	var backgroundSize : Nullable.<string>;
	var baselineShift : Nullable.<string>;
	var border : Nullable.<string>;
	var borderBottom : Nullable.<string>;
	var borderBottomColor : Nullable.<string>;
	var borderBottomLeftRadius : Nullable.<string>;
	var borderBottomRightRadius : Nullable.<string>;
	var borderBottomStyle : Nullable.<string>;
	var borderBottomWidth : Nullable.<string>;
	var borderCollapse : Nullable.<string>;
	var borderColor : Nullable.<string>;
	var borderImage : Nullable.<string>;
	var borderImageOutset : Nullable.<string>;
	var borderImageRepeat : Nullable.<string>;
	var borderImageSlice : Nullable.<string>;
	var borderImageSource : Nullable.<string>;
	var borderImageWidth : Nullable.<string>;
	var borderLeft : Nullable.<string>;
	var borderLeftColor : Nullable.<string>;
	var borderLeftStyle : Nullable.<string>;
	var borderLeftWidth : Nullable.<string>;
	var borderRadius : Nullable.<string>;
	var borderRight : Nullable.<string>;
	var borderRightColor : Nullable.<string>;
	var borderRightStyle : Nullable.<string>;
	var borderRightWidth : Nullable.<string>;
	var borderSpacing : Nullable.<string>;
	var borderStyle : Nullable.<string>;
	var borderTop : Nullable.<string>;
	var borderTopColor : Nullable.<string>;
	var borderTopLeftRadius : Nullable.<string>;
	var borderTopRightRadius : Nullable.<string>;
	var borderTopStyle : Nullable.<string>;
	var borderTopWidth : Nullable.<string>;
	var borderWidth : Nullable.<string>;
	var bottom : Nullable.<string>;
	var boxShadow : Nullable.<string>;
	var boxSizing : Nullable.<string>;
	var captionSide : Nullable.<string>;
	var clear : Nullable.<string>;
	var clip : Nullable.<string>;
	var clipPath : Nullable.<string>;
	var clipRule : Nullable.<string>;
	var color : Nullable.<string>;
	var colorInterpolation : Nullable.<string>;
	var colorInterpolationFilters : Nullable.<string>;
	var colorProfile : Nullable.<string>;
	var colorRendering : Nullable.<string>;
	var content : Nullable.<string>;
	var counterIncrement : Nullable.<string>;
	var counterReset : Nullable.<string>;
	var cursor : Nullable.<string>;
	var direction : Nullable.<string>;
	var display : Nullable.<string>;
	var dominantBaseline : Nullable.<string>;
	var emptyCells : Nullable.<string>;
	var enableBackground : Nullable.<string>;
	var fill : Nullable.<string>;
	var fillOpacity : Nullable.<string>;
	var fillRule : Nullable.<string>;
	var filter : Nullable.<string>;
	var float : Nullable.<string>;
	var floodColor : Nullable.<string>;
	var floodOpacity : Nullable.<string>;
	var font : Nullable.<string>;
	var fontFamily : Nullable.<string>;
	var fontSize : Nullable.<string>;
	var fontStretch : Nullable.<string>;
	var fontStyle : Nullable.<string>;
	var fontVariant : Nullable.<string>;
	var fontWeight : Nullable.<string>;
	var glyphOrientationHorizontal : Nullable.<string>;
	var glyphOrientationVertical : Nullable.<string>;
	var height : Nullable.<string>;
	var imageRendering : Nullable.<string>;
	var kerning : Nullable.<string>;
	var left : Nullable.<string>;
	var letterSpacing : Nullable.<string>;
	var lightingColor : Nullable.<string>;
	var lineHeight : Nullable.<string>;
	var listStyle : Nullable.<string>;
	var listStyleImage : Nullable.<string>;
	var listStylePosition : Nullable.<string>;
	var listStyleType : Nullable.<string>;
	var margin : Nullable.<string>;
	var marginBottom : Nullable.<string>;
	var marginLeft : Nullable.<string>;
	var marginRight : Nullable.<string>;
	var marginTop : Nullable.<string>;
	var marker : Nullable.<string>;
	var markerEnd : Nullable.<string>;
	var markerMid : Nullable.<string>;
	var markerStart : Nullable.<string>;
	var mask : Nullable.<string>;
	var maxHeight : Nullable.<string>;
	var maxWidth : Nullable.<string>;
	var minHeight : Nullable.<string>;
	var minWidth : Nullable.<string>;
	var opacity : Nullable.<string>;
	var orphans : Nullable.<string>;
	var outline : Nullable.<string>;
	var outlineColor : Nullable.<string>;
	var outlineOffset : Nullable.<string>;
	var outlineStyle : Nullable.<string>;
	var outlineWidth : Nullable.<string>;
	var overflow : Nullable.<string>;
	var overflowWrap : Nullable.<string>;
	var overflowX : Nullable.<string>;
	var overflowY : Nullable.<string>;
	var padding : Nullable.<string>;
	var paddingBottom : Nullable.<string>;
	var paddingLeft : Nullable.<string>;
	var paddingRight : Nullable.<string>;
	var paddingTop : Nullable.<string>;
	var page : Nullable.<string>;
	var pageBreakAfter : Nullable.<string>;
	var pageBreakBefore : Nullable.<string>;
	var pageBreakInside : Nullable.<string>;
	var pointerEvents : Nullable.<string>;
	var position : Nullable.<string>;
	var quotes : Nullable.<string>;
	var resize : Nullable.<string>;
	var right : Nullable.<string>;
	var shapeRendering : Nullable.<string>;
	var size : Nullable.<string>;
	var speak : Nullable.<string>;
	var src : Nullable.<string>;
	var stopColor : Nullable.<string>;
	var stopOpacity : Nullable.<string>;
	var stroke : Nullable.<string>;
	var strokeDasharray : Nullable.<string>;
	var strokeDashoffset : Nullable.<string>;
	var strokeLinecap : Nullable.<string>;
	var strokeLinejoin : Nullable.<string>;
	var strokeMiterlimit : Nullable.<string>;
	var strokeOpacity : Nullable.<string>;
	var strokeWidth : Nullable.<string>;
	var tabSize : Nullable.<string>;
	var tableLayout : Nullable.<string>;
	var textAlign : Nullable.<string>;
	var textAnchor : Nullable.<string>;
	var textDecoration : Nullable.<string>;
	var textIndent : Nullable.<string>;
	var textLineThrough : Nullable.<string>;
	var textLineThroughColor : Nullable.<string>;
	var textLineThroughMode : Nullable.<string>;
	var textLineThroughStyle : Nullable.<string>;
	var textLineThroughWidth : Nullable.<string>;
	var textOverflow : Nullable.<string>;
	var textOverline : Nullable.<string>;
	var textOverlineColor : Nullable.<string>;
	var textOverlineMode : Nullable.<string>;
	var textOverlineStyle : Nullable.<string>;
	var textOverlineWidth : Nullable.<string>;
	var textRendering : Nullable.<string>;
	var textShadow : Nullable.<string>;
	var textTransform : Nullable.<string>;
	var textUnderline : Nullable.<string>;
	var textUnderlineColor : Nullable.<string>;
	var textUnderlineMode : Nullable.<string>;
	var textUnderlineStyle : Nullable.<string>;
	var textUnderlineWidth : Nullable.<string>;
	var top : Nullable.<string>;
	var unicodeBidi : Nullable.<string>;
	var unicodeRange : Nullable.<string>;
	var vectorEffect : Nullable.<string>;
	var verticalAlign : Nullable.<string>;
	var visibility : Nullable.<string>;
	var webkitAlignContent : Nullable.<string>;
	var webkitAlignItems : Nullable.<string>;
	var webkitAlignSelf : Nullable.<string>;
	var webkitAnimation : Nullable.<string>;
	var webkitAnimationDelay : Nullable.<string>;
	var webkitAnimationDirection : Nullable.<string>;
	var webkitAnimationDuration : Nullable.<string>;
	var webkitAnimationFillMode : Nullable.<string>;
	var webkitAnimationIterationCount : Nullable.<string>;
	var webkitAnimationName : Nullable.<string>;
	var webkitAnimationPlayState : Nullable.<string>;
	var webkitAnimationTimingFunction : Nullable.<string>;
	var webkitAppearance : Nullable.<string>;
	var webkitAspectRatio : Nullable.<string>;
	var webkitBackfaceVisibility : Nullable.<string>;
	var webkitBackgroundClip : Nullable.<string>;
	var webkitBackgroundComposite : Nullable.<string>;
	var webkitBackgroundOrigin : Nullable.<string>;
	var webkitBackgroundSize : Nullable.<string>;
	var webkitBorderAfter : Nullable.<string>;
	var webkitBorderAfterColor : Nullable.<string>;
	var webkitBorderAfterStyle : Nullable.<string>;
	var webkitBorderAfterWidth : Nullable.<string>;
	var webkitBorderBefore : Nullable.<string>;
	var webkitBorderBeforeColor : Nullable.<string>;
	var webkitBorderBeforeStyle : Nullable.<string>;
	var webkitBorderBeforeWidth : Nullable.<string>;
	var webkitBorderEnd : Nullable.<string>;
	var webkitBorderEndColor : Nullable.<string>;
	var webkitBorderEndStyle : Nullable.<string>;
	var webkitBorderEndWidth : Nullable.<string>;
	var webkitBorderFit : Nullable.<string>;
	var webkitBorderHorizontalSpacing : Nullable.<string>;
	var webkitBorderImage : Nullable.<string>;
	var webkitBorderRadius : Nullable.<string>;
	var webkitBorderStart : Nullable.<string>;
	var webkitBorderStartColor : Nullable.<string>;
	var webkitBorderStartStyle : Nullable.<string>;
	var webkitBorderStartWidth : Nullable.<string>;
	var webkitBorderVerticalSpacing : Nullable.<string>;
	var webkitBoxAlign : Nullable.<string>;
	var webkitBoxDecorationBreak : Nullable.<string>;
	var webkitBoxDirection : Nullable.<string>;
	var webkitBoxFlex : Nullable.<string>;
	var webkitBoxFlexGroup : Nullable.<string>;
	var webkitBoxLines : Nullable.<string>;
	var webkitBoxOrdinalGroup : Nullable.<string>;
	var webkitBoxOrient : Nullable.<string>;
	var webkitBoxPack : Nullable.<string>;
	var webkitBoxReflect : Nullable.<string>;
	var webkitBoxShadow : Nullable.<string>;
	var webkitClipPath : Nullable.<string>;
	var webkitColorCorrection : Nullable.<string>;
	var webkitColumnAxis : Nullable.<string>;
	var webkitColumnBreakAfter : Nullable.<string>;
	var webkitColumnBreakBefore : Nullable.<string>;
	var webkitColumnBreakInside : Nullable.<string>;
	var webkitColumnCount : Nullable.<string>;
	var webkitColumnGap : Nullable.<string>;
	var webkitColumnProgression : Nullable.<string>;
	var webkitColumnRule : Nullable.<string>;
	var webkitColumnRuleColor : Nullable.<string>;
	var webkitColumnRuleStyle : Nullable.<string>;
	var webkitColumnRuleWidth : Nullable.<string>;
	var webkitColumnSpan : Nullable.<string>;
	var webkitColumnWidth : Nullable.<string>;
	var webkitColumns : Nullable.<string>;
	var webkitFilter : Nullable.<string>;
	var webkitFlex : Nullable.<string>;
	var webkitFlexBasis : Nullable.<string>;
	var webkitFlexDirection : Nullable.<string>;
	var webkitFlexFlow : Nullable.<string>;
	var webkitFlexGrow : Nullable.<string>;
	var webkitFlexShrink : Nullable.<string>;
	var webkitFlexWrap : Nullable.<string>;
	var webkitFlowFrom : Nullable.<string>;
	var webkitFlowInto : Nullable.<string>;
	var webkitFontFeatureSettings : Nullable.<string>;
	var webkitFontKerning : Nullable.<string>;
	var webkitFontSizeDelta : Nullable.<string>;
	var webkitFontSmoothing : Nullable.<string>;
	var webkitFontVariantLigatures : Nullable.<string>;
	var webkitGridColumn : Nullable.<string>;
	var webkitGridColumns : Nullable.<string>;
	var webkitGridRow : Nullable.<string>;
	var webkitGridRows : Nullable.<string>;
	var webkitHighlight : Nullable.<string>;
	var webkitHyphenateCharacter : Nullable.<string>;
	var webkitHyphenateLimitAfter : Nullable.<string>;
	var webkitHyphenateLimitBefore : Nullable.<string>;
	var webkitHyphenateLimitLines : Nullable.<string>;
	var webkitHyphens : Nullable.<string>;
	var webkitJustifyContent : Nullable.<string>;
	var webkitLineAlign : Nullable.<string>;
	var webkitLineBoxContain : Nullable.<string>;
	var webkitLineBreak : Nullable.<string>;
	var webkitLineClamp : Nullable.<string>;
	var webkitLineGrid : Nullable.<string>;
	var webkitLineSnap : Nullable.<string>;
	var webkitLocale : Nullable.<string>;
	var webkitLogicalHeight : Nullable.<string>;
	var webkitLogicalWidth : Nullable.<string>;
	var webkitMarginAfter : Nullable.<string>;
	var webkitMarginAfterCollapse : Nullable.<string>;
	var webkitMarginBefore : Nullable.<string>;
	var webkitMarginBeforeCollapse : Nullable.<string>;
	var webkitMarginBottomCollapse : Nullable.<string>;
	var webkitMarginCollapse : Nullable.<string>;
	var webkitMarginEnd : Nullable.<string>;
	var webkitMarginStart : Nullable.<string>;
	var webkitMarginTopCollapse : Nullable.<string>;
	var webkitMarquee : Nullable.<string>;
	var webkitMarqueeDirection : Nullable.<string>;
	var webkitMarqueeIncrement : Nullable.<string>;
	var webkitMarqueeRepetition : Nullable.<string>;
	var webkitMarqueeSpeed : Nullable.<string>;
	var webkitMarqueeStyle : Nullable.<string>;
	var webkitMask : Nullable.<string>;
	var webkitMaskAttachment : Nullable.<string>;
	var webkitMaskBoxImage : Nullable.<string>;
	var webkitMaskBoxImageOutset : Nullable.<string>;
	var webkitMaskBoxImageRepeat : Nullable.<string>;
	var webkitMaskBoxImageSlice : Nullable.<string>;
	var webkitMaskBoxImageSource : Nullable.<string>;
	var webkitMaskBoxImageWidth : Nullable.<string>;
	var webkitMaskClip : Nullable.<string>;
	var webkitMaskComposite : Nullable.<string>;
	var webkitMaskImage : Nullable.<string>;
	var webkitMaskOrigin : Nullable.<string>;
	var webkitMaskPosition : Nullable.<string>;
	var webkitMaskPositionX : Nullable.<string>;
	var webkitMaskPositionY : Nullable.<string>;
	var webkitMaskRepeat : Nullable.<string>;
	var webkitMaskRepeatX : Nullable.<string>;
	var webkitMaskRepeatY : Nullable.<string>;
	var webkitMaskSize : Nullable.<string>;
	var webkitMaxLogicalHeight : Nullable.<string>;
	var webkitMaxLogicalWidth : Nullable.<string>;
	var webkitMinLogicalHeight : Nullable.<string>;
	var webkitMinLogicalWidth : Nullable.<string>;
	var webkitNbspMode : Nullable.<string>;
	var webkitOrder : Nullable.<string>;
	var webkitPaddingAfter : Nullable.<string>;
	var webkitPaddingBefore : Nullable.<string>;
	var webkitPaddingEnd : Nullable.<string>;
	var webkitPaddingStart : Nullable.<string>;
	var webkitPerspective : Nullable.<string>;
	var webkitPerspectiveOrigin : Nullable.<string>;
	var webkitPerspectiveOriginX : Nullable.<string>;
	var webkitPerspectiveOriginY : Nullable.<string>;
	var webkitPrintColorAdjust : Nullable.<string>;
	var webkitRegionBreakAfter : Nullable.<string>;
	var webkitRegionBreakBefore : Nullable.<string>;
	var webkitRegionBreakInside : Nullable.<string>;
	var webkitRegionOverflow : Nullable.<string>;
	var webkitRtlOrdering : Nullable.<string>;
	var webkitShapeInside : Nullable.<string>;
	var webkitShapeOutside : Nullable.<string>;
	var webkitSvgShadow : Nullable.<string>;
	var webkitTapHighlightColor : Nullable.<string>;
	var webkitTextCombine : Nullable.<string>;
	var webkitTextDecorationsInEffect : Nullable.<string>;
	var webkitTextEmphasis : Nullable.<string>;
	var webkitTextEmphasisColor : Nullable.<string>;
	var webkitTextEmphasisPosition : Nullable.<string>;
	var webkitTextEmphasisStyle : Nullable.<string>;
	var webkitTextFillColor : Nullable.<string>;
	var webkitTextOrientation : Nullable.<string>;
	var webkitTextSecurity : Nullable.<string>;
	var webkitTextSizeAdjust : Nullable.<string>;
	var webkitTextStroke : Nullable.<string>;
	var webkitTextStrokeColor : Nullable.<string>;
	var webkitTextStrokeWidth : Nullable.<string>;
	var webkitTransform : Nullable.<string>;
	var webkitTransformOrigin : Nullable.<string>;
	var webkitTransformOriginX : Nullable.<string>;
	var webkitTransformOriginY : Nullable.<string>;
	var webkitTransformOriginZ : Nullable.<string>;
	var webkitTransformStyle : Nullable.<string>;
	var webkitTransition : Nullable.<string>;
	var webkitTransitionDelay : Nullable.<string>;
	var webkitTransitionDuration : Nullable.<string>;
	var webkitTransitionProperty : Nullable.<string>;
	var webkitTransitionTimingFunction : Nullable.<string>;
	var webkitUserDrag : Nullable.<string>;
	var webkitUserModify : Nullable.<string>;
	var webkitUserSelect : Nullable.<string>;
	var webkitWidgetRegion : Nullable.<string>;
	var webkitWrap : Nullable.<string>;
	var webkitWrapFlow : Nullable.<string>;
	var webkitWrapMargin : Nullable.<string>;
	var webkitWrapPadding : Nullable.<string>;
	var webkitWrapThrough : Nullable.<string>;
	var webkitWritingMode : Nullable.<string>;
	var whiteSpace : Nullable.<string>;
	var widows : Nullable.<string>;
	var width : Nullable.<string>;
	var wordBreak : Nullable.<string>;
	var wordSpacing : Nullable.<string>;
	var wordWrap : Nullable.<string>;
	var writingMode : Nullable.<string>;
	var zIndex : Nullable.<string>;
	var zoom : Nullable.<string>;

	var MozAnimation : Nullable.<string>;
	var MozAnimationDelay : Nullable.<string>;
	var MozAnimationDirection : Nullable.<string>;
	var MozAnimationDuration : Nullable.<string>;
	var MozAnimationFillMode : Nullable.<string>;
	var MozAnimationIterationCount : Nullable.<string>;
	var MozAnimationName : Nullable.<string>;
	var MozAnimationPlayState : Nullable.<string>;
	var MozAnimationTimingFunction : Nullable.<string>;
	var MozAppearance : Nullable.<string>;
	var MozBackfaceVisibility : Nullable.<string>;
	var MozBackgroundInlinePolicy : Nullable.<string>;
	var MozBinding : Nullable.<string>;
	var MozBorderBottomColors : Nullable.<string>;
	var MozBorderEnd : Nullable.<string>;
	var MozBorderEndColor : Nullable.<string>;
	var MozBorderEndStyle : Nullable.<string>;
	var MozBorderEndWidth : Nullable.<string>;
	var MozBorderImage : Nullable.<string>;
	var MozBorderLeftColors : Nullable.<string>;
	var MozBorderRightColors : Nullable.<string>;
	var MozBorderStart : Nullable.<string>;
	var MozBorderStartColor : Nullable.<string>;
	var MozBorderStartStyle : Nullable.<string>;
	var MozBorderStartWidth : Nullable.<string>;
	var MozBorderTopColors : Nullable.<string>;
	var MozBoxAlign : Nullable.<string>;
	var MozBoxDirection : Nullable.<string>;
	var MozBoxFlex : Nullable.<string>;
	var MozBoxOrdinalGroup : Nullable.<string>;
	var MozBoxOrient : Nullable.<string>;
	var MozBoxPack : Nullable.<string>;
	var MozBoxSizing : Nullable.<string>;
	var MozColumnCount : Nullable.<string>;
	var MozColumnGap : Nullable.<string>;
	var MozColumnRule : Nullable.<string>;
	var MozColumnRuleColor : Nullable.<string>;
	var MozColumnRuleStyle : Nullable.<string>;
	var MozColumnRuleWidth : Nullable.<string>;
	var MozColumnWidth : Nullable.<string>;
	var MozColumns : Nullable.<string>;
	var MozFloatEdge : Nullable.<string>;
	var MozFontFeatureSettings : Nullable.<string>;
	var MozFontLanguageOverride : Nullable.<string>;
	var MozForceBrokenImageIcon : Nullable.<string>;
	var MozHyphens : Nullable.<string>;
	var MozImageRegion : Nullable.<string>;
	var MozMarginEnd : Nullable.<string>;
	var MozMarginStart : Nullable.<string>;
	var MozOrient : Nullable.<string>;
	var MozOutlineRadius : Nullable.<string>;
	var MozOutlineRadiusBottomleft : Nullable.<string>;
	var MozOutlineRadiusBottomright : Nullable.<string>;
	var MozOutlineRadiusTopleft : Nullable.<string>;
	var MozOutlineRadiusTopright : Nullable.<string>;
	var MozPaddingEnd : Nullable.<string>;
	var MozPaddingStart : Nullable.<string>;
	var MozPerspective : Nullable.<string>;
	var MozPerspectiveOrigin : Nullable.<string>;
	var MozStackSizing : Nullable.<string>;
	var MozTabSize : Nullable.<string>;
	var MozTextAlignLast : Nullable.<string>;
	var MozTextBlink : Nullable.<string>;
	var MozTextDecorationColor : Nullable.<string>;
	var MozTextDecorationLine : Nullable.<string>;
	var MozTextDecorationStyle : Nullable.<string>;
	var MozTextSizeAdjust : Nullable.<string>;
	var MozTransform : Nullable.<string>;
	var MozTransformOrigin : Nullable.<string>;
	var MozTransformStyle : Nullable.<string>;
	var MozTransition : Nullable.<string>;
	var MozTransitionDelay : Nullable.<string>;
	var MozTransitionDuration : Nullable.<string>;
	var MozTransitionProperty : Nullable.<string>;
	var MozTransitionTimingFunction : Nullable.<string>;
	var MozUserFocus : Nullable.<string>;
	var MozUserInput : Nullable.<string>;
	var MozUserModify : Nullable.<string>;
	var MozUserSelect : Nullable.<string>;
	var MozWindowShadow : Nullable.<string>;
	var animation : Nullable.<string>;
	var animationDelay : Nullable.<string>;
	var animationDirection : Nullable.<string>;
	var animationDuration : Nullable.<string>;
	var animationFillMode : Nullable.<string>;
	var animationIterationCount : Nullable.<string>;
	var animationName : Nullable.<string>;
	var animationPlayState : Nullable.<string>;
	var animationTimingFunction : Nullable.<string>;
	var backfaceVisibility : Nullable.<string>;
	var cssFloat : Nullable.<string>;
	var fontSizeAdjust : Nullable.<string>;
	var imeMode : Nullable.<string>;
	var markerOffset : Nullable.<string>;
	var marks : Nullable.<string>;
	var perspective : Nullable.<string>;
	var perspectiveOrigin : Nullable.<string>;
	var transform : Nullable.<string>;
	var transformOrigin : Nullable.<string>;
	var transformStyle : Nullable.<string>;
	var transition : Nullable.<string>;
	var transitionDelay : Nullable.<string>;
	var transitionDuration : Nullable.<string>;
	var transitionProperty : Nullable.<string>;
	var transitionTimingFunction : Nullable.<string>;

	var webkitOverflowScrolling : string/*DOMString*/;

} // end of CSSStyleDeclaration

/** @see http://dev.w3.org/csswg/cssom/ */
native final __fake__ class ElementCSSInlineStyle {

	__readonly__ var style : CSSStyleDeclaration;

} // end of ElementCSSInlineStyle

/** @see http://www.w3.org/TR/html5/single-page.html */
native final __fake__ class Window extends EventTarget {

	/** @see http://dev.w3.org/csswg/cssom/ */
	function getComputedStyle(elt : Element) : CSSStyleDeclaration;
	/** @see http://dev.w3.org/csswg/cssom/ */
	function getComputedStyle(
		elt : Element,
		pseudoElt : string/*DOMString*/
	) : CSSStyleDeclaration;

	/** @see http://dev.w3.org/csswg/cssom-view/ */
	function matchMedia(query : string/*DOMString*/) : MediaQueryList;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var screen : Screen;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var innerWidth : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var innerHeight : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var scrollX : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var pageXOffset : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var scrollY : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var pageYOffset : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	function scroll(x : number/*long*/, y : number/*long*/) : void;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	function scrollTo(x : number/*long*/, y : number/*long*/) : void;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	function scrollBy(x : number/*long*/, y : number/*long*/) : void;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var screenX : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var screenY : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var outerWidth : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var outerHeight : number/*long*/;

	// the current browsing context
	__readonly__ var window : Window/*WindowProxy*/;
	__readonly__ var self : Window/*WindowProxy*/;
	__readonly__ var document : HTMLDocument/*Document*/;
	var name : string/*DOMString*/;
	__readonly__ var location : Location;
	__readonly__ var history : History;
	__readonly__ var locationbar : BarProp;
	__readonly__ var menubar : BarProp;
	__readonly__ var personalbar : BarProp;
	__readonly__ var scrollbars : BarProp;
	__readonly__ var statusbar : BarProp;
	__readonly__ var toolbar : BarProp;
	var status : string/*DOMString*/;
	function close() : void;
	function stop() : void;
	function focus() : void;
	function blur() : void;
	// other browsing contexts
	__readonly__ var frames : Window/*WindowProxy*/;
	__readonly__ var length : number/*unsigned long*/;
	__readonly__ var top : Window/*WindowProxy*/;
	var opener : Nullable.<Window>/*WindowProxy?*/;
	__readonly__ var parent : Window/*WindowProxy*/;
	__readonly__ var frameElement : Nullable.<Element>;
	function open() : Window/*WindowProxy*/;
	function open(url : string/*DOMString*/) : Window/*WindowProxy*/;
	function open(
		url : string/*DOMString*/,
		target : string/*DOMString*/
	) : Window/*WindowProxy*/;
	function open(
		url : string/*DOMString*/,
		target : string/*DOMString*/,
		features : string/*DOMString*/
	) : Window/*WindowProxy*/;
	function open(
		url : string/*DOMString*/,
		target : string/*DOMString*/,
		features : string/*DOMString*/,
		replace : boolean
	) : Window/*WindowProxy*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<Window>/*WindowProxy*/;
	function __native_index_operator__(
		name : string/*DOMString*/
	) : Nullable.<Object>/*object*/;
	// the user agent
	__readonly__ var navigator : Navigator;
	__readonly__ var external : External;
	__readonly__ var applicationCache : ApplicationCache;
	// user prompts
	function alert(message : string/*DOMString*/) : void;
	function confirm(message : string/*DOMString*/) : boolean;
	function prompt(
		message : string/*DOMString*/
	) : Nullable.<string>/*DOMString?*/;
	function prompt(
		message : string/*DOMString*/,
		default : string/*DOMString*/
	) : Nullable.<string>/*DOMString?*/;
	function print() : void;
	function showModalDialog(
		url : string/*DOMString*/
	) : variant/*any*/;
	function showModalDialog(
		url : string/*DOMString*/,
		argument : variant/*any*/
	) : variant/*any*/;
	// event handler IDL attributes
	var onabort : Nullable.<function(:Event):void>/*EventHandler*/;
	var onafterprint : Nullable.<function(:Event):void>/*EventHandler*/;
	var onbeforeprint : Nullable.<function(:Event):void>/*EventHandler*/;
	var onbeforeunload : Nullable.<function(:Event):void>/*EventHandler*/;
	var onblur : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncancel : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncanplay : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncanplaythrough : Nullable.<function(:Event):void>/*EventHandler*/;
	var onchange : Nullable.<function(:Event):void>/*EventHandler*/;
	var onclick : Nullable.<function(:Event):void>/*EventHandler*/;
	var onclose : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncontextmenu : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncuechange : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondblclick : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondrag : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondragend : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondragenter : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondragleave : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondragover : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondragstart : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondrop : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondurationchange : Nullable.<function(:Event):void>/*EventHandler*/;
	var onemptied : Nullable.<function(:Event):void>/*EventHandler*/;
	var onended : Nullable.<function(:Event):void>/*EventHandler*/;
	var onerror : Nullable.<function(:Event):void>/*OnErrorEventHandler*/;
	var onfocus : Nullable.<function(:Event):void>/*EventHandler*/;
	var onhashchange : Nullable.<function(:Event):void>/*EventHandler*/;
	var oninput : Nullable.<function(:Event):void>/*EventHandler*/;
	var oninvalid : Nullable.<function(:Event):void>/*EventHandler*/;
	var onkeydown : Nullable.<function(:Event):void>/*EventHandler*/;
	var onkeypress : Nullable.<function(:Event):void>/*EventHandler*/;
	var onkeyup : Nullable.<function(:Event):void>/*EventHandler*/;
	var onload : Nullable.<function(:Event):void>/*EventHandler*/;
	var onloadeddata : Nullable.<function(:Event):void>/*EventHandler*/;
	var onloadedmetadata : Nullable.<function(:Event):void>/*EventHandler*/;
	var onloadstart : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmessage : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmousedown : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmousemove : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmouseout : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmouseover : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmouseup : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmousewheel : Nullable.<function(:Event):void>/*EventHandler*/;
	var onoffline : Nullable.<function(:Event):void>/*EventHandler*/;
	var ononline : Nullable.<function(:Event):void>/*EventHandler*/;
	var onpause : Nullable.<function(:Event):void>/*EventHandler*/;
	var onplay : Nullable.<function(:Event):void>/*EventHandler*/;
	var onplaying : Nullable.<function(:Event):void>/*EventHandler*/;
	var onpagehide : Nullable.<function(:Event):void>/*EventHandler*/;
	var onpageshow : Nullable.<function(:Event):void>/*EventHandler*/;
	var onpopstate : Nullable.<function(:Event):void>/*EventHandler*/;
	var onprogress : Nullable.<function(:Event):void>/*EventHandler*/;
	var onratechange : Nullable.<function(:Event):void>/*EventHandler*/;
	var onreset : Nullable.<function(:Event):void>/*EventHandler*/;
	var onresize : Nullable.<function(:Event):void>/*EventHandler*/;
	var onscroll : Nullable.<function(:Event):void>/*EventHandler*/;
	var onseeked : Nullable.<function(:Event):void>/*EventHandler*/;
	var onseeking : Nullable.<function(:Event):void>/*EventHandler*/;
	var onselect : Nullable.<function(:Event):void>/*EventHandler*/;
	var onshow : Nullable.<function(:Event):void>/*EventHandler*/;
	var onstalled : Nullable.<function(:Event):void>/*EventHandler*/;
	var onstorage : Nullable.<function(:Event):void>/*EventHandler*/;
	var onsubmit : Nullable.<function(:Event):void>/*EventHandler*/;
	var onsuspend : Nullable.<function(:Event):void>/*EventHandler*/;
	var ontimeupdate : Nullable.<function(:Event):void>/*EventHandler*/;
	var onunload : Nullable.<function(:Event):void>/*EventHandler*/;
	var onvolumechange : Nullable.<function(:Event):void>/*EventHandler*/;
	var onwaiting : Nullable.<function(:Event):void>/*EventHandler*/;

	// implements WindowBase64

	function btoa(btoa : string/*DOMString*/) : string/*DOMString*/;
	function atob(atob : string/*DOMString*/) : string/*DOMString*/;

	// implements WindowSessionStorage

	/** @see http://dev.w3.org/html5/webstorage/ */
	__readonly__ var sessionStorage : Storage;

	// implements WindowLocalStorage

	/** @see http://dev.w3.org/html5/webstorage/ */
	__readonly__ var localStorage : Storage;

	// implements IDBEnvironment

	/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
	__readonly__ var indexedDB : IDBFactory;

	// implements IntentProvider

	/** @see http://www.w3.org/TR/2012/WD-web-intents-20120626/ */
	__readonly__ var intent : Intent;

	function setTimeout(
		handler : function():void/*TimerHandler*/
	) : number/*long*/;
	function setTimeout(
		handler : function():void/*TimerHandler*/,
		timeout : number/*long*/
	) : number/*long*/;
	function clearTimeout(handle : number/*long*/) : void;
	function setInterval(
		handler : function():void/*TimerHandler*/
	) : number/*long*/;
	function setInterval(
		handler : function():void/*TimerHandler*/,
		timeout : number/*long*/
	) : number/*long*/;
	function clearInterval(handle : number/*long*/) : void;

	function postMessage(
		message : variant/*any*/,
		targetOrigin : string/*DOMString*/
	) : void;
	function postMessage(
		message : variant/*any*/,
		targetOrigin : string/*DOMString*/,
		transfer : Transferable[]
	) : void;

	// implements WindowAnimationTiming

	function requestAnimationFrame(
		callback : function(time:number/*DOMTimeStamp*/):void/*FrameRequestCallback*/
	) : number/*long*/;
	function cancelAnimationFrame(handle : number/*long*/) : void;
	// vender's extension
	function webkitRequestAnimationFrame(
		callback : function(time:number/*DOMTimeStamp*/):void/*FrameRequestCallback*/
	) : number/*long*/;
	function webkitCancelAnimationFrame(handle : number/*long*/) : void;
	function mozRequestAnimationFrame(
		callback : function(time:number/*DOMTimeStamp*/):void/*FrameRequestCallback*/
	) : number/*long*/;
	function mozCancelAnimationFrame(handle : number/*long*/) : void;

} // end of Window

/** @see http://dev.w3.org/csswg/cssom-view/ */
native final class MediaQueryList {

	__readonly__ var media : string/*DOMString*/;
	__readonly__ var matches : boolean;
	function addListener(
		listener : function(:MediaQueryList):void/*MediaQueryListListener*/
	) : void;
	function removeListener(
		listener : function(:MediaQueryList):void/*MediaQueryListListener*/
	) : void;

} // end of MediaQueryList

/** @see http://dev.w3.org/csswg/cssom-view/ */
native final class MediaQueryListListener {

	function handleChange(list : MediaQueryList) : void;

} // end of MediaQueryListListener

/** @see http://dev.w3.org/csswg/cssom-view/ */
native final class Screen {

	__readonly__ var availWidth : number/*unsigned long*/;
	__readonly__ var availHeight : number/*unsigned long*/;
	__readonly__ var width : number/*unsigned long*/;
	__readonly__ var height : number/*unsigned long*/;
	__readonly__ var colorDepth : number/*unsigned long*/;
	__readonly__ var pixelDepth : number/*unsigned long*/;

} // end of Screen

/** @see http://dev.w3.org/csswg/cssom-view/ */
native final class CaretPosition {

	__readonly__ var offsetNode : Node;
	__readonly__ var offset : number/*unsigned long*/;

} // end of CaretPosition

/** @see http://www.w3.org/TR/html5/single-page.html */
native class HTMLElement extends Element {

	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var offsetParent : Element;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var offsetTop : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var offsetLeft : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var offsetWidth : number/*long*/;
	/** @see http://dev.w3.org/csswg/cssom-view/ */
	__readonly__ var offsetHeight : number/*long*/;

	// metadata attributes
	var title : string/*DOMString*/;
	var lang : string/*DOMString*/;
	var translate : boolean;
	var dir : string/*DOMString*/;
	__readonly__ var dataset : DOMStringMap;
	// user interaction
	var hidden : boolean;
	function click() : void;
	var tabIndex : number/*long*/;
	function focus() : void;
	function blur() : void;
	var accessKey : string/*DOMString*/;
	__readonly__ var accessKeyLabel : string/*DOMString*/;
	var draggable : boolean;
	__readonly__ var dropzone : DOMSettableTokenList;
	var contentEditable : string/*DOMString*/;
	__readonly__ var isContentEditable : boolean;
	var contextMenu : Nullable.<HTMLMenuElement>;
	var spellcheck : boolean;
	// command API
	__readonly__ var commandType : Nullable.<string>/*DOMString?*/;
	__readonly__ var commandLabel : Nullable.<string>/*DOMString?*/;
	__readonly__ var commandIcon : Nullable.<string>/*DOMString?*/;
	__readonly__ var commandHidden : Nullable.<boolean>;
	__readonly__ var commandDisabled : Nullable.<boolean>;
	__readonly__ var commandChecked : Nullable.<boolean>;
	// styling
	__readonly__ var style : CSSStyleDeclaration;
	// event handler IDL attributes
	var onabort : Nullable.<function(:Event):void>/*EventHandler*/;
	var onblur : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncancel : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncanplay : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncanplaythrough : Nullable.<function(:Event):void>/*EventHandler*/;
	var onchange : Nullable.<function(:Event):void>/*EventHandler*/;
	var onclick : Nullable.<function(:Event):void>/*EventHandler*/;
	var onclose : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncontextmenu : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncuechange : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondblclick : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondrag : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondragend : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondragenter : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondragleave : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondragover : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondragstart : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondrop : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondurationchange : Nullable.<function(:Event):void>/*EventHandler*/;
	var onemptied : Nullable.<function(:Event):void>/*EventHandler*/;
	var onended : Nullable.<function(:Event):void>/*EventHandler*/;
	var onerror : Nullable.<function(:Event):void>/*OnErrorEventHandler*/;
	var onfocus : Nullable.<function(:Event):void>/*EventHandler*/;
	var oninput : Nullable.<function(:Event):void>/*EventHandler*/;
	var oninvalid : Nullable.<function(:Event):void>/*EventHandler*/;
	var onkeydown : Nullable.<function(:Event):void>/*EventHandler*/;
	var onkeypress : Nullable.<function(:Event):void>/*EventHandler*/;
	var onkeyup : Nullable.<function(:Event):void>/*EventHandler*/;
	var onload : Nullable.<function(:Event):void>/*EventHandler*/;
	var onloadeddata : Nullable.<function(:Event):void>/*EventHandler*/;
	var onloadedmetadata : Nullable.<function(:Event):void>/*EventHandler*/;
	var onloadstart : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmousedown : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmousemove : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmouseout : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmouseover : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmouseup : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmousewheel : Nullable.<function(:Event):void>/*EventHandler*/;
	var onpause : Nullable.<function(:Event):void>/*EventHandler*/;
	var onplay : Nullable.<function(:Event):void>/*EventHandler*/;
	var onplaying : Nullable.<function(:Event):void>/*EventHandler*/;
	var onprogress : Nullable.<function(:Event):void>/*EventHandler*/;
	var onratechange : Nullable.<function(:Event):void>/*EventHandler*/;
	var onreset : Nullable.<function(:Event):void>/*EventHandler*/;
	var onscroll : Nullable.<function(:Event):void>/*EventHandler*/;
	var onseeked : Nullable.<function(:Event):void>/*EventHandler*/;
	var onseeking : Nullable.<function(:Event):void>/*EventHandler*/;
	var onselect : Nullable.<function(:Event):void>/*EventHandler*/;
	var onshow : Nullable.<function(:Event):void>/*EventHandler*/;
	var onstalled : Nullable.<function(:Event):void>/*EventHandler*/;
	var onsubmit : Nullable.<function(:Event):void>/*EventHandler*/;
	var onsuspend : Nullable.<function(:Event):void>/*EventHandler*/;
	var ontimeupdate : Nullable.<function(:Event):void>/*EventHandler*/;
	var onvolumechange : Nullable.<function(:Event):void>/*EventHandler*/;
	var onwaiting : Nullable.<function(:Event):void>/*EventHandler*/;

} // end of HTMLElement

/** @see http://dev.w3.org/csswg/cssom-view/ */
native final class ClientRectList {

	__readonly__ var length : number/*unsigned long*/;
	function item(index : number/*unsigned long*/) : ClientRect;

} // end of ClientRectList

/** @see http://dev.w3.org/csswg/cssom-view/ */
native final class ClientRect {

	__readonly__ var top : number/*float*/;
	__readonly__ var right : number/*float*/;
	__readonly__ var bottom : number/*float*/;
	__readonly__ var left : number/*float*/;
	__readonly__ var width : number/*float*/;
	__readonly__ var height : number/*float*/;

} // end of ClientRect

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLAllCollection extends HTMLCollection {

	// inherits length and item()
	// inherits function __native_index_operator__(name : string/*DOMString*/) : Nullable.<Object>/*object?*/;
	/* legacycaller getter */
	// inherits function namedItem(name : string/*DOMString*/) : Nullable.<Object>/*object?*/;
	// overrides inherited namedItem()
	function tags(tagName : string/*DOMString*/) : HTMLAllCollection;

} // end of HTMLAllCollection

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLFormControlsCollection extends HTMLCollection {

	// inherits length and item()
	// inherits function __native_index_operator__(name : string/*DOMString*/) : Nullable.<Object>/*object?*/;
	/* legacycaller getter */
	// inherits function namedItem(name : string/*DOMString*/) : Nullable.<Object>/*object?*/;
	// overrides inherited namedItem()

} // end of HTMLFormControlsCollection

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class RadioNodeList extends NodeList {

	var value : string/*DOMString*/;

} // end of RadioNodeList

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLOptionsCollection extends HTMLCollection {

	// inherits item()
	// inherits var length : number/*unsigned long*/;
	// overrides inherited length
	// inherits function __native_index_operator__(name : string/*DOMString*/) : Nullable.<Object>/*object?*/;
	/* legacycaller getter */
	// inherits function namedItem(name : string/*DOMString*/) : Nullable.<Object>/*object?*/;
	// overrides inherited namedItem()
	function add(element : HTMLOptionElement) : void;
	function add(
		element : HTMLOptionElement,
		before : HTMLElement
	) : void;
	function add(
		element : HTMLOptionElement,
		before : number/*long*/
	) : void;
	function add(element : HTMLOptGroupElement) : void;
	function add(
		element : HTMLOptGroupElement,
		before : HTMLElement
	) : void;
	function add(
		element : HTMLOptGroupElement,
		before : number/*long*/
	) : void;
	function remove(index : number/*long*/) : void;
	var selectedIndex : number/*long*/;

} // end of HTMLOptionsCollection

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class DOMStringMap {

	function __native_index_operator__(
		name : string/*DOMString*/
	) : Nullable.<string>/*DOMString*/;

} // end of DOMStringMap

/** @see http://www.w3.org/TR/html5/single-page.html */
native __fake__ class Transferable {
}

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLDocument extends Document {

	// resource metadata management
	__readonly__ var location : Nullable.<Location>;
	var domain : string/*DOMString*/;
	__readonly__ var referrer : string/*DOMString*/;
	var cookie : string/*DOMString*/;
	__readonly__ var lastModified : string/*DOMString*/;
	__readonly__ var readyState : string/*DOMString*/;
	// DOM tree accessors
	function __native_index_operator__(
		name : string/*DOMString*/
	) : Nullable.<Object>/*object*/;
	var title : string/*DOMString*/;
	var dir : string/*DOMString*/;
	var body : Nullable.<HTMLElement>;
	__readonly__ var head : Nullable.<HTMLHeadElement>;
	__readonly__ var images : HTMLCollection;
	__readonly__ var embeds : HTMLCollection;
	__readonly__ var plugins : HTMLCollection;
	__readonly__ var links : HTMLCollection;
	__readonly__ var forms : HTMLCollection;
	__readonly__ var scripts : HTMLCollection;
	function getElementsByName(
		elementName : string/*DOMString*/
	) : NodeList;
	// dynamic markup insertion
	function open() : HTMLDocument/*Document*/;
	function open(
		type : string/*DOMString*/
	) : HTMLDocument/*Document*/;
	function open(
		type : string/*DOMString*/,
		replace : string/*DOMString*/
	) : HTMLDocument/*Document*/;
	function open(
		url : string/*DOMString*/,
		name : string/*DOMString*/,
		features : string/*DOMString*/
	) : Window/*WindowProxy*/;
	function open(
		url : string/*DOMString*/,
		name : string/*DOMString*/,
		features : string/*DOMString*/,
		replace : boolean
	) : Window/*WindowProxy*/;
	function close() : void;
	function write(...text : string/*DOMString...*/) : void;
	function writeln(...text : string/*DOMString...*/) : void;
	// user interaction
	__readonly__ var defaultView : Nullable.<Window>/*WindowProxy?*/;
	__readonly__ var activeElement : Nullable.<Element>;
	function hasFocus() : boolean;
	var designMode : string/*DOMString*/;
	function execCommand(commandId : string/*DOMString*/) : boolean;
	function execCommand(
		commandId : string/*DOMString*/,
		showUI : boolean
	) : boolean;
	function execCommand(
		commandId : string/*DOMString*/,
		showUI : boolean,
		value : string/*DOMString*/
	) : boolean;
	function queryCommandEnabled(
		commandId : string/*DOMString*/
	) : boolean;
	function queryCommandIndeterm(
		commandId : string/*DOMString*/
	) : boolean;
	function queryCommandState(
		commandId : string/*DOMString*/
	) : boolean;
	function queryCommandSupported(
		commandId : string/*DOMString*/
	) : boolean;
	function queryCommandValue(
		commandId : string/*DOMString*/
	) : string/*DOMString*/;
	__readonly__ var commands : HTMLCollection;
	// event handler IDL attributes
	var onabort : Nullable.<function(:Event):void>/*EventHandler*/;
	var onblur : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncancel : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncanplay : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncanplaythrough : Nullable.<function(:Event):void>/*EventHandler*/;
	var onchange : Nullable.<function(:Event):void>/*EventHandler*/;
	var onclick : Nullable.<function(:Event):void>/*EventHandler*/;
	var onclose : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncontextmenu : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncuechange : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondblclick : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondrag : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondragend : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondragenter : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondragleave : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondragover : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondragstart : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondrop : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondurationchange : Nullable.<function(:Event):void>/*EventHandler*/;
	var onemptied : Nullable.<function(:Event):void>/*EventHandler*/;
	var onended : Nullable.<function(:Event):void>/*EventHandler*/;
	var onerror : Nullable.<function(:Event):void>/*OnErrorEventHandler*/;
	var onfocus : Nullable.<function(:Event):void>/*EventHandler*/;
	var oninput : Nullable.<function(:Event):void>/*EventHandler*/;
	var oninvalid : Nullable.<function(:Event):void>/*EventHandler*/;
	var onkeydown : Nullable.<function(:Event):void>/*EventHandler*/;
	var onkeypress : Nullable.<function(:Event):void>/*EventHandler*/;
	var onkeyup : Nullable.<function(:Event):void>/*EventHandler*/;
	var onload : Nullable.<function(:Event):void>/*EventHandler*/;
	var onloadeddata : Nullable.<function(:Event):void>/*EventHandler*/;
	var onloadedmetadata : Nullable.<function(:Event):void>/*EventHandler*/;
	var onloadstart : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmousedown : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmousemove : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmouseout : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmouseover : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmouseup : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmousewheel : Nullable.<function(:Event):void>/*EventHandler*/;
	var onpause : Nullable.<function(:Event):void>/*EventHandler*/;
	var onplay : Nullable.<function(:Event):void>/*EventHandler*/;
	var onplaying : Nullable.<function(:Event):void>/*EventHandler*/;
	var onprogress : Nullable.<function(:Event):void>/*EventHandler*/;
	var onratechange : Nullable.<function(:Event):void>/*EventHandler*/;
	var onreset : Nullable.<function(:Event):void>/*EventHandler*/;
	var onscroll : Nullable.<function(:Event):void>/*EventHandler*/;
	var onseeked : Nullable.<function(:Event):void>/*EventHandler*/;
	var onseeking : Nullable.<function(:Event):void>/*EventHandler*/;
	var onselect : Nullable.<function(:Event):void>/*EventHandler*/;
	var onshow : Nullable.<function(:Event):void>/*EventHandler*/;
	var onstalled : Nullable.<function(:Event):void>/*EventHandler*/;
	var onsubmit : Nullable.<function(:Event):void>/*EventHandler*/;
	var onsuspend : Nullable.<function(:Event):void>/*EventHandler*/;
	var ontimeupdate : Nullable.<function(:Event):void>/*EventHandler*/;
	var onvolumechange : Nullable.<function(:Event):void>/*EventHandler*/;
	var onwaiting : Nullable.<function(:Event):void>/*EventHandler*/;
	// special event handler IDL attributes that only apply to Document objects
	var onreadystatechange : Nullable.<function(:Event):void>/*EventHandler*/;

	var fgColor : string/*DOMString*/;
	var linkColor : string/*DOMString*/;
	var vlinkColor : string/*DOMString*/;
	var alinkColor : string/*DOMString*/;
	var bgColor : string/*DOMString*/;
	__readonly__ var anchors : HTMLCollection;
	__readonly__ var applets : HTMLCollection;
	function clear() : void;
	__readonly__ var all : HTMLAllCollection;

} // end of HTMLDocument

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLUnknownElement extends HTMLElement {
}

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLHtmlElement extends HTMLElement {

	var version : string/*DOMString*/;

} // end of HTMLHtmlElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLHeadElement extends HTMLElement {
}

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLTitleElement extends HTMLElement {

	var text : string/*DOMString*/;

} // end of HTMLTitleElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLBaseElement extends HTMLElement {

	var href : string/*DOMString*/;
	var target : string/*DOMString*/;

} // end of HTMLBaseElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLLinkElement extends HTMLElement {

	var disabled : boolean;
	var href : string/*DOMString*/;
	var rel : string/*DOMString*/;
	__readonly__ var relList : DOMTokenList;
	var media : string/*DOMString*/;
	var hreflang : string/*DOMString*/;
	var type : string/*DOMString*/;
	__readonly__ var sizes : DOMSettableTokenList;

	var charset : string/*DOMString*/;
	var rev : string/*DOMString*/;
	var target : string/*DOMString*/;

	// implements LinkStyle

	/** @see http://dev.w3.org/csswg/cssom/ */
	__readonly__ var sheet : StyleSheet;

} // end of HTMLLinkElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLMetaElement extends HTMLElement {

	var name : string/*DOMString*/;
	var httpEquiv : string/*DOMString*/;
	var content : string/*DOMString*/;

	var scheme : string/*DOMString*/;

} // end of HTMLMetaElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLStyleElement extends HTMLElement {

	var disabled : boolean;
	var media : string/*DOMString*/;
	var type : string/*DOMString*/;
	var scoped : boolean;

	// implements LinkStyle

	/** @see http://dev.w3.org/csswg/cssom/ */
	__readonly__ var sheet : StyleSheet;

} // end of HTMLStyleElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLScriptElement extends HTMLElement {

	var src : string/*DOMString*/;
	var async : boolean;
	var defer : boolean;
	var type : string/*DOMString*/;
	var charset : string/*DOMString*/;
	var text : string/*DOMString*/;

	var event : string/*DOMString*/;
	var htmlFor : string/*DOMString*/;

} // end of HTMLScriptElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLBodyElement extends HTMLElement {

	var onafterprint : Nullable.<function(:Event):void>/*EventHandler*/;
	var onbeforeprint : Nullable.<function(:Event):void>/*EventHandler*/;
	var onbeforeunload : Nullable.<function(:Event):void>/*EventHandler*/;
	// inherits var onblur : Nullable.<function(:Event):void>/*EventHandler*/;
	// inherits var onerror : Nullable.<function(:Event):void>/*OnErrorEventHandler*/;
	// inherits var onfocus : Nullable.<function(:Event):void>/*EventHandler*/;
	var onhashchange : Nullable.<function(:Event):void>/*EventHandler*/;
	// inherits var onload : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmessage : Nullable.<function(:Event):void>/*EventHandler*/;
	var onoffline : Nullable.<function(:Event):void>/*EventHandler*/;
	var ononline : Nullable.<function(:Event):void>/*EventHandler*/;
	var onpopstate : Nullable.<function(:Event):void>/*EventHandler*/;
	var onpagehide : Nullable.<function(:Event):void>/*EventHandler*/;
	var onpageshow : Nullable.<function(:Event):void>/*EventHandler*/;
	var onresize : Nullable.<function(:Event):void>/*EventHandler*/;
	// inherits var onscroll : Nullable.<function(:Event):void>/*EventHandler*/;
	var onstorage : Nullable.<function(:Event):void>/*EventHandler*/;
	var onunload : Nullable.<function(:Event):void>/*EventHandler*/;

	var text : string/*DOMString*/;
	var link : string/*DOMString*/;
	var vLink : string/*DOMString*/;
	var aLink : string/*DOMString*/;
	var bgColor : string/*DOMString*/;
	var background : string/*DOMString*/;

} // end of HTMLBodyElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLHeadingElement extends HTMLElement {

	var align : string/*DOMString*/;

} // end of HTMLHeadingElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLParagraphElement extends HTMLElement {

	var align : string/*DOMString*/;

} // end of HTMLParagraphElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLHRElement extends HTMLElement {

	var align : string/*DOMString*/;
	var color : string/*DOMString*/;
	var noShade : boolean;
	var size : string/*DOMString*/;
	var width : string/*DOMString*/;

} // end of HTMLHRElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLPreElement extends HTMLElement {

	var width : number/*long*/;

} // end of HTMLPreElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLQuoteElement extends HTMLElement {

	var cite : string/*DOMString*/;

} // end of HTMLQuoteElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLOListElement extends HTMLElement {

	var reversed : boolean;
	var start : number/*long*/;
	var type : string/*DOMString*/;

	var compact : boolean;

} // end of HTMLOListElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLUListElement extends HTMLElement {

	var compact : boolean;
	var type : string/*DOMString*/;

} // end of HTMLUListElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLLIElement extends HTMLElement {

	var value : number/*long*/;

	var type : string/*DOMString*/;

} // end of HTMLLIElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLDListElement extends HTMLElement {

	var compact : boolean;

} // end of HTMLDListElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLDivElement extends HTMLElement {

	var align : string/*DOMString*/;

} // end of HTMLDivElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLAnchorElement extends HTMLElement {

	var href : string/*DOMString*/;
	var target : string/*DOMString*/;
	var rel : string/*DOMString*/;
	__readonly__ var relList : DOMTokenList;
	var media : string/*DOMString*/;
	var hreflang : string/*DOMString*/;
	var type : string/*DOMString*/;
	var text : string/*DOMString*/;
	// URL decomposition IDL attributes
	var protocol : string/*DOMString*/;
	var host : string/*DOMString*/;
	var hostname : string/*DOMString*/;
	var port : string/*DOMString*/;
	var pathname : string/*DOMString*/;
	var search : string/*DOMString*/;
	var hash : string/*DOMString*/;

	var coords : string/*DOMString*/;
	var charset : string/*DOMString*/;
	var name : string/*DOMString*/;
	var rev : string/*DOMString*/;
	var shape : string/*DOMString*/;

} // end of HTMLAnchorElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLTimeElement extends HTMLElement {

	var datetime : string/*DOMString*/;

} // end of HTMLTimeElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLSpanElement extends HTMLElement {
}

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLBRElement extends HTMLElement {

	var clear : string/*DOMString*/;

} // end of HTMLBRElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLModElement extends HTMLElement {

	var cite : string/*DOMString*/;
	var dateTime : string/*DOMString*/;

} // end of HTMLModElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLImageElement extends HTMLElement {

	var alt : string/*DOMString*/;
	var src : string/*DOMString*/;
	var crossOrigin : string/*DOMString*/;
	var useMap : string/*DOMString*/;
	var isMap : boolean;
	var width : number/*unsigned long*/;
	var height : number/*unsigned long*/;
	__readonly__ var naturalWidth : number/*unsigned long*/;
	__readonly__ var naturalHeight : number/*unsigned long*/;
	__readonly__ var complete : boolean;

	var name : string/*DOMString*/;
	var align : string/*DOMString*/;
	var hspace : number/*unsigned long*/;
	var vspace : number/*unsigned long*/;
	var longDesc : string/*DOMString*/;
	var border : string/*DOMString*/;

} // end of HTMLImageElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLIFrameElement extends HTMLElement {

	var src : string/*DOMString*/;
	var srcdoc : string/*DOMString*/;
	var name : string/*DOMString*/;
	__readonly__ var sandbox : DOMSettableTokenList;
	var seamless : boolean;
	var width : string/*DOMString*/;
	var height : string/*DOMString*/;
	__readonly__ var contentDocument : Nullable.<HTMLDocument>/*Document?*/;
	__readonly__ var contentWindow : Nullable.<Window>/*WindowProxy?*/;

	var align : string/*DOMString*/;
	var scrolling : string/*DOMString*/;
	var frameBorder : string/*DOMString*/;
	var longDesc : string/*DOMString*/;
	var marginHeight : string/*DOMString*/;
	var marginWidth : string/*DOMString*/;

} // end of HTMLIFrameElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLEmbedElement extends HTMLElement {

	var src : string/*DOMString*/;
	var type : string/*DOMString*/;
	var width : string/*DOMString*/;
	var height : string/*DOMString*/;

	var align : string/*DOMString*/;
	var name : string/*DOMString*/;

} // end of HTMLEmbedElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLObjectElement extends HTMLElement {

	var data : string/*DOMString*/;
	var type : string/*DOMString*/;
	var typeMustMatch : boolean;
	var name : string/*DOMString*/;
	var useMap : string/*DOMString*/;
	__readonly__ var form : Nullable.<HTMLFormElement>;
	var width : string/*DOMString*/;
	var height : string/*DOMString*/;
	__readonly__ var contentDocument : Nullable.<HTMLDocument>/*Document?*/;
	__readonly__ var contentWindow : Nullable.<Window>/*WindowProxy?*/;
	__readonly__ var willValidate : boolean;
	__readonly__ var validity : ValidityState;
	__readonly__ var validationMessage : string/*DOMString*/;
	function checkValidity() : boolean;
	function setCustomValidity(error : string/*DOMString*/) : void;

	var align : string/*DOMString*/;
	var archive : string/*DOMString*/;
	var code : string/*DOMString*/;
	var declare : boolean;
	var hspace : number/*unsigned long*/;
	var standby : string/*DOMString*/;
	var vspace : number/*unsigned long*/;
	var codeBase : string/*DOMString*/;
	var codeType : string/*DOMString*/;
	var border : string/*DOMString*/;

} // end of HTMLObjectElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLParamElement extends HTMLElement {

	var name : string/*DOMString*/;
	var value : string/*DOMString*/;

	var type : string/*DOMString*/;
	var valueType : string/*DOMString*/;

} // end of HTMLParamElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLVideoElement extends HTMLMediaElement {

	var width : number/*unsigned long*/;
	var height : number/*unsigned long*/;
	__readonly__ var videoWidth : number/*unsigned long*/;
	__readonly__ var videoHeight : number/*unsigned long*/;
	var poster : string/*DOMString*/;

} // end of HTMLVideoElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLAudioElement extends HTMLMediaElement {
}

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLSourceElement extends HTMLElement {

	var src : string/*DOMString*/;
	var type : string/*DOMString*/;
	var media : string/*DOMString*/;

} // end of HTMLSourceElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLTrackElement extends HTMLElement {

	var kind : string/*DOMString*/;
	var src : string/*DOMString*/;
	var srclang : string/*DOMString*/;
	var label : string/*DOMString*/;
	var default : boolean;
	static __readonly__ var NONE : number/*unsigned short*/;
	       __readonly__ var NONE : number/*unsigned short*/;
	static __readonly__ var LOADING : number/*unsigned short*/;
	       __readonly__ var LOADING : number/*unsigned short*/;
	static __readonly__ var LOADED : number/*unsigned short*/;
	       __readonly__ var LOADED : number/*unsigned short*/;
	static __readonly__ var ERROR : number/*unsigned short*/;
	       __readonly__ var ERROR : number/*unsigned short*/;
	__readonly__ var readyState : number/*unsigned short*/;
	__readonly__ var track : TextTrack;

} // end of HTMLTrackElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native class HTMLMediaElement extends HTMLElement {

	// error state
	__readonly__ var error : Nullable.<MediaError>;
	// network state
	var src : string/*DOMString*/;
	__readonly__ var currentSrc : string/*DOMString*/;
	var crossOrigin : string/*DOMString*/;
	static __readonly__ var NETWORK_EMPTY : number/*unsigned short*/;
	       __readonly__ var NETWORK_EMPTY : number/*unsigned short*/;
	static __readonly__ var NETWORK_IDLE : number/*unsigned short*/;
	       __readonly__ var NETWORK_IDLE : number/*unsigned short*/;
	static __readonly__ var NETWORK_LOADING : number/*unsigned short*/;
	       __readonly__ var NETWORK_LOADING : number/*unsigned short*/;
	static __readonly__ var NETWORK_NO_SOURCE : number/*unsigned short*/;
	       __readonly__ var NETWORK_NO_SOURCE : number/*unsigned short*/;
	__readonly__ var networkState : number/*unsigned short*/;
	var preload : string/*DOMString*/;
	__readonly__ var buffered : TimeRanges;
	function load() : void;
	function canPlayType(
		type : string/*DOMString*/
	) : string/*DOMString*/;
	// ready state
	static __readonly__ var HAVE_NOTHING : number/*unsigned short*/;
	       __readonly__ var HAVE_NOTHING : number/*unsigned short*/;
	static __readonly__ var HAVE_METADATA : number/*unsigned short*/;
	       __readonly__ var HAVE_METADATA : number/*unsigned short*/;
	static __readonly__ var HAVE_CURRENT_DATA : number/*unsigned short*/;
	       __readonly__ var HAVE_CURRENT_DATA : number/*unsigned short*/;
	static __readonly__ var HAVE_FUTURE_DATA : number/*unsigned short*/;
	       __readonly__ var HAVE_FUTURE_DATA : number/*unsigned short*/;
	static __readonly__ var HAVE_ENOUGH_DATA : number/*unsigned short*/;
	       __readonly__ var HAVE_ENOUGH_DATA : number/*unsigned short*/;
	__readonly__ var readyState : number/*unsigned short*/;
	__readonly__ var seeking : boolean;
	// playback state
	var currentTime : number/*double*/;
	__readonly__ var duration : number/*unrestricted double*/;
	__readonly__ var startDate : Date;
	__readonly__ var paused : boolean;
	var defaultPlaybackRate : number/*double*/;
	var playbackRate : number/*double*/;
	__readonly__ var played : TimeRanges;
	__readonly__ var seekable : TimeRanges;
	__readonly__ var ended : boolean;
	var autoplay : boolean;
	var loop : boolean;
	function play() : void;
	function pause() : void;
	// media controller
	var mediaGroup : string/*DOMString*/;
	var controller : Nullable.<MediaController>;
	// controls
	var controls : boolean;
	var volume : number/*double*/;
	var muted : boolean;
	var defaultMuted : boolean;
	// tracks
	__readonly__ var audioTracks : AudioTrackList;
	__readonly__ var videoTracks : VideoTrackList;
	__readonly__ var textTracks : TextTrackList;
	function addTextTrack(kind : string/*DOMString*/) : TextTrack;
	function addTextTrack(
		kind : string/*DOMString*/,
		label : string/*DOMString*/
	) : TextTrack;
	function addTextTrack(
		kind : string/*DOMString*/,
		label : string/*DOMString*/,
		language : string/*DOMString*/
	) : TextTrack;

} // end of HTMLMediaElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class MediaError {

	static __readonly__ var MEDIA_ERR_ABORTED : number/*unsigned short*/;
	       __readonly__ var MEDIA_ERR_ABORTED : number/*unsigned short*/;
	static __readonly__ var MEDIA_ERR_NETWORK : number/*unsigned short*/;
	       __readonly__ var MEDIA_ERR_NETWORK : number/*unsigned short*/;
	static __readonly__ var MEDIA_ERR_DECODE : number/*unsigned short*/;
	       __readonly__ var MEDIA_ERR_DECODE : number/*unsigned short*/;
	static __readonly__ var MEDIA_ERR_SRC_NOT_SUPPORTED : number/*unsigned short*/;
	       __readonly__ var MEDIA_ERR_SRC_NOT_SUPPORTED : number/*unsigned short*/;
	__readonly__ var code : number/*unsigned short*/;

} // end of MediaError

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class AudioTrackList extends EventTarget {

	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<AudioTrack>;
	function getTrackById(
		id : string/*DOMString*/
	) : Nullable.<AudioTrack>;
	var onchange : Nullable.<function(:Event):void>/*EventHandler*/;
	var onaddtrack : Nullable.<function(:Event):void>/*EventHandler*/;
	var onremovetrack : Nullable.<function(:Event):void>/*EventHandler*/;

} // end of AudioTrackList

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class AudioTrack {

	__readonly__ var id : string/*DOMString*/;
	__readonly__ var kind : string/*DOMString*/;
	__readonly__ var label : string/*DOMString*/;
	__readonly__ var language : string/*DOMString*/;
	var enabled : boolean;

} // end of AudioTrack

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class VideoTrackList extends EventTarget {

	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<VideoTrack>;
	function getTrackById(
		id : string/*DOMString*/
	) : Nullable.<VideoTrack>;
	__readonly__ var selectedIndex : number/*long*/;
	var onchange : Nullable.<function(:Event):void>/*EventHandler*/;
	var onaddtrack : Nullable.<function(:Event):void>/*EventHandler*/;
	var onremovetrack : Nullable.<function(:Event):void>/*EventHandler*/;

} // end of VideoTrackList

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class VideoTrack {

	__readonly__ var id : string/*DOMString*/;
	__readonly__ var kind : string/*DOMString*/;
	__readonly__ var label : string/*DOMString*/;
	__readonly__ var language : string/*DOMString*/;
	var selected : boolean;

} // end of VideoTrack

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class MediaController extends EventTarget {

	function constructor();

	__readonly__ var readyState : number/*unsigned short*/;
	// uses HTMLMediaElement.readyState's values

	__readonly__ var buffered : TimeRanges;
	__readonly__ var seekable : TimeRanges;
	__readonly__ var duration : number/*unrestricted double*/;
	var currentTime : number/*double*/;
	__readonly__ var paused : boolean;
	__readonly__ var playbackState : string/*MediaControllerPlaybackState*/;
	__readonly__ var played : TimeRanges;
	function pause() : void;
	function unpause() : void;
	function play() : void;
	// calls play() on all media elements as well

	var defaultPlaybackRate : number/*double*/;
	var playbackRate : number/*double*/;
	var volume : number/*double*/;
	var muted : boolean;
	var onemptied : Nullable.<function(:Event):void>/*EventHandler*/;
	var onloadedmetadata : Nullable.<function(:Event):void>/*EventHandler*/;
	var onloadeddata : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncanplay : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncanplaythrough : Nullable.<function(:Event):void>/*EventHandler*/;
	var onplaying : Nullable.<function(:Event):void>/*EventHandler*/;
	var onended : Nullable.<function(:Event):void>/*EventHandler*/;
	var onwaiting : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondurationchange : Nullable.<function(:Event):void>/*EventHandler*/;
	var ontimeupdate : Nullable.<function(:Event):void>/*EventHandler*/;
	var onplay : Nullable.<function(:Event):void>/*EventHandler*/;
	var onpause : Nullable.<function(:Event):void>/*EventHandler*/;
	var onratechange : Nullable.<function(:Event):void>/*EventHandler*/;
	var onvolumechange : Nullable.<function(:Event):void>/*EventHandler*/;

} // end of MediaController

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class TextTrackList extends EventTarget {

	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<TextTrack>;
	var onaddtrack : Nullable.<function(:Event):void>/*EventHandler*/;
	var onremovetrack : Nullable.<function(:Event):void>/*EventHandler*/;

} // end of TextTrackList

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class TextTrack extends EventTarget {

	__readonly__ var kind : string/*DOMString*/;
	__readonly__ var label : string/*DOMString*/;
	__readonly__ var language : string/*DOMString*/;
	__readonly__ var inBandMetadataTrackDispatchType : string/*DOMString*/;
	var mode : string/*TextTrackMode*/;
	__readonly__ var cues : Nullable.<TextTrackCueList>;
	__readonly__ var activeCues : Nullable.<TextTrackCueList>;
	function addCue(cue : TextTrackCue) : void;
	function removeCue(cue : TextTrackCue) : void;
	var oncuechange : Nullable.<function(:Event):void>/*EventHandler*/;

} // end of TextTrack

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class TextTrackCueList {

	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<TextTrackCue>;
	function getCueById(
		id : string/*DOMString*/
	) : Nullable.<TextTrackCue>;

} // end of TextTrackCueList

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class TextTrackCue extends EventTarget {

	function constructor(
		startTime : number/*double*/,
		endTime : number/*double*/,
		text : string/*DOMString*/
	);

	__readonly__ var track : Nullable.<TextTrack>;
	var id : string/*DOMString*/;
	var startTime : number/*double*/;
	var endTime : number/*double*/;
	var pauseOnExit : boolean;
	var vertical : string/*DOMString*/;
	var snapToLines : boolean;
	var line : variant/*(long or AutoKeyword)*/;
	var position : number/*long*/;
	var size : number/*long*/;
	var align : string/*DOMString*/;
	var text : string/*DOMString*/;
	function getCueAsHTML() : DocumentFragment;
	var onenter : Nullable.<function(:Event):void>/*EventHandler*/;
	var onexit : Nullable.<function(:Event):void>/*EventHandler*/;

} // end of TextTrackCue

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class TimeRanges {

	__readonly__ var length : number/*unsigned long*/;
	function start(index : number/*unsigned long*/) : number/*double*/;
	function end(index : number/*unsigned long*/) : number/*double*/;

} // end of TimeRanges

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class TrackEvent extends Event {

	function constructor(type : string/*DOMString*/);
	function constructor(
		type : string/*DOMString*/,
		eventInitDict : TrackEventInit
	);

	__readonly__ var track : Nullable.<Object>/*object?*/;

} // end of TrackEvent

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class TrackEventInit extends EventInit {

	var track : Nullable.<Object>/*object?*/;

} // end of TrackEventInit

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLCanvasElement extends HTMLElement {

	var width : number/*unsigned long*/;
	var height : number/*unsigned long*/;
	function toDataURL(
		type : string/*DOMString*/,
		...arguments : variant/*any...*/
	) : string/*DOMString*/;
	function toBlob(
		_callback : Nullable.<function(:File):void>/*FileCallback?*/,
		type : string/*DOMString*/,
		...arguments : variant/*any...*/
	) : void;
	function getContext(
		contextId : string/*DOMString*/,
		...arguments : variant/*any...*/
	) : Nullable.<Object>/*object?*/;

} // end of HTMLCanvasElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLMapElement extends HTMLElement {

	var name : string/*DOMString*/;
	__readonly__ var areas : HTMLCollection;
	__readonly__ var images : HTMLCollection;

} // end of HTMLMapElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLAreaElement extends HTMLElement {

	var alt : string/*DOMString*/;
	var coords : string/*DOMString*/;
	var shape : string/*DOMString*/;
	var href : string/*DOMString*/;
	var target : string/*DOMString*/;
	var rel : string/*DOMString*/;
	__readonly__ var relList : DOMTokenList;
	var media : string/*DOMString*/;
	var hreflang : string/*DOMString*/;
	var type : string/*DOMString*/;
	// URL decomposition IDL attributes
	var protocol : string/*DOMString*/;
	var host : string/*DOMString*/;
	var hostname : string/*DOMString*/;
	var port : string/*DOMString*/;
	var pathname : string/*DOMString*/;
	var search : string/*DOMString*/;
	var hash : string/*DOMString*/;

	var noHref : boolean;

} // end of HTMLAreaElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLTableElement extends HTMLElement {

	var caption : Nullable.<HTMLTableCaptionElement>;
	function createCaption() : HTMLElement;
	function deleteCaption() : void;
	var tHead : Nullable.<HTMLTableSectionElement>;
	function createTHead() : HTMLElement;
	function deleteTHead() : void;
	var tFoot : Nullable.<HTMLTableSectionElement>;
	function createTFoot() : HTMLElement;
	function deleteTFoot() : void;
	__readonly__ var tBodies : HTMLCollection;
	function createTBody() : HTMLElement;
	__readonly__ var rows : HTMLCollection;
	function insertRow() : HTMLElement;
	function insertRow(index : number/*long*/) : HTMLElement;
	function deleteRow(index : number/*long*/) : void;
	var border : string/*DOMString*/;

	var align : string/*DOMString*/;
	var frame : string/*DOMString*/;
	var rules : string/*DOMString*/;
	var summary : string/*DOMString*/;
	var width : string/*DOMString*/;
	var bgColor : string/*DOMString*/;
	var cellPadding : string/*DOMString*/;
	var cellSpacing : string/*DOMString*/;

} // end of HTMLTableElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLTableCaptionElement extends HTMLElement {

	var align : string/*DOMString*/;

} // end of HTMLTableCaptionElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLTableColElement extends HTMLElement {

	var span : number/*unsigned long*/;

	var align : string/*DOMString*/;
	var ch : string/*DOMString*/;
	var chOff : string/*DOMString*/;
	var vAlign : string/*DOMString*/;
	var width : string/*DOMString*/;

} // end of HTMLTableColElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLTableSectionElement extends HTMLElement {

	__readonly__ var rows : HTMLCollection;
	function insertRow() : HTMLElement;
	function insertRow(index : number/*long*/) : HTMLElement;
	function deleteRow(index : number/*long*/) : void;

	var align : string/*DOMString*/;
	var ch : string/*DOMString*/;
	var chOff : string/*DOMString*/;
	var vAlign : string/*DOMString*/;

} // end of HTMLTableSectionElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLTableRowElement extends HTMLElement {

	__readonly__ var rowIndex : number/*long*/;
	__readonly__ var sectionRowIndex : number/*long*/;
	__readonly__ var cells : HTMLCollection;
	function insertCell() : HTMLElement;
	function insertCell(index : number/*long*/) : HTMLElement;
	function deleteCell(index : number/*long*/) : void;

	var align : string/*DOMString*/;
	var ch : string/*DOMString*/;
	var chOff : string/*DOMString*/;
	var vAlign : string/*DOMString*/;
	var bgColor : string/*DOMString*/;

} // end of HTMLTableRowElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLTableDataCellElement extends HTMLTableCellElement {
}

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLTableHeaderCellElement extends HTMLTableCellElement {

	var scope : string/*DOMString*/;
	// inherits var abbr : string/*DOMString*/;

} // end of HTMLTableHeaderCellElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native class HTMLTableCellElement extends HTMLElement {

	var colSpan : number/*unsigned long*/;
	var rowSpan : number/*unsigned long*/;
	__readonly__ var headers : DOMSettableTokenList;
	__readonly__ var cellIndex : number/*long*/;

	var abbr : string/*DOMString*/;
	var align : string/*DOMString*/;
	var axis : string/*DOMString*/;
	var height : string/*DOMString*/;
	var width : string/*DOMString*/;
	var ch : string/*DOMString*/;
	var chOff : string/*DOMString*/;
	var noWrap : boolean;
	var vAlign : string/*DOMString*/;
	var bgColor : string/*DOMString*/;

} // end of HTMLTableCellElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLFormElement extends HTMLElement {

	var acceptCharset : string/*DOMString*/;
	var action : string/*DOMString*/;
	var autocomplete : string/*DOMString*/;
	var enctype : string/*DOMString*/;
	var encoding : string/*DOMString*/;
	var method : string/*DOMString*/;
	var name : string/*DOMString*/;
	var noValidate : boolean;
	var target : string/*DOMString*/;
	__readonly__ var elements : HTMLFormControlsCollection;
	__readonly__ var length : number/*long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<Element>;
	function __native_index_operator__(
		name : string/*DOMString*/
	) : Nullable.<Object>/*object*/;
	function submit() : void;
	function reset() : void;
	function checkValidity() : boolean;

} // end of HTMLFormElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLFieldSetElement extends HTMLElement {

	var disabled : boolean;
	__readonly__ var form : Nullable.<HTMLFormElement>;
	var name : string/*DOMString*/;
	__readonly__ var type : string/*DOMString*/;
	__readonly__ var elements : HTMLFormControlsCollection;
	__readonly__ var willValidate : boolean;
	__readonly__ var validity : ValidityState;
	__readonly__ var validationMessage : string/*DOMString*/;
	function checkValidity() : boolean;
	function setCustomValidity(error : string/*DOMString*/) : void;

} // end of HTMLFieldSetElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLLegendElement extends HTMLElement {

	__readonly__ var form : Nullable.<HTMLFormElement>;

	var align : string/*DOMString*/;

} // end of HTMLLegendElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLLabelElement extends HTMLElement {

	__readonly__ var form : Nullable.<HTMLFormElement>;
	var htmlFor : string/*DOMString*/;
	__readonly__ var control : Nullable.<HTMLElement>;

} // end of HTMLLabelElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLInputElement extends HTMLElement {

	var accept : string/*DOMString*/;
	var alt : string/*DOMString*/;
	var autocomplete : string/*DOMString*/;
	var autofocus : boolean;
	var defaultChecked : boolean;
	var checked : boolean;
	var dirName : string/*DOMString*/;
	var disabled : boolean;
	__readonly__ var form : Nullable.<HTMLFormElement>;
	__readonly__ var files : Nullable.<FileList>;
	var formAction : string/*DOMString*/;
	var formEnctype : string/*DOMString*/;
	var formMethod : string/*DOMString*/;
	var formNoValidate : boolean;
	var formTarget : string/*DOMString*/;
	var height : number/*unsigned long*/;
	var indeterminate : boolean;
	__readonly__ var list : Nullable.<HTMLElement>;
	var max : string/*DOMString*/;
	var maxLength : number/*long*/;
	var min : string/*DOMString*/;
	var multiple : boolean;
	var name : string/*DOMString*/;
	var pattern : string/*DOMString*/;
	var placeholder : string/*DOMString*/;
	var readOnly : boolean;
	var required : boolean;
	var size : number/*unsigned long*/;
	var src : string/*DOMString*/;
	var step : string/*DOMString*/;
	var type : string/*DOMString*/;
	var defaultValue : string/*DOMString*/;
	var value : string/*DOMString*/;
	var valueAsDate : Nullable.<Date>;
	var valueAsNumber : number/*unrestricted double*/;
	var width : number/*unsigned long*/;
	function stepUp() : void;
	function stepUp(n : number/*long*/) : void;
	function stepDown() : void;
	function stepDown(n : number/*long*/) : void;
	__readonly__ var willValidate : boolean;
	__readonly__ var validity : ValidityState;
	__readonly__ var validationMessage : string/*DOMString*/;
	function checkValidity() : boolean;
	function setCustomValidity(error : string/*DOMString*/) : void;
	__readonly__ var labels : NodeList;
	function select() : void;
	var selectionStart : number/*unsigned long*/;
	var selectionEnd : number/*unsigned long*/;
	var selectionDirection : string/*DOMString*/;
	function setSelectionRange(
		start : number/*unsigned long*/,
		end : number/*unsigned long*/
	) : void;
	function setSelectionRange(
		start : number/*unsigned long*/,
		end : number/*unsigned long*/,
		direction : string/*DOMString*/
	) : void;

	var align : string/*DOMString*/;
	var useMap : string/*DOMString*/;

} // end of HTMLInputElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLButtonElement extends HTMLElement {

	var autofocus : boolean;
	var disabled : boolean;
	__readonly__ var form : Nullable.<HTMLFormElement>;
	var formAction : string/*DOMString*/;
	var formEnctype : string/*DOMString*/;
	var formMethod : string/*DOMString*/;
	var formNoValidate : boolean;
	var formTarget : string/*DOMString*/;
	var name : string/*DOMString*/;
	var type : string/*DOMString*/;
	var value : string/*DOMString*/;
	__readonly__ var willValidate : boolean;
	__readonly__ var validity : ValidityState;
	__readonly__ var validationMessage : string/*DOMString*/;
	function checkValidity() : boolean;
	function setCustomValidity(error : string/*DOMString*/) : void;
	__readonly__ var labels : NodeList;

} // end of HTMLButtonElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLSelectElement extends HTMLElement {

	var autofocus : boolean;
	var disabled : boolean;
	__readonly__ var form : Nullable.<HTMLFormElement>;
	var multiple : boolean;
	var name : string/*DOMString*/;
	var required : boolean;
	var size : number/*unsigned long*/;
	__readonly__ var type : string/*DOMString*/;
	__readonly__ var options : HTMLOptionsCollection;
	var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<Element>;
	/* getter */
	function item(index : number/*unsigned long*/) : Nullable.<Element>;
	function namedItem(name : string/*DOMString*/) : Object/*object*/;
	function add(element : HTMLOptionElement) : void;
	function add(
		element : HTMLOptionElement,
		before : HTMLElement
	) : void;
	function add(
		element : HTMLOptionElement,
		before : number/*long*/
	) : void;
	function add(element : HTMLOptGroupElement) : void;
	function add(
		element : HTMLOptGroupElement,
		before : HTMLElement
	) : void;
	function add(
		element : HTMLOptGroupElement,
		before : number/*long*/
	) : void;
	function remove(index : number/*long*/) : void;
	__readonly__ var selectedOptions : HTMLCollection;
	var selectedIndex : number/*long*/;
	var value : string/*DOMString*/;
	__readonly__ var willValidate : boolean;
	__readonly__ var validity : ValidityState;
	__readonly__ var validationMessage : string/*DOMString*/;
	function checkValidity() : boolean;
	function setCustomValidity(error : string/*DOMString*/) : void;
	__readonly__ var labels : NodeList;

} // end of HTMLSelectElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLDataListElement extends HTMLElement {

	__readonly__ var options : HTMLCollection;

} // end of HTMLDataListElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLOptGroupElement extends HTMLElement {

	var disabled : boolean;
	var label : string/*DOMString*/;

} // end of HTMLOptGroupElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLOptionElement extends HTMLElement {

	var disabled : boolean;
	__readonly__ var form : Nullable.<HTMLFormElement>;
	var label : string/*DOMString*/;
	var defaultSelected : boolean;
	var selected : boolean;
	var value : string/*DOMString*/;
	var text : string/*DOMString*/;
	__readonly__ var index : number/*long*/;

} // end of HTMLOptionElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLTextAreaElement extends HTMLElement {

	var autofocus : boolean;
	var cols : number/*unsigned long*/;
	var dirName : string/*DOMString*/;
	var disabled : boolean;
	__readonly__ var form : Nullable.<HTMLFormElement>;
	var maxLength : number/*long*/;
	var name : string/*DOMString*/;
	var placeholder : string/*DOMString*/;
	var readOnly : boolean;
	var required : boolean;
	var rows : number/*unsigned long*/;
	var wrap : string/*DOMString*/;
	__readonly__ var type : string/*DOMString*/;
	var defaultValue : string/*DOMString*/;
	var value : string/*DOMString*/;
	__readonly__ var textLength : number/*unsigned long*/;
	__readonly__ var willValidate : boolean;
	__readonly__ var validity : ValidityState;
	__readonly__ var validationMessage : string/*DOMString*/;
	function checkValidity() : boolean;
	function setCustomValidity(error : string/*DOMString*/) : void;
	__readonly__ var labels : NodeList;
	function select() : void;
	var selectionStart : number/*unsigned long*/;
	var selectionEnd : number/*unsigned long*/;
	var selectionDirection : string/*DOMString*/;
	function setSelectionRange(
		start : number/*unsigned long*/,
		end : number/*unsigned long*/
	) : void;
	function setSelectionRange(
		start : number/*unsigned long*/,
		end : number/*unsigned long*/,
		direction : string/*DOMString*/
	) : void;

} // end of HTMLTextAreaElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLKeygenElement extends HTMLElement {

	var autofocus : boolean;
	var challenge : string/*DOMString*/;
	var disabled : boolean;
	__readonly__ var form : Nullable.<HTMLFormElement>;
	var keytype : string/*DOMString*/;
	var name : string/*DOMString*/;
	__readonly__ var type : string/*DOMString*/;
	__readonly__ var willValidate : boolean;
	__readonly__ var validity : ValidityState;
	__readonly__ var validationMessage : string/*DOMString*/;
	function checkValidity() : boolean;
	function setCustomValidity(error : string/*DOMString*/) : void;
	__readonly__ var labels : NodeList;

} // end of HTMLKeygenElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLOutputElement extends HTMLElement {

	__readonly__ var htmlFor : DOMSettableTokenList;
	__readonly__ var form : Nullable.<HTMLFormElement>;
	var name : string/*DOMString*/;
	__readonly__ var type : string/*DOMString*/;
	var defaultValue : string/*DOMString*/;
	var value : string/*DOMString*/;
	__readonly__ var willValidate : boolean;
	__readonly__ var validity : ValidityState;
	__readonly__ var validationMessage : string/*DOMString*/;
	function checkValidity() : boolean;
	function setCustomValidity(error : string/*DOMString*/) : void;
	__readonly__ var labels : NodeList;

} // end of HTMLOutputElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLProgressElement extends HTMLElement {

	var value : number/*double*/;
	var max : number/*double*/;
	__readonly__ var position : number/*double*/;
	__readonly__ var labels : NodeList;

} // end of HTMLProgressElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLMeterElement extends HTMLElement {

	var value : number/*double*/;
	var min : number/*double*/;
	var max : number/*double*/;
	var low : number/*double*/;
	var high : number/*double*/;
	var optimum : number/*double*/;
	__readonly__ var labels : NodeList;

} // end of HTMLMeterElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class ValidityState {

	__readonly__ var valueMissing : boolean;
	__readonly__ var typeMismatch : boolean;
	__readonly__ var patternMismatch : boolean;
	__readonly__ var tooLong : boolean;
	__readonly__ var rangeUnderflow : boolean;
	__readonly__ var rangeOverflow : boolean;
	__readonly__ var stepMismatch : boolean;
	__readonly__ var customError : boolean;
	__readonly__ var valid : boolean;

} // end of ValidityState

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLDetailsElement extends HTMLElement {

	var open : boolean;

} // end of HTMLDetailsElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLCommandElement extends HTMLElement {

	var type : string/*DOMString*/;
	var label : string/*DOMString*/;
	var icon : string/*DOMString*/;
	var disabled : boolean;
	var checked : boolean;
	var radiogroup : string/*DOMString*/;
	__readonly__ var command : Nullable.<HTMLElement>;

} // end of HTMLCommandElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLMenuElement extends HTMLElement {

	var type : string/*DOMString*/;
	var label : string/*DOMString*/;

	var compact : boolean;

} // end of HTMLMenuElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLDialogElement extends HTMLElement {

	var open : boolean;
	var returnValue : string/*DOMString*/;
	function show() : void;
	function show(anchor : MouseEvent) : void;
	function show(anchor : Element) : void;
	function showModal() : void;
	function showModal(anchor : MouseEvent) : void;
	function showModal(anchor : Element) : void;
	function close() : void;
	function close(returnValue : string/*DOMString*/) : void;

} // end of HTMLDialogElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class BarProp {

	var visible : boolean;

} // end of BarProp

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class History {

	__readonly__ var length : number/*long*/;
	__readonly__ var state : variant/*any*/;
	function go() : void;
	function go(delta : number/*long*/) : void;
	function back() : void;
	function forward() : void;
	function pushState(
		data : variant/*any*/,
		title : string/*DOMString*/
	) : void;
	function pushState(
		data : variant/*any*/,
		title : string/*DOMString*/,
		url : Nullable.<string>/*DOMString?*/
	) : void;
	function replaceState(
		data : variant/*any*/,
		title : string/*DOMString*/
	) : void;
	function replaceState(
		data : variant/*any*/,
		title : string/*DOMString*/,
		url : Nullable.<string>/*DOMString?*/
	) : void;

} // end of History

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class Location {

	var href : string/*DOMString*/;
	function assign(url : string/*DOMString*/) : void;
	function replace(url : string/*DOMString*/) : void;
	function reload() : void;
	// URL decomposition IDL attributes
	var protocol : string/*DOMString*/;
	var host : string/*DOMString*/;
	var hostname : string/*DOMString*/;
	var port : string/*DOMString*/;
	var pathname : string/*DOMString*/;
	var search : string/*DOMString*/;
	var hash : string/*DOMString*/;

	function reload(ignoreCache : boolean) : void;

} // end of Location

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class PopStateEvent extends Event {

	function constructor(type : string/*DOMString*/);
	function constructor(
		type : string/*DOMString*/,
		eventInitDict : PopStateEventInit
	);

	__readonly__ var state : variant/*any*/;

} // end of PopStateEvent

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class PopStateEventInit extends EventInit {

	var state : variant/*any*/;

} // end of PopStateEventInit

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HashChangeEvent extends Event {

	function constructor(type : string/*DOMString*/);
	function constructor(
		type : string/*DOMString*/,
		eventInitDict : HashChangeEventInit
	);

	__readonly__ var oldURL : string/*DOMString*/;
	__readonly__ var newURL : string/*DOMString*/;

} // end of HashChangeEvent

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HashChangeEventInit extends EventInit {

	var oldURL : string/*DOMString*/;
	var newURL : string/*DOMString*/;

} // end of HashChangeEventInit

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class PageTransitionEvent extends Event {

	function constructor(type : string/*DOMString*/);
	function constructor(
		type : string/*DOMString*/,
		eventInitDict : PageTransitionEventInit
	);

	__readonly__ var persisted : boolean;

} // end of PageTransitionEvent

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class PageTransitionEventInit extends EventInit {

	var persisted : boolean;

} // end of PageTransitionEventInit

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class BeforeUnloadEvent extends Event {

	var returnValue : string/*DOMString*/;

} // end of BeforeUnloadEvent

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class ApplicationCache extends EventTarget {

	// update status
	static __readonly__ var UNCACHED : number/*unsigned short*/;
	       __readonly__ var UNCACHED : number/*unsigned short*/;
	static __readonly__ var IDLE : number/*unsigned short*/;
	       __readonly__ var IDLE : number/*unsigned short*/;
	static __readonly__ var CHECKING : number/*unsigned short*/;
	       __readonly__ var CHECKING : number/*unsigned short*/;
	static __readonly__ var DOWNLOADING : number/*unsigned short*/;
	       __readonly__ var DOWNLOADING : number/*unsigned short*/;
	static __readonly__ var UPDATEREADY : number/*unsigned short*/;
	       __readonly__ var UPDATEREADY : number/*unsigned short*/;
	static __readonly__ var OBSOLETE : number/*unsigned short*/;
	       __readonly__ var OBSOLETE : number/*unsigned short*/;
	__readonly__ var status : number/*unsigned short*/;
	// updates
	function update() : void;
	function abort() : void;
	function swapCache() : void;
	// events
	var onchecking : Nullable.<function(:Event):void>/*EventHandler*/;
	var onerror : Nullable.<function(:Event):void>/*EventHandler*/;
	var onnoupdate : Nullable.<function(:Event):void>/*EventHandler*/;
	var ondownloading : Nullable.<function(:Event):void>/*EventHandler*/;
	var onprogress : Nullable.<function(:Event):void>/*EventHandler*/;
	var onupdateready : Nullable.<function(:Event):void>/*EventHandler*/;
	var oncached : Nullable.<function(:Event):void>/*EventHandler*/;
	var onobsolete : Nullable.<function(:Event):void>/*EventHandler*/;

} // end of ApplicationCache

/** @see http://www.w3.org/TR/html5/single-page.html */
native __fake__ class NavigatorOnLine {

	__readonly__ var onLine : boolean;

} // end of NavigatorOnLine

/** @see http://www.w3.org/TR/html5/single-page.html */
native __fake__ class WindowBase64 {

	function btoa(btoa : string/*DOMString*/) : string/*DOMString*/;
	function atob(atob : string/*DOMString*/) : string/*DOMString*/;

} // end of WindowBase64

/** @see http://www.w3.org/TR/html5/single-page.html */
native final __fake__ class WindowModal {

	__readonly__ var dialogArguments : variant/*any*/;
	var returnValue : string/*DOMString*/;

} // end of WindowModal

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class Navigator extends NavigatorID {

	// objects implementing this interface also implement the interfaces given below

	// implements NavigatorOnLine

	__readonly__ var onLine : boolean;

	// implements NavigatorContentUtils

	// content handler registration
	function registerProtocolHandler(
		scheme : string/*DOMString*/,
		url : string/*DOMString*/,
		title : string/*DOMString*/
	) : void;
	function registerContentHandler(
		mimeType : string/*DOMString*/,
		url : string/*DOMString*/,
		title : string/*DOMString*/
	) : void;
	function isProtocolHandlerRegistered(
		scheme : string/*DOMString*/,
		url : string/*DOMString*/
	) : string/*DOMString*/;
	function isContentHandlerRegistered(
		mimeType : string/*DOMString*/,
		url : string/*DOMString*/
	) : string/*DOMString*/;
	function unregisterProtocolHandler(
		scheme : string/*DOMString*/,
		url : string/*DOMString*/
	) : void;
	function unregisterContentHandler(
		mimeType : string/*DOMString*/,
		url : string/*DOMString*/
	) : void;

	// implements NavigatorStorageUtils

	function yieldForStorageUpdates() : void;

	// implements NavigatorGeolocation

	/** @see http://dev.w3.org/geo/api/spec-source.html */
	__readonly__ var geolocation : Geolocation;

	// implements Intents

	/** @see http://www.w3.org/TR/2012/WD-web-intents-20120626/ */
	function startActivity(intent : Intent) : void;
	/** @see http://www.w3.org/TR/2012/WD-web-intents-20120626/ */
	function startActivity(
		intent : Intent,
		onSuccess : function(data:variant/*any*/,
		ports:MessagePort[]):void/*IntentSuccessCallback*/
	) : void;
	/** @see http://www.w3.org/TR/2012/WD-web-intents-20120626/ */
	function startActivity(
		intent : Intent,
		onSuccess : function(data:variant/*any*/,
		ports:MessagePort[]):void/*IntentSuccessCallback*/,
		onFailure : function(data:variant/*any*/):void/*IntentFailureCallback*/
	) : void;

	// implements NavigatorUserMedia

	/** @see http://www.w3.org/TR/mediacapture-streams/ */
	function getUserMedia(
		constraints : Nullable.<MediaStreamConstraints>,
		successCallback : function(stream:LocalMediaStream):void/*NavigatorUserMediaSuccessCallback*/
	) : void;
	/** @see http://www.w3.org/TR/mediacapture-streams/ */
	function getUserMedia(
		constraints : Nullable.<MediaStreamConstraints>,
		successCallback : function(stream:LocalMediaStream):void/*NavigatorUserMediaSuccessCallback*/,
		errorCallback : Nullable.<function(error:NavigatorUserMediaError):void>/*NavigatorUserMediaErrorCallback?*/
	) : void;

} // end of Navigator

/** @see http://www.w3.org/TR/html5/single-page.html */
native __fake__ class NavigatorID {

	__readonly__ var appName : string/*DOMString*/;
	__readonly__ var appVersion : string/*DOMString*/;
	__readonly__ var platform : string/*DOMString*/;
	__readonly__ var userAgent : string/*DOMString*/;

} // end of NavigatorID

/** @see http://www.w3.org/TR/html5/single-page.html */
native __fake__ class NavigatorContentUtils {

	// content handler registration
	function registerProtocolHandler(
		scheme : string/*DOMString*/,
		url : string/*DOMString*/,
		title : string/*DOMString*/
	) : void;
	function registerContentHandler(
		mimeType : string/*DOMString*/,
		url : string/*DOMString*/,
		title : string/*DOMString*/
	) : void;
	function isProtocolHandlerRegistered(
		scheme : string/*DOMString*/,
		url : string/*DOMString*/
	) : string/*DOMString*/;
	function isContentHandlerRegistered(
		mimeType : string/*DOMString*/,
		url : string/*DOMString*/
	) : string/*DOMString*/;
	function unregisterProtocolHandler(
		scheme : string/*DOMString*/,
		url : string/*DOMString*/
	) : void;
	function unregisterContentHandler(
		mimeType : string/*DOMString*/,
		url : string/*DOMString*/
	) : void;

} // end of NavigatorContentUtils

/** @see http://www.w3.org/TR/html5/single-page.html */
native __fake__ class NavigatorStorageUtils {

	function yieldForStorageUpdates() : void;

} // end of NavigatorStorageUtils

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class External {

	function AddSearchProvider(engineURL : string/*DOMString*/) : void;
	function IsSearchProviderInstalled(
		engineURL : string/*DOMString*/
	) : number/*unsigned long*/;

} // end of External

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class DataTransfer {

	var dropEffect : string/*DOMString*/;
	var effectAllowed : string/*DOMString*/;
	__readonly__ var items : DataTransferItemList;
	function setDragImage(
		image : Element,
		x : number/*long*/,
		y : number/*long*/
	) : void;
	/* old interface */
	__readonly__ var types : string[]/*DOMString[]*/;
	function getData(
		format : string/*DOMString*/
	) : string/*DOMString*/;
	function setData(
		format : string/*DOMString*/,
		data : string/*DOMString*/
	) : void;
	function clearData() : void;
	function clearData(format : string/*DOMString*/) : void;
	__readonly__ var files : FileList;

} // end of DataTransfer

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class DataTransferItemList {

	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<DataTransferItem>;
	function clear() : void;
	function add(
		data : string/*DOMString*/,
		type : string/*DOMString*/
	) : Nullable.<DataTransferItem>;
	function add(data : File) : Nullable.<DataTransferItem>;

} // end of DataTransferItemList

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class DataTransferItem {

	__readonly__ var kind : string/*DOMString*/;
	__readonly__ var type : string/*DOMString*/;
	function getAsString(
		_callback : Nullable.<function(:string):void>/*FunctionStringCallback?*/
	) : void;
	function getAsFile() : Nullable.<File>;

} // end of DataTransferItem

// alias FunctionStringCallback = function(data:string/*DOMString*/):void

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class DragEvent extends MouseEvent {

	function constructor(type : string/*DOMString*/);
	function constructor(
		type : string/*DOMString*/,
		eventInitDict : DragEventInit
	);

	__readonly__ var dataTransfer : Nullable.<DataTransfer>;

} // end of DragEvent

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class DragEventInit extends EventInit {

	// Attributes from UIEvent:
	var view : Nullable.<Window>;
	var detail : number/*long*/;
	// Attributes for MouseEvent:
	var screenX : number/*long*/;
	var screenY : number/*long*/;
	var clientX : number/*long*/;
	var clientY : number/*long*/;
	var ctrlKey : boolean;
	var shiftKey : boolean;
	var altKey : boolean;
	var metaKey : boolean;
	var button : number/*unsigned short*/;
	var buttons : number/*unsigned short*/;
	var relatedTarget : Nullable.<EventTarget>;
	// Attributes for DragEvent:
	var dataTransfer : Nullable.<DataTransfer>;

} // end of DragEventInit

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLAppletElement extends HTMLElement {

	var align : string/*DOMString*/;
	var alt : string/*DOMString*/;
	var archive : string/*DOMString*/;
	var code : string/*DOMString*/;
	var codeBase : string/*DOMString*/;
	var height : string/*DOMString*/;
	var hspace : number/*unsigned long*/;
	var name : string/*DOMString*/;
	var _object : string/*DOMString*/;
	// the underscore is not part of the identifier
	var vspace : number/*unsigned long*/;
	var width : string/*DOMString*/;

} // end of HTMLAppletElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLMarqueeElement extends HTMLElement {

	var behavior : string/*DOMString*/;
	var bgColor : string/*DOMString*/;
	var direction : string/*DOMString*/;
	var height : string/*DOMString*/;
	var hspace : number/*unsigned long*/;
	var loop : number/*long*/;
	var scrollAmount : number/*unsigned long*/;
	var scrollDelay : number/*unsigned long*/;
	var trueSpeed : boolean;
	var vspace : number/*unsigned long*/;
	var width : string/*DOMString*/;
	var onbounce : Nullable.<function(:Event):void>/*EventHandler*/;
	var onfinish : Nullable.<function(:Event):void>/*EventHandler*/;
	var onstart : Nullable.<function(:Event):void>/*EventHandler*/;
	function start() : void;
	function stop() : void;

} // end of HTMLMarqueeElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLFrameSetElement extends HTMLElement {

	var cols : string/*DOMString*/;
	var rows : string/*DOMString*/;
	var onafterprint : Nullable.<function(:Event):void>/*EventHandler*/;
	var onbeforeprint : Nullable.<function(:Event):void>/*EventHandler*/;
	var onbeforeunload : Nullable.<function(:Event):void>/*EventHandler*/;
	// inherits var onblur : Nullable.<function(:Event):void>/*EventHandler*/;
	// inherits var onerror : Nullable.<function(:Event):void>/*EventHandler*/;
	// inherits var onfocus : Nullable.<function(:Event):void>/*EventHandler*/;
	var onhashchange : Nullable.<function(:Event):void>/*EventHandler*/;
	// inherits var onload : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmessage : Nullable.<function(:Event):void>/*EventHandler*/;
	var onoffline : Nullable.<function(:Event):void>/*EventHandler*/;
	var ononline : Nullable.<function(:Event):void>/*EventHandler*/;
	var onpagehide : Nullable.<function(:Event):void>/*EventHandler*/;
	var onpageshow : Nullable.<function(:Event):void>/*EventHandler*/;
	var onpopstate : Nullable.<function(:Event):void>/*EventHandler*/;
	var onresize : Nullable.<function(:Event):void>/*EventHandler*/;
	// inherits var onscroll : Nullable.<function(:Event):void>/*EventHandler*/;
	var onstorage : Nullable.<function(:Event):void>/*EventHandler*/;
	var onunload : Nullable.<function(:Event):void>/*EventHandler*/;

} // end of HTMLFrameSetElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLFrameElement extends HTMLElement {

	var name : string/*DOMString*/;
	var scrolling : string/*DOMString*/;
	var src : string/*DOMString*/;
	var frameBorder : string/*DOMString*/;
	var longDesc : string/*DOMString*/;
	var noResize : boolean;
	__readonly__ var contentDocument : Nullable.<HTMLDocument>/*Document?*/;
	__readonly__ var contentWindow : Nullable.<Window>/*WindowProxy?*/;
	var marginHeight : string/*DOMString*/;
	var marginWidth : string/*DOMString*/;

} // end of HTMLFrameElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLBaseFontElement extends HTMLElement {

	var color : string/*DOMString*/;
	var face : string/*DOMString*/;
	var size : number/*long*/;

} // end of HTMLBaseFontElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLDirectoryElement extends HTMLElement {

	var compact : boolean;

} // end of HTMLDirectoryElement

/** @see http://www.w3.org/TR/html5/single-page.html */
native final class HTMLFontElement extends HTMLElement {

	var color : string/*DOMString*/;
	var face : string/*DOMString*/;
	var size : string/*DOMString*/;

} // end of HTMLFontElement

/** @see http://www.w3.org/TR/2012/WD-FileAPI-20121025/ */
native final class FileList {

	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<File>;
	/* getter */
	function item(index : number/*unsigned long*/) : Nullable.<File>;
	__readonly__ var length : number/*unsigned long*/;

} // end of FileList

/** @see http://www.w3.org/TR/2012/WD-FileAPI-20121025/ */
native class Blob {

	__readonly__ var size : number/*unsigned long long*/;
	__readonly__ var type : string/*DOMString*/;
	//slice Blob into byte-ranged chunks

	function slice() : Blob;
	function slice(start : number/*long long*/) : Blob;
	function slice(
		start : number/*long long*/,
		end : number/*long long*/
	) : Blob;
	function slice(
		start : number/*long long*/,
		end : number/*long long*/,
		contentType : string/*DOMString*/
	) : Blob;

} // end of Blob

/** @see http://www.w3.org/TR/2012/WD-FileAPI-20121025/ */
native final class File extends Blob {

	__readonly__ var name : string/*DOMString*/;
	__readonly__ var lastModifiedDate : Date;

} // end of File

/** @see http://www.w3.org/TR/2012/WD-FileAPI-20121025/ */
native final class FileReader extends EventTarget {

	function constructor();

	// async read methods
	function readAsArrayBuffer(blob : Blob) : void;
	function readAsBinaryString(blob : Blob) : void;
	function readAsText(blob : Blob) : void;
	function readAsText(
		blob : Blob,
		encoding : string/*DOMString*/
	) : void;
	function readAsDataURL(blob : Blob) : void;
	function abort() : void;
	// states
	static __readonly__ var EMPTY : number/*unsigned short*/;
	       __readonly__ var EMPTY : number/*unsigned short*/;
	static __readonly__ var LOADING : number/*unsigned short*/;
	       __readonly__ var LOADING : number/*unsigned short*/;
	static __readonly__ var DONE : number/*unsigned short*/;
	       __readonly__ var DONE : number/*unsigned short*/;
	__readonly__ var readyState : number/*unsigned short*/;
	// File or Blob data
	__readonly__ var result : variant/*any*/;
	__readonly__ var error : DOMError;
	// event handler attributes
	var onloadstart : Nullable.<function(:Event):void>/*Function?*/;
	var onprogress : Nullable.<function(:Event):void>/*Function?*/;
	var onload : Nullable.<function(:Event):void>/*Function?*/;
	var onabort : Nullable.<function(:Event):void>/*Function?*/;
	var onerror : Nullable.<function(:Event):void>/*Function?*/;
	var onloadend : Nullable.<function(:Event):void>/*Function?*/;

} // end of FileReader

/** @see http://www.w3.org/TR/2012/WD-FileAPI-20121025/ */
native final class FileReaderSync {

	function constructor();

	// Synchronously return strings

	function readAsArrayBuffer(blob : Blob) : ArrayBuffer;
	function readAsBinaryString(blob : Blob) : string/*DOMString*/;
	function readAsText(blob : Blob) : string/*DOMString*/;
	function readAsText(
		blob : Blob,
		encoding : string/*DOMString*/
	) : string/*DOMString*/;
	function readAsDataURL(blob : Blob) : string/*DOMString*/;

} // end of FileReaderSync

/** @see http://www.w3.org/TR/2012/WD-url-20120524/ */
native class URL {

	/** @see http://www.w3.org/TR/2012/WD-FileAPI-20121025/ */
	static function createObjectURL(blob : Blob) : string/*DOMString*/;
	/** @see http://www.w3.org/TR/2012/WD-FileAPI-20121025/ */
	static function revokeObjectURL(url : string/*DOMString*/) : void;
	function constructor(url : string/*DOMString*/);
	function constructor(
		url : string/*DOMString*/,
		baseURL : string/*DOMString*/
	);

	var protocol : string/*DOMString*/;
	var username : string/*DOMString*/;
	var password : string/*DOMString*/;
	var host : string/*DOMString*/;
	var hostname : string/*DOMString*/;
	var port : string/*DOMString*/;
	var pathname : string/*DOMString*/;
	var search : string/*DOMString*/;
	var hash : string/*DOMString*/;
	var filename : string/*DOMString*/;
	__readonly__ var origin : string/*DOMString*/;
	function getParameterNames() : string[]/*sequence<DOMString>*/;
	function getParameterValues(
		name : string/*DOMString*/
	) : string[]/*sequence<DOMString>*/;
	function hasParameter(name : string/*DOMString*/) : boolean;
	function getParameter(
		name : string/*DOMString*/
	) : Nullable.<string>/*DOMString?*/;
	function setParameter(
		name : string/*DOMString*/,
		value : string/*DOMString*/
	) : void;
	function addParameter(
		name : string/*DOMString*/,
		value : string/*DOMString*/
	) : void;
	function removeParameter(name : string/*DOMString*/) : void;
	function clearParameters() : void;
	var href : string/*DOMString*/;

	/** @see http://www.w3.org/TR/mediacapture-streams/ */
	static function createObjectURL(
		stream : MediaStream
	) : string/*DOMString*/;

} // end of URL

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native class AudioContext {

	function constructor();

	__readonly__ var destination : AudioDestinationNode;
	__readonly__ var sampleRate : number/*float*/;
	__readonly__ var currentTime : number/*double*/;
	__readonly__ var listener : AudioListener;
	__readonly__ var activeSourceCount : number/*unsigned long*/;
	function createBuffer(
		numberOfChannels : number/*unsigned long*/,
		length : number/*unsigned long*/,
		sampleRate : number/*float*/
	) : AudioBuffer;
	function createBuffer(
		buffer : ArrayBuffer,
		mixToMono : boolean
	) : AudioBuffer;
	function decodeAudioData(
		audioData : ArrayBuffer,
		successCallback : function(decodedData:AudioBuffer):void/*DecodeSuccessCallback*/
	) : void;
	function decodeAudioData(
		audioData : ArrayBuffer,
		successCallback : function(decodedData:AudioBuffer):void/*DecodeSuccessCallback*/,
		errorCallback : function():void/*DecodeErrorCallback*/
	) : void;
	// AudioNode creation
	function createBufferSource() : AudioBufferSourceNode;
	function createMediaElementSource(
		mediaElement : HTMLMediaElement
	) : MediaElementAudioSourceNode;
	function createMediaStreamSource(
		mediaStream : MediaStream
	) : MediaStreamAudioSourceNode;
	function createScriptProcessor(
		bufferSize : number/*unsigned long*/
	) : ScriptProcessorNode;
	function createScriptProcessor(
		bufferSize : number/*unsigned long*/,
		numberOfInputChannels : number/*unsigned long*/
	) : ScriptProcessorNode;
	function createScriptProcessor(
		bufferSize : number/*unsigned long*/,
		numberOfInputChannels : number/*unsigned long*/,
		numberOfOutputChannels : number/*unsigned long*/
	) : ScriptProcessorNode;
	function createAnalyser() : AnalyserNode;
	function createGain() : GainNode;
	function createDelay() : DelayNode;
	function createDelay(maxDelayTime : number/*double*/) : DelayNode;
	function createBiquadFilter() : BiquadFilterNode;
	function createWaveShaper() : WaveShaperNode;
	function createPanner() : PannerNode;
	function createConvolver() : ConvolverNode;
	function createChannelSplitter() : ChannelSplitterNode;
	function createChannelSplitter(
		numberOfOutputs : number/*unsigned long*/
	) : ChannelSplitterNode;
	function createChannelMerger() : ChannelMergerNode;
	function createChannelMerger(
		numberOfInputs : number/*unsigned long*/
	) : ChannelMergerNode;
	function createDynamicsCompressor() : DynamicsCompressorNode;
	function createOscillator() : OscillatorNode;
	function createWaveTable(
		real : Float32Array,
		imag : Float32Array
	) : WaveTable;

	// deprecated
	function createGainNode() : void;
	// deprecated
	function createDelayNode() : void;
	// deprecated
	function createJavaScriptNode() : void;

} // end of AudioContext

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class OfflineAudioContext extends AudioContext {

	function constructor();

	function startRendering() : void;
	var oncomplete : function(renderedData:AudioBuffer):void/*OfflineRenderSuccessCallback*/;

} // end of OfflineAudioContext

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native class AudioNode {

	function connect(destination : AudioNode) : void;
	function connect(
		destination : AudioNode,
		output : number/*unsigned long*/
	) : void;
	function connect(
		destination : AudioNode,
		output : number/*unsigned long*/,
		input : number/*unsigned long*/
	) : void;
	function connect(destination : AudioParam) : void;
	function connect(
		destination : AudioParam,
		output : number/*unsigned long*/
	) : void;
	function disconnect() : void;
	function disconnect(output : number/*unsigned long*/) : void;
	__readonly__ var context : AudioContext;
	__readonly__ var numberOfInputs : number/*unsigned long*/;
	__readonly__ var numberOfOutputs : number/*unsigned long*/;

} // end of AudioNode

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native class AudioSourceNode extends AudioNode {
}

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class AudioDestinationNode extends AudioNode {

	__readonly__ var maxNumberOfChannels : number/*unsigned long*/;
	var numberOfChannels : number/*unsigned long*/;

} // end of AudioDestinationNode

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class AudioParam {

	var value : number/*float*/;
	__readonly__ var computedValue : number/*float*/;
	__readonly__ var minValue : number/*float*/;
	__readonly__ var maxValue : number/*float*/;
	__readonly__ var defaultValue : number/*float*/;
	// Parameter automation.
	function setValueAtTime(
		value : number/*float*/,
		startTime : number/*double*/
	) : void;
	function linearRampToValueAtTime(
		value : number/*float*/,
		endTime : number/*double*/
	) : void;
	function exponentialRampToValueAtTime(
		value : number/*float*/,
		endTime : number/*double*/
	) : void;
	// Exponentially approach the target value with a rate having the given time constant.
	function setTargetAtTime(
		target : number/*float*/,
		startTime : number/*double*/,
		timeConstant : number/*double*/
	) : void;
	// Sets an array of arbitrary parameter values starting at time for the given duration.
	// The number of values will be scaled to fit into the desired duration.
	function setValueCurveAtTime(
		values : Float32Array,
		startTime : number/*double*/,
		duration : number/*double*/
	) : void;
	// Cancels all scheduled parameter changes with times greater than or equal to startTime.
	function cancelScheduledValues(startTime : number/*double*/) : void;

} // end of AudioParam

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class GainNode extends AudioNode {

	__readonly__ var gain : AudioParam;

} // end of GainNode

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class DelayNode extends AudioNode {

	__readonly__ var delayTime : AudioParam;

} // end of DelayNode

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class AudioBuffer {

	__readonly__ var sampleRate : number/*float*/;
	__readonly__ var length : number/*long*/;
	// in seconds
	__readonly__ var duration : number/*double*/;
	__readonly__ var numberOfChannels : number/*long*/;
	function getChannelData(
		channel : number/*unsigned long*/
	) : Float32Array;

} // end of AudioBuffer

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class AudioBufferSourceNode extends AudioSourceNode {

	static __readonly__ var UNSCHEDULED_STATE : number/*unsigned short*/;
	       __readonly__ var UNSCHEDULED_STATE : number/*unsigned short*/;
	static __readonly__ var SCHEDULED_STATE : number/*unsigned short*/;
	       __readonly__ var SCHEDULED_STATE : number/*unsigned short*/;
	static __readonly__ var PLAYING_STATE : number/*unsigned short*/;
	       __readonly__ var PLAYING_STATE : number/*unsigned short*/;
	static __readonly__ var FINISHED_STATE : number/*unsigned short*/;
	       __readonly__ var FINISHED_STATE : number/*unsigned short*/;
	__readonly__ var playbackState : number/*unsigned short*/;
	var buffer : Nullable.<AudioBuffer>;
	var playbackRate : AudioParam;
	var loop : boolean;
	var loopStart : number/*double*/;
	var loopEnd : number/*double*/;
	function start(when : number/*double*/) : void;
	function start(
		when : number/*double*/,
		offset : number/*double*/
	) : void;
	function start(
		when : number/*double*/,
		offset : number/*double*/,
		duration : number/*double*/
	) : void;
	function stop(when : number/*double*/) : void;

	// deprecated
	function noteOn(when : number/*double*/) : void;
	function noteOn(
		when : number/*double*/,
		offset : number/*double*/
	) : void;
	function noteOn(
		when : number/*double*/,
		offset : number/*double*/,
		duration : number/*double*/
	) : void;
	// deprecated
	function noteOff(when : number/*double*/) : void;

} // end of AudioBufferSourceNode

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class MediaElementAudioSourceNode extends AudioSourceNode {
}

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class ScriptProcessorNode extends AudioNode {

	var onaudioprocess : function(:Event):void/*EventListener*/;
	__readonly__ var bufferSize : number/*long*/;

} // end of ScriptProcessorNode

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class AudioProcessingEvent extends Event {

	var node : ScriptProcessorNode;
	__readonly__ var playbackTime : number/*double*/;
	__readonly__ var inputBuffer : AudioBuffer;
	__readonly__ var outputBuffer : AudioBuffer;

} // end of AudioProcessingEvent

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class PannerNode extends AudioNode {

	// Default for stereo is HRTF
	var panningModel : string/*PanningModelType*/;
	// Uses a 3D cartesian coordinate system
	function setPosition(
		x : number/*float*/,
		y : number/*float*/,
		z : number/*float*/
	) : void;
	function setOrientation(
		x : number/*float*/,
		y : number/*float*/,
		z : number/*float*/
	) : void;
	function setVelocity(
		x : number/*float*/,
		y : number/*float*/,
		z : number/*float*/
	) : void;
	// Distance model and attributes
	var distanceModel : string/*DistanceModelType*/;
	var refDistance : number/*float*/;
	var maxDistance : number/*float*/;
	var rolloffFactor : number/*float*/;
	// Directional sound cone
	var coneInnerAngle : number/*float*/;
	var coneOuterAngle : number/*float*/;
	var coneOuterGain : number/*float*/;

} // end of PannerNode

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class AudioListener {

	// same as OpenAL (default 1)
	var dopplerFactor : number/*float*/;
	// in meters / second (default 343.3)
	var speedOfSound : number/*float*/;
	// Uses a 3D cartesian coordinate system
	function setPosition(
		x : number/*float*/,
		y : number/*float*/,
		z : number/*float*/
	) : void;
	function setOrientation(
		x : number/*float*/,
		y : number/*float*/,
		z : number/*float*/,
		xUp : number/*float*/,
		yUp : number/*float*/,
		zUp : number/*float*/
	) : void;
	function setVelocity(
		x : number/*float*/,
		y : number/*float*/,
		z : number/*float*/
	) : void;

} // end of AudioListener

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class ConvolverNode extends AudioNode {

	var buffer : AudioBuffer;
	var normalize : boolean;

} // end of ConvolverNode

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class AnalyserNode extends AudioNode {

	// Real-time frequency-domain data
	function getFloatFrequencyData(array : Float32Array) : void;
	function getByteFrequencyData(array : Uint8Array) : void;
	// Real-time waveform data
	function getByteTimeDomainData(array : Uint8Array) : void;
	var fftSize : number/*unsigned long*/;
	__readonly__ var frequencyBinCount : number/*unsigned long*/;
	var minDecibels : number/*float*/;
	var maxDecibels : number/*float*/;
	var smoothingTimeConstant : number/*float*/;

} // end of AnalyserNode

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class ChannelSplitterNode extends AudioNode {
}

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class ChannelMergerNode extends AudioNode {
}

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class DynamicsCompressorNode extends AudioNode {

	__readonly__ var threshold : AudioParam;
	// in Decibels
	__readonly__ var knee : AudioParam;
	// in Decibels
	__readonly__ var ratio : AudioParam;
	// unit-less
	__readonly__ var reduction : AudioParam;
	// in Decibels
	__readonly__ var attack : AudioParam;
	// in Seconds
	__readonly__ var release : AudioParam;
	// in Seconds

} // end of DynamicsCompressorNode

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class BiquadFilterNode extends AudioNode {

	var type : string/*BiquadFilterType*/;
	__readonly__ var frequency : AudioParam;
	// in Hertz
	__readonly__ var detune : AudioParam;
	// in Cents
	__readonly__ var Q : AudioParam;
	// Quality factor
	__readonly__ var gain : AudioParam;
	// in Decibels

	function getFrequencyResponse(
		frequencyHz : Float32Array,
		magResponse : Float32Array,
		phaseResponse : Float32Array
	) : void;

} // end of BiquadFilterNode

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class WaveShaperNode extends AudioNode {

	var curve : Float32Array;

} // end of WaveShaperNode

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class OscillatorNode extends AudioSourceNode {

	var type : string/*OscillatorType*/;
	static __readonly__ var UNSCHEDULED_STATE : number/*unsigned short*/;
	       __readonly__ var UNSCHEDULED_STATE : number/*unsigned short*/;
	static __readonly__ var SCHEDULED_STATE : number/*unsigned short*/;
	       __readonly__ var SCHEDULED_STATE : number/*unsigned short*/;
	static __readonly__ var PLAYING_STATE : number/*unsigned short*/;
	       __readonly__ var PLAYING_STATE : number/*unsigned short*/;
	static __readonly__ var FINISHED_STATE : number/*unsigned short*/;
	       __readonly__ var FINISHED_STATE : number/*unsigned short*/;
	__readonly__ var playbackState : number/*unsigned short*/;
	__readonly__ var frequency : AudioParam;
	// in Hertz
	__readonly__ var detune : AudioParam;
	// in Cents

	function start(when : number/*double*/) : void;
	function stop(when : number/*double*/) : void;
	function setWaveTable(waveTable : WaveTable) : void;

	// deprecated
	function noteOn(when : number/*double*/) : void;
	// deprecated
	function noteOff(when : number/*double*/) : void;

} // end of OscillatorNode

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class WaveTable {
}

/** @see http://www.w3.org/TR/2012/WD-webaudio-20121213/ */
native final class MediaStreamAudioSourceNode extends AudioSourceNode {
}

/** @see http://www.w3.org/TR/touch-events/ */
native final class Touch {

	__readonly__ var identifier : number/*long*/;
	__readonly__ var target : EventTarget;
	__readonly__ var screenX : number/*long*/;
	__readonly__ var screenY : number/*long*/;
	__readonly__ var clientX : number/*long*/;
	__readonly__ var clientY : number/*long*/;
	__readonly__ var pageX : number/*long*/;
	__readonly__ var pageY : number/*long*/;

} // end of Touch

/** @see http://www.w3.org/TR/touch-events/ */
native final class TouchList {

	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<Touch>;
	/* getter */
	function item(index : number/*unsigned long*/) : Nullable.<Touch>;
	function identifiedTouch(identifier : number/*long*/) : Touch;

} // end of TouchList

/** @see http://www.w3.org/TR/touch-events/ */
native final class TouchEvent extends UIEvent {

	__readonly__ var touches : TouchList;
	__readonly__ var targetTouches : TouchList;
	__readonly__ var changedTouches : TouchList;
	__readonly__ var altKey : boolean;
	__readonly__ var metaKey : boolean;
	__readonly__ var ctrlKey : boolean;
	__readonly__ var shiftKey : boolean;

} // end of TouchEvent

/** @see http://www.w3.org/TR/2012/CR-websockets-20120920/ */
native final class WebSocket extends EventTarget {

	function constructor(url : string/*DOMString*/);
	function constructor(
		url : string/*DOMString*/,
		protocols : string/*DOMString*/
	);
	function constructor(
		url : string/*DOMString*/,
		protocols : string[]/*DOMString[]*/
	);

	__readonly__ var url : string/*DOMString*/;
	// ready state
	static __readonly__ var CONNECTING : number/*unsigned short*/;
	       __readonly__ var CONNECTING : number/*unsigned short*/;
	static __readonly__ var OPEN : number/*unsigned short*/;
	       __readonly__ var OPEN : number/*unsigned short*/;
	static __readonly__ var CLOSING : number/*unsigned short*/;
	       __readonly__ var CLOSING : number/*unsigned short*/;
	static __readonly__ var CLOSED : number/*unsigned short*/;
	       __readonly__ var CLOSED : number/*unsigned short*/;
	__readonly__ var readyState : number/*unsigned short*/;
	__readonly__ var bufferedAmount : number/*unsigned long*/;
	// networking
	var onopen : Nullable.<function(:Event):void>/*EventHandler*/;
	var onerror : Nullable.<function(:Event):void>/*EventHandler*/;
	var onclose : Nullable.<function(:Event):void>/*EventHandler*/;
	__readonly__ var extensions : string/*DOMString*/;
	__readonly__ var protocol : string/*DOMString*/;
	function close() : void;
	function close(code : number/*unsigned short*/) : void;
	function close(
		code : number/*unsigned short*/,
		reason : string/*DOMString*/
	) : void;
	// messaging
	var onmessage : Nullable.<function(:Event):void>/*EventHandler*/;
	var binaryType : string/*DOMString*/;
	function send(data : string/*DOMString*/) : void;
	function send(data : Blob) : void;
	function send(data : ArrayBuffer) : void;
	function send(data : ArrayBufferView) : void;

} // end of WebSocket

/** @see http://www.w3.org/TR/2012/CR-websockets-20120920/ */
native final class CloseEvent extends Event {

	function constructor(type : string/*DOMString*/);
	function constructor(
		type : string/*DOMString*/,
		eventInitDict : CloseEventInit
	);

	__readonly__ var wasClean : boolean;
	__readonly__ var code : number/*unsigned short*/;
	__readonly__ var reason : string/*DOMString*/;

} // end of CloseEvent

/** @see http://www.w3.org/TR/2012/CR-websockets-20120920/ */
native final class CloseEventInit extends EventInit {

	var wasClean : boolean;
	var code : number/*unsigned short*/;
	var reason : string/*DOMString*/;

} // end of CloseEventInit

/** @see http://dev.w3.org/geo/api/spec-source.html */
native __fake__ class NavigatorGeolocation {

	__readonly__ var geolocation : Geolocation;

} // end of NavigatorGeolocation

/** @see http://dev.w3.org/geo/api/spec-source.html */
native final __fake__ class Geolocation {

	function getCurrentPosition(
		successCallback : function(position:Position):void/*PositionCallback*/
	) : void;
	function getCurrentPosition(
		successCallback : function(position:Position):void/*PositionCallback*/,
		errorCallback : function(positionError:PositionError):void/*PositionErrorCallback*/
	) : void;
	function getCurrentPosition(
		successCallback : function(position:Position):void/*PositionCallback*/,
		errorCallback : function(positionError:PositionError):void/*PositionErrorCallback*/,
		options : PositionOptions
	) : void;
	function watchPosition(
		successCallback : function(position:Position):void/*PositionCallback*/
	) : number/*long*/;
	function watchPosition(
		successCallback : function(position:Position):void/*PositionCallback*/,
		errorCallback : function(positionError:PositionError):void/*PositionErrorCallback*/
	) : number/*long*/;
	function watchPosition(
		successCallback : function(position:Position):void/*PositionCallback*/,
		errorCallback : function(positionError:PositionError):void/*PositionErrorCallback*/,
		options : PositionOptions
	) : number/*long*/;
	function clearWatch(watchId : number/*long*/) : void;

} // end of Geolocation

/** @see http://dev.w3.org/geo/api/spec-source.html */
native final __fake__ class PositionOptions {

	var enableHighAccuracy : boolean;
	var timeout : number/*long*/;
	var maximumAge : number/*long*/;

} // end of PositionOptions

/** @see http://dev.w3.org/geo/api/spec-source.html */
native final __fake__ class Position {

	__readonly__ var coords : Coordinates;
	__readonly__ var timestamp : number/*DOMTimeStamp*/;

} // end of Position

/** @see http://dev.w3.org/geo/api/spec-source.html */
native final __fake__ class Coordinates {

	__readonly__ var latitude : number/*double*/;
	__readonly__ var longitude : number/*double*/;
	__readonly__ var altitude : Nullable.<number>/*double?*/;
	__readonly__ var accuracy : number/*double*/;
	__readonly__ var altitudeAccuracy : Nullable.<number>/*double?*/;
	__readonly__ var heading : Nullable.<number>/*double?*/;
	__readonly__ var speed : Nullable.<number>/*double?*/;

} // end of Coordinates

/** @see http://dev.w3.org/geo/api/spec-source.html */
native final __fake__ class PositionError {

	static __readonly__ var PERMISSION_DENIED : number/*unsigned short*/;
	       __readonly__ var PERMISSION_DENIED : number/*unsigned short*/;
	static __readonly__ var POSITION_UNAVAILABLE : number/*unsigned short*/;
	       __readonly__ var POSITION_UNAVAILABLE : number/*unsigned short*/;
	static __readonly__ var TIMEOUT : number/*unsigned short*/;
	       __readonly__ var TIMEOUT : number/*unsigned short*/;
	__readonly__ var code : number/*unsigned short*/;
	__readonly__ var message : string/*DOMString*/;

} // end of PositionError

/** @see http://dev.w3.org/html5/webstorage/ */
native final class Storage {

	__readonly__ var length : number/*unsigned long*/;
	function key(
		index : number/*unsigned long*/
	) : Nullable.<string>/*DOMString?*/;
	function __native_index_operator__(
		key : string/*DOMString*/
	) : Nullable.<string>/*DOMString?*/;
	/* getter */
	function getItem(
		key : string/*DOMString*/
	) : Nullable.<string>/*DOMString?*/;
	/* setter creator */
	function setItem(
		key : string/*DOMString*/,
		value : string/*DOMString*/
	) : void;
	/* deleter */
	function removeItem(key : string/*DOMString*/) : void;
	function clear() : void;

} // end of Storage

/** @see http://dev.w3.org/html5/webstorage/ */
native __fake__ class WindowSessionStorage {

	__readonly__ var sessionStorage : Storage;

} // end of WindowSessionStorage

/** @see http://dev.w3.org/html5/webstorage/ */
native __fake__ class WindowLocalStorage {

	__readonly__ var localStorage : Storage;

} // end of WindowLocalStorage

/** @see http://dev.w3.org/html5/webstorage/ */
native final class StorageEvent extends Event {

	function constructor(type : string/*DOMString*/);
	function constructor(
		type : string/*DOMString*/,
		eventInitDict : StorageEventInit
	);

	__readonly__ var key : Nullable.<string>/*DOMString?*/;
	__readonly__ var oldValue : Nullable.<string>/*DOMString?*/;
	__readonly__ var newValue : Nullable.<string>/*DOMString?*/;
	__readonly__ var url : string/*DOMString*/;
	__readonly__ var storageArea : Nullable.<Storage>;

} // end of StorageEvent

/** @see http://dev.w3.org/html5/webstorage/ */
native final class StorageEventInit extends EventInit {

	var key : Nullable.<string>/*DOMString?*/;
	var oldValue : Nullable.<string>/*DOMString?*/;
	var newValue : Nullable.<string>/*DOMString?*/;
	var url : string/*DOMString*/;
	var storageArea : Nullable.<Storage>;

} // end of StorageEventInit

/** @see http://www.w3.org/TR/webmessaging/ */
native final class MessageEvent extends Event {

	function constructor(type : string/*DOMString*/);
	function constructor(
		type : string/*DOMString*/,
		eventInitDict : MessageEventInit
	);

	__readonly__ var data : variant/*any*/;
	__readonly__ var origin : string/*DOMString*/;
	__readonly__ var lastEventId : string/*DOMString*/;
	__readonly__ var source : Nullable.<Window>/*WindowProxy?*/;
	__readonly__ var ports : Nullable.<MessagePort[]>;

} // end of MessageEvent

/** @see http://www.w3.org/TR/webmessaging/ */
native final class MessageEventInit extends EventInit {

	var data : variant/*any*/;
	var origin : string/*DOMString*/;
	var lastEventId : string/*DOMString*/;
	var source : Nullable.<Window>/*WindowProxy?*/;
	var ports : Nullable.<MessagePort[]>;

} // end of MessageEventInit

/** @see http://www.w3.org/TR/webmessaging/ */
native final class MessageChannel {

	function constructor();

	__readonly__ var port1 : MessagePort;
	__readonly__ var port2 : MessagePort;

} // end of MessageChannel

/** @see http://www.w3.org/TR/webmessaging/ */
native final class MessagePort extends EventTarget {

	function postMessage(message : variant/*any*/) : void;
	function postMessage(
		message : variant/*any*/,
		transfer : Transferable[]
	) : void;
	function start() : void;
	function close() : void;
	// event handlers
	var onmessage : Nullable.<function(:Event):void>/*Function?*/;

	// implements Transferable

} // end of MessagePort

/** @see http://www.w3.org/TR/workers/ */
native class WorkerGlobalScope extends EventTarget {

	__readonly__ var self : WorkerGlobalScope;
	__readonly__ var location : WorkerLocation;
	function close() : void;
	var onerror : Nullable.<function(:Event):void>/*Function?*/;
	var onoffline : Nullable.<function(:Event):void>/*Function?*/;
	var ononline : Nullable.<function(:Event):void>/*Function?*/;

	// implements WorkerUtils

	function importScripts(...urls : string/*DOMString...*/) : void;
	__readonly__ var navigator : WorkerNavigator;

} // end of WorkerGlobalScope

/** @see http://www.w3.org/TR/workers/ */
native final class DedicatedWorkerGlobalScope extends WorkerGlobalScope {

	function postMessage(message : variant/*any*/) : void;
	function postMessage(
		message : variant/*any*/,
		transfer : Transferable[]
	) : void;
	var onmessage : Nullable.<function(:Event):void>/*Function?*/;

} // end of DedicatedWorkerGlobalScope

/** @see http://www.w3.org/TR/workers/ */
native final class SharedWorkerGlobalScope extends WorkerGlobalScope {

	__readonly__ var name : string/*DOMString*/;
	__readonly__ var applicationCache : ApplicationCache;
	var onconnect : Nullable.<function(:Event):void>/*Function?*/;

} // end of SharedWorkerGlobalScope

/** @see http://www.w3.org/TR/workers/ */
native final class ErrorEvent extends Event {

	function constructor(type : string/*DOMString*/);
	function constructor(
		type : string/*DOMString*/,
		eventInitDict : ErrorEventInit
	);

	__readonly__ var message : string/*DOMString*/;
	__readonly__ var filename : string/*DOMString*/;
	__readonly__ var lineno : number/*unsigned long*/;

} // end of ErrorEvent

/** @see http://www.w3.org/TR/workers/ */
native final class ErrorEventInit extends EventInit {

	var message : string/*DOMString*/;
	var filename : string/*DOMString*/;
	var lineno : number/*unsigned long*/;

} // end of ErrorEventInit

/** @see http://www.w3.org/TR/workers/ */
native __fake__ class AbstractWorker {

	var onerror : Nullable.<function(:Event):void>/*Function?*/;

} // end of AbstractWorker

/** @see http://www.w3.org/TR/workers/ */
native final class Worker extends EventTarget {

	function constructor(scriptURL : string/*DOMString*/);

	function terminate() : void;
	function postMessage(message : variant/*any*/) : void;
	function postMessage(
		message : variant/*any*/,
		transfer : Transferable[]
	) : void;
	var onmessage : Nullable.<function(:Event):void>/*Function?*/;

	// implements AbstractWorker

	var onerror : Nullable.<function(:Event):void>/*Function?*/;

} // end of Worker

/** @see http://www.w3.org/TR/workers/ */
native final class SharedWorker extends EventTarget {

	function constructor(scriptURL : string/*DOMString*/);
	function constructor(
		scriptURL : string/*DOMString*/,
		name : string/*DOMString*/
	);

	__readonly__ var port : MessagePort;

	// implements AbstractWorker

	var onerror : Nullable.<function(:Event):void>/*Function?*/;

} // end of SharedWorker

/** @see http://www.w3.org/TR/workers/ */
native __fake__ class WorkerUtils extends WindowBase64 {

	function importScripts(...urls : string/*DOMString...*/) : void;
	__readonly__ var navigator : WorkerNavigator;

	// implements IDBEnvironment

	/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
	__readonly__ var indexedDB : IDBFactory;

	// implements IDBEnvironmentSync

	/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
	__readonly__ var indexedDBSync : IDBFactorySync;

} // end of WorkerUtils

/** @see http://www.w3.org/TR/workers/ */
native final class WorkerNavigator extends NavigatorID {

	// implements NavigatorOnLine

	/** @see http://www.w3.org/TR/html5/single-page.html */
	__readonly__ var onLine : boolean;

} // end of WorkerNavigator

/** @see http://www.w3.org/TR/workers/ */
native final class WorkerLocation {

	// URL decomposition IDL attributes
	__readonly__ var href : string/*DOMString*/;
	__readonly__ var protocol : string/*DOMString*/;
	__readonly__ var host : string/*DOMString*/;
	__readonly__ var hostname : string/*DOMString*/;
	__readonly__ var port : string/*DOMString*/;
	__readonly__ var pathname : string/*DOMString*/;
	__readonly__ var search : string/*DOMString*/;
	__readonly__ var hash : string/*DOMString*/;

} // end of WorkerLocation

/** @see http://www.w3.org/TR/eventsource/ */
native final class EventSource extends EventTarget {

	function constructor(url : string/*DOMString*/);
	function constructor(
		url : string/*DOMString*/,
		eventSourceInitDict : EventSourceInit
	);

	__readonly__ var url : string/*DOMString*/;
	__readonly__ var withCredentials : boolean;
	// ready state
	static __readonly__ var CONNECTING : number/*unsigned short*/;
	       __readonly__ var CONNECTING : number/*unsigned short*/;
	static __readonly__ var OPEN : number/*unsigned short*/;
	       __readonly__ var OPEN : number/*unsigned short*/;
	static __readonly__ var CLOSED : number/*unsigned short*/;
	       __readonly__ var CLOSED : number/*unsigned short*/;
	__readonly__ var readyState : number/*unsigned short*/;
	// networking
	var onopen : Nullable.<function(:Event):void>/*EventHandler*/;
	var onmessage : Nullable.<function(:Event):void>/*EventHandler*/;
	var onerror : Nullable.<function(:Event):void>/*EventHandler*/;
	function close() : void;

} // end of EventSource

/** @see http://www.w3.org/TR/eventsource/ */
native final class EventSourceInit {

	var withCredentials : boolean;

} // end of EventSourceInit

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native class IDBKeyRange {

	__readonly__ var lower : variant/*any*/;
	__readonly__ var upper : variant/*any*/;
	__readonly__ var lowerOpen : boolean;
	__readonly__ var upperOpen : boolean;
	static function only(value : variant/*any*/) : IDBKeyRange;
	static function lowerBound(lower : variant/*any*/) : IDBKeyRange;
	static function lowerBound(
		lower : variant/*any*/,
		open : boolean
	) : IDBKeyRange;
	static function upperBound(upper : variant/*any*/) : IDBKeyRange;
	static function upperBound(
		upper : variant/*any*/,
		open : boolean
	) : IDBKeyRange;
	static function bound(
		lower : variant/*any*/,
		upper : variant/*any*/
	) : IDBKeyRange;
	static function bound(
		lower : variant/*any*/,
		upper : variant/*any*/,
		lowerOpen : boolean
	) : IDBKeyRange;
	static function bound(
		lower : variant/*any*/,
		upper : variant/*any*/,
		lowerOpen : boolean,
		upperOpen : boolean
	) : IDBKeyRange;

} // end of IDBKeyRange

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native final class IDBObjectStoreParameters {

	var keyPath : Nullable.<string>/*DOMString?*/;
	var autoIncrement : boolean;

} // end of IDBObjectStoreParameters

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native final class IDBIndexParameters {

	var unique : boolean;
	var multiEntry : boolean;

} // end of IDBIndexParameters

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native final class IDBVersionChangeEventInit extends EventInit {

	var oldVersion : number/*unsigned long long*/;
	var newVersion : Nullable.<number>/*unsigned long long?*/;

} // end of IDBVersionChangeEventInit

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native class IDBRequest extends EventTarget {

	__readonly__ var result : variant/*any*/;
	__readonly__ var error : DOMError;
	__readonly__ var source : Object;
	__readonly__ var transaction : IDBTransaction;
	__readonly__ var readyState : string/*DOMString*/;
	var onsuccess : Nullable.<function(:Event):void>/*Function?*/;
	var onerror : Nullable.<function(:Event):void>/*Function?*/;

} // end of IDBRequest

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native final class IDBOpenDBRequest extends IDBRequest {

	var onblocked : Nullable.<function(:Event):void>/*Function?*/;
	var onupgradeneeded : Nullable.<function(:Event):void>/*Function?*/;

} // end of IDBOpenDBRequest

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native final class IDBVersionChangeEvent extends Event {

	function constructor(type : string/*DOMString*/);
	function constructor(
		type : string/*DOMString*/,
		eventInitDict : IDBVersionChangeEventInit
	);

	__readonly__ var oldVersion : number/*unsigned long long*/;
	__readonly__ var newVersion : Nullable.<number>/*unsigned long long?*/;

} // end of IDBVersionChangeEvent

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native __fake__ class IDBEnvironment {

	__readonly__ var indexedDB : IDBFactory;

} // end of IDBEnvironment

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native class IDBFactory {

	function open(name : string/*DOMString*/) : IDBOpenDBRequest;
	function open(
		name : string/*DOMString*/,
		version : number/*unsigned long long*/
	) : IDBOpenDBRequest;
	function deleteDatabase(
		name : string/*DOMString*/
	) : IDBOpenDBRequest;
	function cmp(
		first : variant/*any*/,
		second : variant/*any*/
	) : number/*short*/;

} // end of IDBFactory

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native class IDBDatabase extends EventTarget {

	__readonly__ var name : string/*DOMString*/;
	__readonly__ var version : number/*unsigned long long*/;
	__readonly__ var objectStoreNames : DOMStringList;
	function createObjectStore(
		name : string/*DOMString*/
	) : IDBObjectStore;
	function createObjectStore(
		name : string/*DOMString*/,
		optionalParameters : IDBObjectStoreParameters
	) : IDBObjectStore;
	function deleteObjectStore(name : string/*DOMString*/) : void;
	function transaction(storeNames : variant/*any*/) : IDBTransaction;
	function transaction(
		storeNames : variant/*any*/,
		mode : string/*DOMString*/
	) : IDBTransaction;
	function close() : void;
	var onabort : Nullable.<function(:Event):void>/*Function?*/;
	var onerror : Nullable.<function(:Event):void>/*Function?*/;
	var onversionchange : Nullable.<function(:Event):void>/*Function?*/;

} // end of IDBDatabase

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native class IDBObjectStore {

	__readonly__ var name : string/*DOMString*/;
	__readonly__ var keyPath : string/*DOMString*/;
	__readonly__ var indexNames : DOMStringList;
	__readonly__ var transaction : IDBTransaction;

	function put(value : variant/*any*/) : IDBRequest;
	function put(
		value : variant/*any*/,
		key : variant/*any*/
	) : IDBRequest;
	function add(value : variant/*any*/) : IDBRequest;
	function add(
		value : variant/*any*/,
		key : variant/*any*/
	) : IDBRequest;
	function delete(key : variant/*any*/) : IDBRequest;
	function get(key : variant/*any*/) : IDBRequest;
	function clear() : IDBRequest;
	function openCursor() : IDBRequest;
	function openCursor(range : variant/*any?*/) : IDBRequest;
	function openCursor(
		range : variant/*any?*/,
		direction : string/*DOMString*/
	) : IDBRequest;
	function createIndex(
		name : string/*DOMString*/,
		keyPath : variant/*any*/
	) : IDBIndex;
	function createIndex(
		name : string/*DOMString*/,
		keyPath : variant/*any*/,
		optionalParameters : IDBIndexParameters
	) : IDBIndex;
	function index(name : string/*DOMString*/) : IDBIndex;
	function deleteIndex(indexName : string/*DOMString*/) : void;
	function count() : IDBRequest;
	function count(key : variant/*any*/) : IDBRequest;

} // end of IDBObjectStore

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native class IDBIndex {

	__readonly__ var name : string/*DOMString*/;
	__readonly__ var objectStore : IDBObjectStore;
	__readonly__ var keyPath : string/*DOMString*/;
	__readonly__ var multiEntry : boolean;
	__readonly__ var unique : boolean;
	function openCursor() : IDBRequest;
	function openCursor(range : variant/*any?*/) : IDBRequest;
	function openCursor(
		range : variant/*any?*/,
		direction : string/*DOMString*/
	) : IDBRequest;
	function openKeyCursor() : IDBRequest;
	function openKeyCursor(range : variant/*any?*/) : IDBRequest;
	function openKeyCursor(
		range : variant/*any?*/,
		direction : string/*DOMString*/
	) : IDBRequest;
	function get(key : variant/*any*/) : IDBRequest;
	function getKey(key : variant/*any*/) : IDBRequest;
	function count() : IDBRequest;
	function count(key : variant/*any*/) : IDBRequest;

} // end of IDBIndex

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native class IDBCursor {

	__readonly__ var source : Object;
	__readonly__ var direction : string/*DOMString*/;
	__readonly__ var key : variant/*any*/;
	__readonly__ var primaryKey : variant/*any*/;
	function update(value : variant/*any*/) : IDBRequest;
	function advance(count : number/*unsigned long*/) : void;
	function continue() : void;
	function continue(key : variant/*any*/) : void;
	function delete() : IDBRequest;

} // end of IDBCursor

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native final class IDBCursorWithValue extends IDBCursor {

	__readonly__ var value : variant/*any*/;

} // end of IDBCursorWithValue

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native class IDBTransaction extends EventTarget {

	__readonly__ var mode : string/*DOMString*/;
	__readonly__ var db : IDBDatabase;
	__readonly__ var error : DOMError;
	function objectStore(name : string/*DOMString*/) : IDBObjectStore;
	function abort() : void;
	var onabort : Nullable.<function(:Event):void>/*Function?*/;
	var oncomplete : Nullable.<function(:Event):void>/*Function?*/;
	var onerror : Nullable.<function(:Event):void>/*Function?*/;

} // end of IDBTransaction

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native __fake__ class IDBEnvironmentSync {

	__readonly__ var indexedDBSync : IDBFactorySync;

} // end of IDBEnvironmentSync

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native final class IDBFactorySync {

	function open(name : string/*DOMString*/) : IDBDatabaseSync;
	function open(
		name : string/*DOMString*/,
		version : number/*unsigned long long*/
	) : IDBDatabaseSync;
	function open(
		name : string/*DOMString*/,
		version : number/*unsigned long long*/,
		upgradeCallback : function(:IDBTransactionSync,
		:number):void/*IDBVersionChangeCallback*/
	) : IDBDatabaseSync;
	function open(
		name : string/*DOMString*/,
		version : number/*unsigned long long*/,
		upgradeCallback : function(:IDBTransactionSync,
		:number):void/*IDBVersionChangeCallback*/,
		timeout : number/*unsigned long*/
	) : IDBDatabaseSync;
	function deleteDatabase(name : string/*DOMString*/) : void;
	function cmp(
		first : variant/*any*/,
		second : variant/*any*/
	) : number/*short*/;

} // end of IDBFactorySync

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native final class IDBDatabaseSync {

	__readonly__ var name : string/*DOMString*/;
	__readonly__ var version : number/*unsigned long long*/;
	__readonly__ var objectStoreNames : DOMStringList;
	function createObjectStore(
		name : string/*DOMString*/
	) : IDBObjectStoreSync;
	function createObjectStore(
		name : string/*DOMString*/,
		optionalParameters : IDBObjectStoreParameters
	) : IDBObjectStoreSync;
	function deleteObjectStore(name : string/*DOMString*/) : void;
	function transaction(
		storeNames : variant/*any*/,
		callback : function(:IDBTransactionSync):void/*IDBTransactionCallback*/
	) : void;
	function transaction(
		storeNames : variant/*any*/,
		callback : function(:IDBTransactionSync):void/*IDBTransactionCallback*/,
		mode : string/*DOMString*/
	) : void;
	function transaction(
		storeNames : variant/*any*/,
		callback : function(:IDBTransactionSync):void/*IDBTransactionCallback*/,
		mode : string/*DOMString*/,
		timeout : number/*unsigned long*/
	) : void;
	function close() : void;

} // end of IDBDatabaseSync

// alias IDBTransactionCallback = function(transaction:IDBTransactionSync):void

// alias IDBVersionChangeCallback = function(transaction:IDBTransactionSync,oldVersion:number/*unsigned long long*/):void

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native final class IDBObjectStoreSync {

	__readonly__ var name : string/*DOMString*/;
	__readonly__ var keyPath : variant/*any*/;
	__readonly__ var indexNames : DOMStringList;
	__readonly__ var transaction : IDBTransactionSync;

	function put(value : variant/*any*/) : variant/*any*/;
	function put(
		value : variant/*any*/,
		key : variant/*any*/
	) : variant/*any*/;
	function add(value : variant/*any*/) : variant/*any*/;
	function add(
		value : variant/*any*/,
		key : variant/*any*/
	) : variant/*any*/;
	function delete(key : variant/*any*/) : boolean;
	function get(key : variant/*any*/) : variant/*any*/;
	function clear() : void;
	function createIndex(
		name : string/*DOMString*/,
		keyPath : variant/*any*/
	) : IDBIndexSync;
	function createIndex(
		name : string/*DOMString*/,
		keyPath : variant/*any*/,
		optionalParameters : IDBIndexParameters
	) : IDBIndexSync;
	function index(name : string/*DOMString*/) : IDBIndexSync;
	function deleteIndex(indexName : string/*DOMString*/) : void;
	function openCursor() : IDBCursorWithValueSync;
	function openCursor(
		range : variant/*any?*/
	) : IDBCursorWithValueSync;
	function openCursor(
		range : variant/*any?*/,
		direction : string/*DOMString*/
	) : IDBCursorWithValueSync;
	function count() : number/*unsigned long*/;
	function count(key : variant/*any*/) : number/*unsigned long*/;

} // end of IDBObjectStoreSync

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native final class IDBIndexSync {

	__readonly__ var name : string/*DOMString*/;
	__readonly__ var objectStore : IDBObjectStoreSync;
	__readonly__ var keyPath : variant/*any*/;
	__readonly__ var multiEntry : boolean;
	__readonly__ var unique : boolean;
	function openCursor() : IDBCursorWithValueSync;
	function openCursor(
		range : variant/*any?*/
	) : IDBCursorWithValueSync;
	function openCursor(
		range : variant/*any?*/,
		direction : string/*DOMString*/
	) : IDBCursorWithValueSync;
	function openKeyCursor() : IDBCursorSync;
	function openKeyCursor(range : variant/*any?*/) : IDBCursorSync;
	function openKeyCursor(
		range : variant/*any?*/,
		direction : string/*DOMString*/
	) : IDBCursorSync;
	function get(key : variant/*any*/) : variant/*any*/;
	function getKey(key : variant/*any*/) : variant/*any*/;
	function count() : number/*unsigned long*/;
	function count(key : variant/*any*/) : number/*unsigned long*/;

} // end of IDBIndexSync

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native class IDBCursorSync {

	__readonly__ var source : Object;
	__readonly__ var direction : string/*DOMString*/;
	__readonly__ var primaryKey : variant/*any*/;
	function update(value : variant/*any*/) : IDBRequest;
	function advance(count : number/*unsigned long*/) : boolean;
	function continue() : boolean;
	function continue(key : variant/*any*/) : boolean;
	function delete() : boolean;

} // end of IDBCursorSync

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native final class IDBCursorWithValueSync extends IDBCursorSync {

	var value : variant/*any*/;

} // end of IDBCursorWithValueSync

/** @see http://www.w3.org/TR/2012/WD-IndexedDB-20120524/ */
native final class IDBTransactionSync {

	__readonly__ var mode : string/*DOMString*/;
	var db : IDBDatabaseSync;
	__readonly__ var error : DOMError;
	function objectStore(
		name : string/*DOMString*/
	) : IDBObjectStoreSync;
	function abort() : void;

} // end of IDBTransactionSync

/** @see http://www.w3.org/TR/2012/WD-notifications-20120614/ */
native final class Notification extends EventTarget {

	function constructor(title : string/*DOMString*/);
	function constructor(
		title : string/*DOMString*/,
		options : NotificationOptions
	);

	__readonly__ var permission : string/*NotificationPermission*/;
	static function requestPermission(
		callback : function(permission:string/*NotificationPermission*/):void/*NotificationPermissionCallback*/
	) : void;
	var onclick : Nullable.<function(:Event):void>/*Function?*/;
	var onshow : Nullable.<function(:Event):void>/*Function?*/;
	var onerror : Nullable.<function(:Event):void>/*Function?*/;
	var onclose : Nullable.<function(:Event):void>/*Function?*/;
	function close() : void;

} // end of Notification

/** @see http://www.w3.org/TR/2012/WD-notifications-20120614/ */
native final class NotificationOptions {

	var titleDir : string/*NotificationDirection*/;
	var body : string/*DOMString*/;
	var bodyDir : string/*NotificationDirection*/;
	var tag : string/*DOMString*/;
	var iconUrl : string/*DOMString*/;

} // end of NotificationOptions

/** @see http://www.w3.org/TR/2012/WD-web-intents-20120626/ */
native final class IntentParameters {

	var action : string/*DOMString*/;
	var type : string/*DOMString*/;
	var data : variant/*any*/;
	var transfer : Transferable[];
	var extras : Object;
	var service : URL;
	var suggestions : URL[];

} // end of IntentParameters

/** @see http://www.w3.org/TR/2012/WD-web-intents-20120626/ */
native class Intent {

	function constructor(params : IntentParameters);
	function constructor(
		action : string/*DOMString*/,
		type : string/*DOMString*/
	);
	function constructor(
		action : string/*DOMString*/,
		type : string/*DOMString*/,
		data : variant/*any*/
	);
	function constructor(
		action : string/*DOMString*/,
		type : string/*DOMString*/,
		data : variant/*any*/,
		transferList : Transferable[]
	);

	__readonly__ var action : string/*DOMString*/;
	__readonly__ var type : string/*DOMString*/;
	__readonly__ var data : variant/*any*/;
	__readonly__ var ports : MessagePort[];
	function getExtra(key : string/*DOMString*/) : string/*DOMString*/;
	function postResult(data : variant/*any*/) : void;
	function postResult(
		data : variant/*any*/,
		transferable : Transferable[]
	) : void;
	function postFailure(data : variant/*any*/) : void;

} // end of Intent

/** @see http://www.w3.org/TR/2012/WD-web-intents-20120626/ */
native __fake__ class Intents {

	function startActivity(intent : Intent) : void;
	function startActivity(
		intent : Intent,
		onSuccess : function(data:variant/*any*/,
		ports:MessagePort[]):void/*IntentSuccessCallback*/
	) : void;
	function startActivity(
		intent : Intent,
		onSuccess : function(data:variant/*any*/,
		ports:MessagePort[]):void/*IntentSuccessCallback*/,
		onFailure : function(data:variant/*any*/):void/*IntentFailureCallback*/
	) : void;

} // end of Intents

/** @see http://www.w3.org/TR/2012/WD-web-intents-20120626/ */
native __fake__ class IntentProvider {

	__readonly__ var intent : Intent;

} // end of IntentProvider

/** @see http://www.w3.org/TR/2012/WD-web-intents-20120626/ */
native final class HTMLIntentElement extends HTMLElement {

	var action : string/*DOMString*/;
	var type : string/*DOMString*/;
	var href : string/*DOMString*/;
	// inherits var title : string/*DOMString*/;
	var disposition : string/*DOMString*/;

} // end of HTMLIntentElement

/** @see http://www.w3.org/TR/mediacapture-streams/ */
native class MediaStream extends EventTarget {

	function constructor(
		audioTracks : Nullable.<MediaStreamTrackList>,
		videoTracks : Nullable.<MediaStreamTrackList>
	);

	__readonly__ var label : string/*DOMString*/;
	__readonly__ var audioTracks : MediaStreamTrackList;
	__readonly__ var videoTracks : MediaStreamTrackList;
	var ended : boolean;
	var onended : Nullable.<function(:Event):void>/*Function?*/;

} // end of MediaStream

/** @see http://www.w3.org/TR/mediacapture-streams/ */
native final class LocalMediaStream extends MediaStream {

	function stop() : void;

} // end of LocalMediaStream

/** @see http://www.w3.org/TR/mediacapture-streams/ */
native final class MediaStreamTrack {

	__readonly__ var kind : string/*DOMString*/;
	__readonly__ var label : string/*DOMString*/;
	var enabled : boolean;
	static __readonly__ var LIVE : number/*unsigned short*/;
	       __readonly__ var LIVE : number/*unsigned short*/;
	static __readonly__ var MUTED : number/*unsigned short*/;
	       __readonly__ var MUTED : number/*unsigned short*/;
	static __readonly__ var ENDED : number/*unsigned short*/;
	       __readonly__ var ENDED : number/*unsigned short*/;
	__readonly__ var readyState : number/*unsigned short*/;
	var onmute : Nullable.<function(:Event):void>/*Function?*/;
	var onunmute : Nullable.<function(:Event):void>/*Function?*/;
	var onended : Nullable.<function(:Event):void>/*Function?*/;

} // end of MediaStreamTrack

/** @see http://www.w3.org/TR/mediacapture-streams/ */
native final class MediaStreamTrackList {

	__readonly__ var length : number/*unsigned long*/;
	function item(index : number/*unsigned long*/) : MediaStreamTrack;
	function add(track : MediaStreamTrack) : void;
	function remove(track : MediaStreamTrack) : void;
	var onaddtrack : Nullable.<function(:Event):void>/*Function?*/;
	var onremovetrack : Nullable.<function(:Event):void>/*Function?*/;

} // end of MediaStreamTrackList

/** @see http://www.w3.org/TR/mediacapture-streams/ */
native __fake__ class NavigatorUserMedia {

	function getUserMedia(
		constraints : Nullable.<MediaStreamConstraints>,
		successCallback : function(stream:LocalMediaStream):void/*NavigatorUserMediaSuccessCallback*/
	) : void;
	function getUserMedia(
		constraints : Nullable.<MediaStreamConstraints>,
		successCallback : function(stream:LocalMediaStream):void/*NavigatorUserMediaSuccessCallback*/,
		errorCallback : Nullable.<function(error:NavigatorUserMediaError):void>/*NavigatorUserMediaErrorCallback?*/
	) : void;

} // end of NavigatorUserMedia

/** @see http://www.w3.org/TR/mediacapture-streams/ */
native final class MediaStreamConstraints {

	var video : variant/*(boolean or MediaTrackConstraints)*/;
	var audio : variant/*(boolean or MediaTrackConstraints)*/;

} // end of MediaStreamConstraints

/** @see http://www.w3.org/TR/mediacapture-streams/ */
native final class MediaTrackConstraints {

	var mandatory : Nullable.<Map.<variant>>/*MediaTrackConstraintSet?*/;
	var optional : Nullable.<Map.<variant>[]>/*MediaTrackConstraint[]?*/;

} // end of MediaTrackConstraints

/** @see http://www.w3.org/TR/mediacapture-streams/ */
native final __fake__ class NavigatorUserMediaError {

	static __readonly__ var PERMISSION_DENIED : number/*unsigned short*/;
	       __readonly__ var PERMISSION_DENIED : number/*unsigned short*/;
	__readonly__ var code : number/*unsigned short*/;

} // end of NavigatorUserMediaError

/** @see https://www.khronos.org/registry/typedarray/specs/latest/typedarray.idl */
native final class ArrayBuffer extends Transferable {

	function constructor(length : number/*unsigned long*/);

	__readonly__ var byteLength : number/*unsigned long*/;
	function slice(begin : number/*long*/) : ArrayBuffer;
	function slice(
		begin : number/*long*/,
		end : number/*long*/
	) : ArrayBuffer;

} // end of ArrayBuffer

/** @see https://www.khronos.org/registry/typedarray/specs/latest/typedarray.idl */
native __fake__ class ArrayBufferView {

	__readonly__ var buffer : ArrayBuffer;
	__readonly__ var byteOffset : number/*unsigned long*/;
	__readonly__ var byteLength : number/*unsigned long*/;

} // end of ArrayBufferView

/** @see https://www.khronos.org/registry/typedarray/specs/latest/typedarray.idl */
native final class Int8Array extends ArrayBufferView {

	function constructor(length : number/*unsigned long*/);
	function constructor(array : Int8Array);
	function constructor(array : number[]/*byte[]*/);
	function constructor(array : int[]/*byte[]*/);
	function constructor(buffer : ArrayBuffer);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/
	);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/,
		length : number/*unsigned long*/
	);

	static __readonly__ var BYTES_PER_ELEMENT : number/*long*/;
	       __readonly__ var BYTES_PER_ELEMENT : number/*long*/;
	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<number>/*byte*/;
	/* getter */
	function get(
		index : number/*unsigned long*/
	) : Nullable.<number>/*byte*/;
	/* setter */
	function set(
		index : number/*unsigned long*/,
		value : number/*byte*/
	) : void;
	function set(array : Int8Array) : void;
	function set(
		array : Int8Array,
		offset : number/*unsigned long*/
	) : void;
	function set(array : number[]/*byte[]*/) : void;
	function set(
		array : number[]/*byte[]*/,
		offset : number/*unsigned long*/
	) : void;
	function set(array : int[]/*byte[]*/) : void;
	function set(
		array : int[]/*byte[]*/,
		offset : number/*unsigned long*/
	) : void;
	function subarray(
		start : number/*long*/,
		end : number/*long*/
	) : Int8Array;

} // end of Int8Array

/** @see https://www.khronos.org/registry/typedarray/specs/latest/typedarray.idl */
native class Uint8Array extends ArrayBufferView {

	function constructor(length : number/*unsigned long*/);
	function constructor(array : Uint8Array);
	function constructor(array : number[]/*octet[]*/);
	function constructor(array : int[]/*octet[]*/);
	function constructor(buffer : ArrayBuffer);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/
	);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/,
		length : number/*unsigned long*/
	);

	static __readonly__ var BYTES_PER_ELEMENT : number/*long*/;
	       __readonly__ var BYTES_PER_ELEMENT : number/*long*/;
	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<number>/*octet*/;
	/* getter */
	function get(
		index : number/*unsigned long*/
	) : Nullable.<number>/*octet*/;
	/* setter */
	function set(
		index : number/*unsigned long*/,
		value : number/*octet*/
	) : void;
	function set(array : Uint8Array) : void;
	function set(
		array : Uint8Array,
		offset : number/*unsigned long*/
	) : void;
	function set(array : number[]/*octet[]*/) : void;
	function set(
		array : number[]/*octet[]*/,
		offset : number/*unsigned long*/
	) : void;
	function set(array : int[]/*octet[]*/) : void;
	function set(
		array : int[]/*octet[]*/,
		offset : number/*unsigned long*/
	) : void;
	function subarray(
		start : number/*long*/,
		end : number/*long*/
	) : Uint8Array;

} // end of Uint8Array

/** @see https://www.khronos.org/registry/typedarray/specs/latest/typedarray.idl */
native final class Uint8ClampedArray extends Uint8Array {

	function constructor(length : number/*unsigned long*/);
	function constructor(array : Uint8ClampedArray);
	function constructor(array : Uint8Array);
	function constructor(array : number[]/*octet[]*/);
	function constructor(array : int[]/*octet[]*/);
	function constructor(buffer : ArrayBuffer);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/
	);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/,
		length : number/*unsigned long*/
	);

	/* setter */
	// inherits function set(index : number/*unsigned long*/, value : number/*octet*/) : void;
	function set(array : Uint8ClampedArray) : void;
	function set(
		array : Uint8ClampedArray,
		offset : number/*unsigned long*/
	) : void;
	// inherits function set(array : number[]/*octet[]*/) : void;
	// inherits function set(array : number[]/*octet[]*/, offset : number/*unsigned long*/) : void;
	// inherits function set(array : int[]/*octet[]*/) : void;
	// inherits function set(array : int[]/*octet[]*/, offset : number/*unsigned long*/) : void;
	override function subarray(
		start : number/*long*/,
		end : number/*long*/
	) : Uint8ClampedArray;

} // end of Uint8ClampedArray

/** @see https://www.khronos.org/registry/typedarray/specs/latest/typedarray.idl */
native final class Int16Array extends ArrayBufferView {

	function constructor(length : number/*unsigned long*/);
	function constructor(array : Int16Array);
	function constructor(array : number[]/*short[]*/);
	function constructor(array : int[]/*short[]*/);
	function constructor(buffer : ArrayBuffer);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/
	);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/,
		length : number/*unsigned long*/
	);

	static __readonly__ var BYTES_PER_ELEMENT : number/*long*/;
	       __readonly__ var BYTES_PER_ELEMENT : number/*long*/;
	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<number>/*short*/;
	/* getter */
	function get(
		index : number/*unsigned long*/
	) : Nullable.<number>/*short*/;
	/* setter */
	function set(
		index : number/*unsigned long*/,
		value : number/*short*/
	) : void;
	function set(array : Int16Array) : void;
	function set(
		array : Int16Array,
		offset : number/*unsigned long*/
	) : void;
	function set(array : number[]/*short[]*/) : void;
	function set(
		array : number[]/*short[]*/,
		offset : number/*unsigned long*/
	) : void;
	function set(array : int[]/*short[]*/) : void;
	function set(
		array : int[]/*short[]*/,
		offset : number/*unsigned long*/
	) : void;
	function subarray(
		start : number/*long*/,
		end : number/*long*/
	) : Int16Array;

} // end of Int16Array

/** @see https://www.khronos.org/registry/typedarray/specs/latest/typedarray.idl */
native final class Uint16Array extends ArrayBufferView {

	function constructor(length : number/*unsigned long*/);
	function constructor(array : Uint16Array);
	function constructor(array : number[]/*unsigned short[]*/);
	function constructor(array : int[]/*unsigned short[]*/);
	function constructor(buffer : ArrayBuffer);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/
	);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/,
		length : number/*unsigned long*/
	);

	static __readonly__ var BYTES_PER_ELEMENT : number/*long*/;
	       __readonly__ var BYTES_PER_ELEMENT : number/*long*/;
	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<number>/*unsigned short*/;
	/* getter */
	function get(
		index : number/*unsigned long*/
	) : Nullable.<number>/*unsigned short*/;
	/* setter */
	function set(
		index : number/*unsigned long*/,
		value : number/*unsigned short*/
	) : void;
	function set(array : Uint16Array) : void;
	function set(
		array : Uint16Array,
		offset : number/*unsigned long*/
	) : void;
	function set(array : number[]/*unsigned short[]*/) : void;
	function set(
		array : number[]/*unsigned short[]*/,
		offset : number/*unsigned long*/
	) : void;
	function set(array : int[]/*unsigned short[]*/) : void;
	function set(
		array : int[]/*unsigned short[]*/,
		offset : number/*unsigned long*/
	) : void;
	function subarray(
		start : number/*long*/,
		end : number/*long*/
	) : Uint16Array;

} // end of Uint16Array

/** @see https://www.khronos.org/registry/typedarray/specs/latest/typedarray.idl */
native final class Int32Array extends ArrayBufferView {

	function constructor(length : number/*unsigned long*/);
	function constructor(array : Int32Array);
	function constructor(array : number[]/*long[]*/);
	function constructor(array : int[]/*long[]*/);
	function constructor(buffer : ArrayBuffer);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/
	);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/,
		length : number/*unsigned long*/
	);

	static __readonly__ var BYTES_PER_ELEMENT : number/*long*/;
	       __readonly__ var BYTES_PER_ELEMENT : number/*long*/;
	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<number>/*long*/;
	/* getter */
	function get(
		index : number/*unsigned long*/
	) : Nullable.<number>/*long*/;
	/* setter */
	function set(
		index : number/*unsigned long*/,
		value : number/*long*/
	) : void;
	function set(array : Int32Array) : void;
	function set(
		array : Int32Array,
		offset : number/*unsigned long*/
	) : void;
	function set(array : number[]/*long[]*/) : void;
	function set(
		array : number[]/*long[]*/,
		offset : number/*unsigned long*/
	) : void;
	function set(array : int[]/*long[]*/) : void;
	function set(
		array : int[]/*long[]*/,
		offset : number/*unsigned long*/
	) : void;
	function subarray(
		start : number/*long*/,
		end : number/*long*/
	) : Int32Array;

} // end of Int32Array

/** @see https://www.khronos.org/registry/typedarray/specs/latest/typedarray.idl */
native final class Uint32Array extends ArrayBufferView {

	function constructor(length : number/*unsigned long*/);
	function constructor(array : Uint32Array);
	function constructor(array : number[]/*unsigned long[]*/);
	function constructor(array : int[]/*unsigned long[]*/);
	function constructor(buffer : ArrayBuffer);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/
	);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/,
		length : number/*unsigned long*/
	);

	static __readonly__ var BYTES_PER_ELEMENT : number/*long*/;
	       __readonly__ var BYTES_PER_ELEMENT : number/*long*/;
	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<number>/*unsigned long*/;
	/* getter */
	function get(
		index : number/*unsigned long*/
	) : Nullable.<number>/*unsigned long*/;
	/* setter */
	function set(
		index : number/*unsigned long*/,
		value : number/*unsigned long*/
	) : void;
	function set(array : Uint32Array) : void;
	function set(
		array : Uint32Array,
		offset : number/*unsigned long*/
	) : void;
	function set(array : number[]/*unsigned long[]*/) : void;
	function set(
		array : number[]/*unsigned long[]*/,
		offset : number/*unsigned long*/
	) : void;
	function set(array : int[]/*unsigned long[]*/) : void;
	function set(
		array : int[]/*unsigned long[]*/,
		offset : number/*unsigned long*/
	) : void;
	function subarray(
		start : number/*long*/,
		end : number/*long*/
	) : Uint32Array;

} // end of Uint32Array

/** @see https://www.khronos.org/registry/typedarray/specs/latest/typedarray.idl */
native final class Float32Array extends ArrayBufferView {

	function constructor(length : number/*unsigned long*/);
	function constructor(array : Float32Array);
	function constructor(array : number[]/*float[]*/);
	function constructor(array : int[]/*float[]*/);
	function constructor(buffer : ArrayBuffer);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/
	);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/,
		length : number/*unsigned long*/
	);

	static __readonly__ var BYTES_PER_ELEMENT : number/*long*/;
	       __readonly__ var BYTES_PER_ELEMENT : number/*long*/;
	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<number>/*float*/;
	/* getter */
	function get(
		index : number/*unsigned long*/
	) : Nullable.<number>/*float*/;
	/* setter */
	function set(
		index : number/*unsigned long*/,
		value : number/*float*/
	) : void;
	function set(array : Float32Array) : void;
	function set(
		array : Float32Array,
		offset : number/*unsigned long*/
	) : void;
	function set(array : number[]/*float[]*/) : void;
	function set(
		array : number[]/*float[]*/,
		offset : number/*unsigned long*/
	) : void;
	function set(array : int[]/*float[]*/) : void;
	function set(
		array : int[]/*float[]*/,
		offset : number/*unsigned long*/
	) : void;
	function subarray(
		start : number/*long*/,
		end : number/*long*/
	) : Float32Array;

} // end of Float32Array

/** @see https://www.khronos.org/registry/typedarray/specs/latest/typedarray.idl */
native final class Float64Array extends ArrayBufferView {

	function constructor(length : number/*unsigned long*/);
	function constructor(array : Float64Array);
	function constructor(array : number[]/*double[]*/);
	function constructor(array : int[]/*double[]*/);
	function constructor(buffer : ArrayBuffer);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/
	);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/,
		length : number/*unsigned long*/
	);

	static __readonly__ var BYTES_PER_ELEMENT : number/*long*/;
	       __readonly__ var BYTES_PER_ELEMENT : number/*long*/;
	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<number>/*double*/;
	/* getter */
	function get(
		index : number/*unsigned long*/
	) : Nullable.<number>/*double*/;
	/* setter */
	function set(
		index : number/*unsigned long*/,
		value : number/*double*/
	) : void;
	function set(array : Float64Array) : void;
	function set(
		array : Float64Array,
		offset : number/*unsigned long*/
	) : void;
	function set(array : number[]/*double[]*/) : void;
	function set(
		array : number[]/*double[]*/,
		offset : number/*unsigned long*/
	) : void;
	function set(array : int[]/*double[]*/) : void;
	function set(
		array : int[]/*double[]*/,
		offset : number/*unsigned long*/
	) : void;
	function subarray(
		start : number/*long*/,
		end : number/*long*/
	) : Float64Array;

} // end of Float64Array

/** @see https://www.khronos.org/registry/typedarray/specs/latest/typedarray.idl */
native final class DataView extends ArrayBufferView {

	function constructor(buffer : ArrayBuffer);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/
	);
	function constructor(
		buffer : ArrayBuffer,
		byteOffset : number/*unsigned long*/,
		byteLength : number/*unsigned long*/
	);

	// Gets the value of the given type at the specified byte offset
	// from the start of the view. There is no alignment constraint;
	// multi-byte values may be fetched from any offset.
	//
	// For multi-byte values, the optional littleEndian argument
	// indicates whether a big-endian or little-endian value should be
	// read. If false or undefined, a big-endian value is read.
	//
	// These methods raise an INDEX_SIZE_ERR exception if they would read
	// beyond the end of the view.
	function getInt8(
		byteOffset : number/*unsigned long*/
	) : number/*byte*/;
	function getUint8(
		byteOffset : number/*unsigned long*/
	) : number/*octet*/;
	function getInt16(
		byteOffset : number/*unsigned long*/
	) : number/*short*/;
	function getInt16(
		byteOffset : number/*unsigned long*/,
		littleEndian : boolean
	) : number/*short*/;
	function getUint16(
		byteOffset : number/*unsigned long*/
	) : number/*unsigned short*/;
	function getUint16(
		byteOffset : number/*unsigned long*/,
		littleEndian : boolean
	) : number/*unsigned short*/;
	function getInt32(
		byteOffset : number/*unsigned long*/
	) : number/*long*/;
	function getInt32(
		byteOffset : number/*unsigned long*/,
		littleEndian : boolean
	) : number/*long*/;
	function getUint32(
		byteOffset : number/*unsigned long*/
	) : number/*unsigned long*/;
	function getUint32(
		byteOffset : number/*unsigned long*/,
		littleEndian : boolean
	) : number/*unsigned long*/;
	function getFloat32(
		byteOffset : number/*unsigned long*/
	) : number/*float*/;
	function getFloat32(
		byteOffset : number/*unsigned long*/,
		littleEndian : boolean
	) : number/*float*/;
	function getFloat64(
		byteOffset : number/*unsigned long*/
	) : number/*double*/;
	function getFloat64(
		byteOffset : number/*unsigned long*/,
		littleEndian : boolean
	) : number/*double*/;
	// Stores a value of the given type at the specified byte offset
	// from the start of the view. There is no alignment constraint;
	// multi-byte values may be stored at any offset.
	//
	// For multi-byte values, the optional littleEndian argument
	// indicates whether the value should be stored in big-endian or
	// little-endian byte order. If false or undefined, the value is
	// stored in big-endian byte order.
	//
	// These methods throw exceptions if they would write beyond the end
	// of the view.
	function setInt8(
		byteOffset : number/*unsigned long*/,
		value : number/*byte*/
	) : void;
	function setUint8(
		byteOffset : number/*unsigned long*/,
		value : number/*octet*/
	) : void;
	function setInt16(
		byteOffset : number/*unsigned long*/,
		value : number/*short*/
	) : void;
	function setInt16(
		byteOffset : number/*unsigned long*/,
		value : number/*short*/,
		littleEndian : boolean
	) : void;
	function setUint16(
		byteOffset : number/*unsigned long*/,
		value : number/*unsigned short*/
	) : void;
	function setUint16(
		byteOffset : number/*unsigned long*/,
		value : number/*unsigned short*/,
		littleEndian : boolean
	) : void;
	function setInt32(
		byteOffset : number/*unsigned long*/,
		value : number/*long*/
	) : void;
	function setInt32(
		byteOffset : number/*unsigned long*/,
		value : number/*long*/,
		littleEndian : boolean
	) : void;
	function setUint32(
		byteOffset : number/*unsigned long*/,
		value : number/*unsigned long*/
	) : void;
	function setUint32(
		byteOffset : number/*unsigned long*/,
		value : number/*unsigned long*/,
		littleEndian : boolean
	) : void;
	function setFloat32(
		byteOffset : number/*unsigned long*/,
		value : number/*float*/
	) : void;
	function setFloat32(
		byteOffset : number/*unsigned long*/,
		value : number/*float*/,
		littleEndian : boolean
	) : void;
	function setFloat64(
		byteOffset : number/*unsigned long*/,
		value : number/*double*/
	) : void;
	function setFloat64(
		byteOffset : number/*unsigned long*/,
		value : number/*double*/,
		littleEndian : boolean
	) : void;

} // end of DataView

/** @see http://www.w3.org/TR/2dcontext/ */
native final class CanvasRenderingContext2D extends CanvasDrawingStyles {

	// back-reference to the canvas
	__readonly__ var canvas : HTMLCanvasElement;
	// state
	function save() : void;
	// push state on state stack
	function restore() : void;
	// pop state stack and restore state

	// transformations (default transform is the identity matrix)
	function scale(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/
	) : void;
	function rotate(angle : number/*unrestricted double*/) : void;
	function translate(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/
	) : void;
	function transform(
		a : number/*unrestricted double*/,
		b : number/*unrestricted double*/,
		c : number/*unrestricted double*/,
		d : number/*unrestricted double*/,
		e : number/*unrestricted double*/,
		f : number/*unrestricted double*/
	) : void;
	function setTransform(
		a : number/*unrestricted double*/,
		b : number/*unrestricted double*/,
		c : number/*unrestricted double*/,
		d : number/*unrestricted double*/,
		e : number/*unrestricted double*/,
		f : number/*unrestricted double*/
	) : void;
	// compositing
	var globalAlpha : number/*unrestricted double*/;
	// (default 1.0)
	var globalCompositeOperation : string/*DOMString*/;
	// (default source-over)

	// colors and styles (see also the CanvasDrawingStyles interface)
	var strokeStyle : variant/*(DOMString or CanvasGradient or CanvasPattern)*/;
	// (default black)
	var fillStyle : variant/*(DOMString or CanvasGradient or CanvasPattern)*/;
	// (default black)
	function createLinearGradient(
		x0 : number/*double*/,
		y0 : number/*double*/,
		x1 : number/*double*/,
		y1 : number/*double*/
	) : CanvasGradient;
	function createRadialGradient(
		x0 : number/*double*/,
		y0 : number/*double*/,
		r0 : number/*double*/,
		x1 : number/*double*/,
		y1 : number/*double*/,
		r1 : number/*double*/
	) : CanvasGradient;
	function createPattern(
		image : HTMLImageElement,
		repetition : string/*DOMString*/
	) : CanvasPattern;
	function createPattern(
		image : HTMLCanvasElement,
		repetition : string/*DOMString*/
	) : CanvasPattern;
	function createPattern(
		image : HTMLVideoElement,
		repetition : string/*DOMString*/
	) : CanvasPattern;
	// shadows
	var shadowOffsetX : number/*unrestricted double*/;
	// (default 0)
	var shadowOffsetY : number/*unrestricted double*/;
	// (default 0)
	var shadowBlur : number/*unrestricted double*/;
	// (default 0)
	var shadowColor : string/*DOMString*/;
	// (default transparent black)

	// rects
	function clearRect(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/,
		w : number/*unrestricted double*/,
		h : number/*unrestricted double*/
	) : void;
	function fillRect(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/,
		w : number/*unrestricted double*/,
		h : number/*unrestricted double*/
	) : void;
	function strokeRect(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/,
		w : number/*unrestricted double*/,
		h : number/*unrestricted double*/
	) : void;
	// path API (see also CanvasPathMethods)
	function beginPath() : void;
	function fill() : void;
	function fill(path : Path) : void;
	function stroke() : void;
	function stroke(path : Path) : void;
	function drawSystemFocusRing(element : Element) : void;
	function drawSystemFocusRing(path : Path, element : Element) : void;
	function drawCustomFocusRing(element : Element) : boolean;
	function drawCustomFocusRing(
		path : Path,
		element : Element
	) : boolean;
	function scrollPathIntoView() : void;
	function scrollPathIntoView(path : Path) : void;
	function clip() : void;
	function clip(path : Path) : void;
	function isPointInPath(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/
	) : boolean;
	function isPointInPath(
		path : Path,
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/
	) : boolean;
	// text (see also the CanvasDrawingStyles interface)
	function fillText(
		text : string/*DOMString*/,
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/
	) : void;
	function fillText(
		text : string/*DOMString*/,
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/,
		maxWidth : number/*unrestricted double*/
	) : void;
	function strokeText(
		text : string/*DOMString*/,
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/
	) : void;
	function strokeText(
		text : string/*DOMString*/,
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/,
		maxWidth : number/*unrestricted double*/
	) : void;
	function measureText(text : string/*DOMString*/) : TextMetrics;
	// drawing images
	function drawImage(
		image : HTMLImageElement,
		dx : number/*unrestricted double*/,
		dy : number/*unrestricted double*/
	) : void;
	function drawImage(
		image : HTMLCanvasElement,
		dx : number/*unrestricted double*/,
		dy : number/*unrestricted double*/
	) : void;
	function drawImage(
		image : HTMLVideoElement,
		dx : number/*unrestricted double*/,
		dy : number/*unrestricted double*/
	) : void;
	function drawImage(
		image : HTMLImageElement,
		dx : number/*unrestricted double*/,
		dy : number/*unrestricted double*/,
		dw : number/*unrestricted double*/,
		dh : number/*unrestricted double*/
	) : void;
	function drawImage(
		image : HTMLCanvasElement,
		dx : number/*unrestricted double*/,
		dy : number/*unrestricted double*/,
		dw : number/*unrestricted double*/,
		dh : number/*unrestricted double*/
	) : void;
	function drawImage(
		image : HTMLVideoElement,
		dx : number/*unrestricted double*/,
		dy : number/*unrestricted double*/,
		dw : number/*unrestricted double*/,
		dh : number/*unrestricted double*/
	) : void;
	function drawImage(
		image : HTMLImageElement,
		sx : number/*unrestricted double*/,
		sy : number/*unrestricted double*/,
		sw : number/*unrestricted double*/,
		sh : number/*unrestricted double*/,
		dx : number/*unrestricted double*/,
		dy : number/*unrestricted double*/,
		dw : number/*unrestricted double*/,
		dh : number/*unrestricted double*/
	) : void;
	function drawImage(
		image : HTMLCanvasElement,
		sx : number/*unrestricted double*/,
		sy : number/*unrestricted double*/,
		sw : number/*unrestricted double*/,
		sh : number/*unrestricted double*/,
		dx : number/*unrestricted double*/,
		dy : number/*unrestricted double*/,
		dw : number/*unrestricted double*/,
		dh : number/*unrestricted double*/
	) : void;
	function drawImage(
		image : HTMLVideoElement,
		sx : number/*unrestricted double*/,
		sy : number/*unrestricted double*/,
		sw : number/*unrestricted double*/,
		sh : number/*unrestricted double*/,
		dx : number/*unrestricted double*/,
		dy : number/*unrestricted double*/,
		dw : number/*unrestricted double*/,
		dh : number/*unrestricted double*/
	) : void;
	// hit regions
	function addHitRegion(options : HitRegionOptions) : void;
	function removeHitRegion(options : HitRegionOptions) : void;
	// pixel manipulation
	function createImageData(
		sw : number/*unrestricted double*/,
		sh : number/*unrestricted double*/
	) : ImageData;
	function createImageData(imagedata : ImageData) : ImageData;
	function getImageData(
		sx : number/*double*/,
		sy : number/*double*/,
		sw : number/*double*/,
		sh : number/*double*/
	) : ImageData;
	function putImageData(
		imagedata : ImageData,
		dx : number/*double*/,
		dy : number/*double*/,
		dirtyX : number/*double*/,
		dirtyY : number/*double*/,
		dirtyWidth : number/*double*/,
		dirtyHeight : number/*double*/
	) : void;
	function putImageData(
		imagedata : ImageData,
		dx : number/*double*/,
		dy : number/*double*/
	) : void;

	// implements CanvasPathMethods

	// shared path API methods
	function closePath() : void;
	function moveTo(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/
	) : void;
	function lineTo(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/
	) : void;
	function quadraticCurveTo(
		cpx : number/*unrestricted double*/,
		cpy : number/*unrestricted double*/,
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/
	) : void;
	function bezierCurveTo(
		cp1x : number/*unrestricted double*/,
		cp1y : number/*unrestricted double*/,
		cp2x : number/*unrestricted double*/,
		cp2y : number/*unrestricted double*/,
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/
	) : void;
	function arcTo(
		x1 : number/*unrestricted double*/,
		y1 : number/*unrestricted double*/,
		x2 : number/*unrestricted double*/,
		y2 : number/*unrestricted double*/,
		radius : number/*unrestricted double*/
	) : void;
	function rect(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/,
		w : number/*unrestricted double*/,
		h : number/*unrestricted double*/
	) : void;
	function arc(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/,
		radius : number/*unrestricted double*/,
		startAngle : number/*unrestricted double*/,
		endAngle : number/*unrestricted double*/
	) : void;
	function arc(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/,
		radius : number/*unrestricted double*/,
		startAngle : number/*unrestricted double*/,
		endAngle : number/*unrestricted double*/,
		anticlockwise : boolean
	) : void;
	function ellipse(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/,
		radiusX : number/*unrestricted double*/,
		radiusY : number/*unrestricted double*/,
		rotation : number/*unrestricted double*/,
		startAngle : number/*unrestricted double*/,
		endAngle : number/*unrestricted double*/,
		anticlockwise : boolean
	) : void;

} // end of CanvasRenderingContext2D

/** @see http://www.w3.org/TR/2dcontext/ */
native __fake__ class CanvasDrawingStyles {

	// line caps/joins
	var lineWidth : number/*unrestricted double*/;
	// (default 1)
	var lineCap : string/*DOMString*/;
	// "butt", "round", "square" (default "butt")
	var lineJoin : string/*DOMString*/;
	// "round", "bevel", "miter" (default "miter")
	var miterLimit : number/*unrestricted double*/;
	// (default 10)

	// dashed lines
	function setLineDash(
		segments : number[]/*sequence<unrestricted double>*/
	) : void;
	function setLineDash(
		segments : int[]/*sequence<unrestricted double>*/
	) : void;
	// default empty
	function getLineDash() : number[]/*sequence<unrestricted double>*/;
	var lineDashOffset : number/*unrestricted double*/;
	// text
	var font : string/*DOMString*/;
	// (default 10px sans-serif)
	var textAlign : string/*DOMString*/;
	// "start", "end", "left", "right", "center" (default: "start")
	var textBaseline : string/*DOMString*/;
	// "top", "hanging", "middle", "alphabetic", "ideographic", "bottom" (default: "alphabetic")

} // end of CanvasDrawingStyles

/** @see http://www.w3.org/TR/2dcontext/ */
native __fake__ class CanvasPathMethods {

	// shared path API methods
	function closePath() : void;
	function moveTo(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/
	) : void;
	function lineTo(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/
	) : void;
	function quadraticCurveTo(
		cpx : number/*unrestricted double*/,
		cpy : number/*unrestricted double*/,
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/
	) : void;
	function bezierCurveTo(
		cp1x : number/*unrestricted double*/,
		cp1y : number/*unrestricted double*/,
		cp2x : number/*unrestricted double*/,
		cp2y : number/*unrestricted double*/,
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/
	) : void;
	function arcTo(
		x1 : number/*unrestricted double*/,
		y1 : number/*unrestricted double*/,
		x2 : number/*unrestricted double*/,
		y2 : number/*unrestricted double*/,
		radius : number/*unrestricted double*/
	) : void;
	function rect(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/,
		w : number/*unrestricted double*/,
		h : number/*unrestricted double*/
	) : void;
	function arc(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/,
		radius : number/*unrestricted double*/,
		startAngle : number/*unrestricted double*/,
		endAngle : number/*unrestricted double*/
	) : void;
	function arc(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/,
		radius : number/*unrestricted double*/,
		startAngle : number/*unrestricted double*/,
		endAngle : number/*unrestricted double*/,
		anticlockwise : boolean
	) : void;
	function ellipse(
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/,
		radiusX : number/*unrestricted double*/,
		radiusY : number/*unrestricted double*/,
		rotation : number/*unrestricted double*/,
		startAngle : number/*unrestricted double*/,
		endAngle : number/*unrestricted double*/,
		anticlockwise : boolean
	) : void;

} // end of CanvasPathMethods

/** @see http://www.w3.org/TR/2dcontext/ */
native final class CanvasGradient {

	// opaque object
	function addColorStop(
		offset : number/*double*/,
		color : string/*DOMString*/
	) : void;

} // end of CanvasGradient

/** @see http://www.w3.org/TR/2dcontext/ */
native final class CanvasPattern {

	// opaque object

} // end of CanvasPattern

/** @see http://www.w3.org/TR/2dcontext/ */
native final class TextMetrics {

	// x-direction
	__readonly__ var width : number/*double*/;
	__readonly__ var actualBoundingBoxLeft : number/*double*/;
	__readonly__ var actualBoundingBoxRight : number/*double*/;
	// y-direction
	__readonly__ var fontBoundingBoxAscent : number/*double*/;
	__readonly__ var fontBoundingBoxDescent : number/*double*/;
	__readonly__ var actualBoundingBoxAscent : number/*double*/;
	__readonly__ var actualBoundingBoxDescent : number/*double*/;
	__readonly__ var emHeightAscent : number/*double*/;
	__readonly__ var emHeightDescent : number/*double*/;
	__readonly__ var hangingBaseline : number/*double*/;
	__readonly__ var alphabeticBaseline : number/*double*/;
	__readonly__ var ideographicBaseline : number/*double*/;

} // end of TextMetrics

/** @see http://www.w3.org/TR/2dcontext/ */
native final class HitRegionOptions {

	var path : Nullable.<Path>;
	var id : string/*DOMString*/;
	var parentID : Nullable.<string>/*DOMString?*/;
	var cursor : string/*DOMString*/;
	// for control-backed regions:
	var control : Nullable.<Element>;
	// for unbacked regions:
	var label : Nullable.<string>/*DOMString?*/;
	var role : Nullable.<string>/*DOMString?*/;

} // end of HitRegionOptions

/** @see http://www.w3.org/TR/2dcontext/ */
native final class ImageData {

	__readonly__ var width : number/*unsigned long*/;
	__readonly__ var height : number/*unsigned long*/;
	__readonly__ var data : Uint8ClampedArray;

} // end of ImageData

/** @see http://www.w3.org/TR/2dcontext/ */
native final class DrawingStyle extends CanvasDrawingStyles {

	function constructor();
	function constructor(scope : Element);

} // end of DrawingStyle

/** @see http://www.w3.org/TR/2dcontext/ */
native final class Path extends CanvasPathMethods {

	function constructor();

	function addPath(
		path : Path,
		transformation : Nullable.<SVGMatrix>
	) : void;
	function addPathByStrokingPath(
		path : Path,
		styles : CanvasDrawingStyles,
		transformation : Nullable.<SVGMatrix>
	) : void;
	function addText(
		text : string/*DOMString*/,
		styles : CanvasDrawingStyles,
		transformation : Nullable.<SVGMatrix>,
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/
	) : void;
	function addText(
		text : string/*DOMString*/,
		styles : CanvasDrawingStyles,
		transformation : Nullable.<SVGMatrix>,
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/,
		maxWidth : number/*unrestricted double*/
	) : void;
	function addPathByStrokingText(
		text : string/*DOMString*/,
		styles : CanvasDrawingStyles,
		transformation : Nullable.<SVGMatrix>,
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/
	) : void;
	function addPathByStrokingText(
		text : string/*DOMString*/,
		styles : CanvasDrawingStyles,
		transformation : Nullable.<SVGMatrix>,
		x : number/*unrestricted double*/,
		y : number/*unrestricted double*/,
		maxWidth : number/*unrestricted double*/
	) : void;
	function addText(
		text : string/*DOMString*/,
		styles : CanvasDrawingStyles,
		transformation : Nullable.<SVGMatrix>,
		path : Path
	) : void;
	function addText(
		text : string/*DOMString*/,
		styles : CanvasDrawingStyles,
		transformation : Nullable.<SVGMatrix>,
		path : Path,
		maxWidth : number/*unrestricted double*/
	) : void;
	function addPathByStrokingText(
		text : string/*DOMString*/,
		styles : CanvasDrawingStyles,
		transformation : Nullable.<SVGMatrix>,
		path : Path
	) : void;
	function addPathByStrokingText(
		text : string/*DOMString*/,
		styles : CanvasDrawingStyles,
		transformation : Nullable.<SVGMatrix>,
		path : Path,
		maxWidth : number/*unrestricted double*/
	) : void;

} // end of Path

/** @see https://www.khronos.org/registry/webgl/specs/latest/webgl.idl */
native final class WebGLContextAttributes {

	var alpha : boolean;
	var depth : boolean;
	var stencil : boolean;
	var antialias : boolean;
	var premultipliedAlpha : boolean;
	var preserveDrawingBuffer : boolean;

} // end of WebGLContextAttributes

/** @see https://www.khronos.org/registry/webgl/specs/latest/webgl.idl */
native class WebGLObject {
}

/** @see https://www.khronos.org/registry/webgl/specs/latest/webgl.idl */
native final class WebGLBuffer extends WebGLObject {
}

/** @see https://www.khronos.org/registry/webgl/specs/latest/webgl.idl */
native final class WebGLFramebuffer extends WebGLObject {
}

/** @see https://www.khronos.org/registry/webgl/specs/latest/webgl.idl */
native final class WebGLProgram extends WebGLObject {
}

/** @see https://www.khronos.org/registry/webgl/specs/latest/webgl.idl */
native final class WebGLRenderbuffer extends WebGLObject {
}

/** @see https://www.khronos.org/registry/webgl/specs/latest/webgl.idl */
native final class WebGLShader extends WebGLObject {
}

/** @see https://www.khronos.org/registry/webgl/specs/latest/webgl.idl */
native final class WebGLTexture extends WebGLObject {
}

/** @see https://www.khronos.org/registry/webgl/specs/latest/webgl.idl */
native final class WebGLUniformLocation {
}

/** @see https://www.khronos.org/registry/webgl/specs/latest/webgl.idl */
native final class WebGLActiveInfo {

	__readonly__ var size : number/*GLint*/;
	__readonly__ var type : number/*GLenum*/;
	__readonly__ var name : string/*DOMString*/;

} // end of WebGLActiveInfo

/** @see https://www.khronos.org/registry/webgl/specs/latest/webgl.idl */
native final class WebGLShaderPrecisionFormat {

	__readonly__ var rangeMin : number/*GLint*/;
	__readonly__ var rangeMax : number/*GLint*/;
	__readonly__ var precision : number/*GLint*/;

} // end of WebGLShaderPrecisionFormat

/** @see https://www.khronos.org/registry/webgl/specs/latest/webgl.idl */
native final class WebGLRenderingContext {

	/* ClearBufferMask */
	static __readonly__ var DEPTH_BUFFER_BIT : number/*GLenum*/;
	       __readonly__ var DEPTH_BUFFER_BIT : number/*GLenum*/;
	static __readonly__ var STENCIL_BUFFER_BIT : number/*GLenum*/;
	       __readonly__ var STENCIL_BUFFER_BIT : number/*GLenum*/;
	static __readonly__ var COLOR_BUFFER_BIT : number/*GLenum*/;
	       __readonly__ var COLOR_BUFFER_BIT : number/*GLenum*/;
	/* BeginMode */
	static __readonly__ var POINTS : number/*GLenum*/;
	       __readonly__ var POINTS : number/*GLenum*/;
	static __readonly__ var LINES : number/*GLenum*/;
	       __readonly__ var LINES : number/*GLenum*/;
	static __readonly__ var LINE_LOOP : number/*GLenum*/;
	       __readonly__ var LINE_LOOP : number/*GLenum*/;
	static __readonly__ var LINE_STRIP : number/*GLenum*/;
	       __readonly__ var LINE_STRIP : number/*GLenum*/;
	static __readonly__ var TRIANGLES : number/*GLenum*/;
	       __readonly__ var TRIANGLES : number/*GLenum*/;
	static __readonly__ var TRIANGLE_STRIP : number/*GLenum*/;
	       __readonly__ var TRIANGLE_STRIP : number/*GLenum*/;
	static __readonly__ var TRIANGLE_FAN : number/*GLenum*/;
	       __readonly__ var TRIANGLE_FAN : number/*GLenum*/;
	/* AlphaFunction (not supported in ES20) */
	/*      NEVER */
	/*      LESS */
	/*      EQUAL */
	/*      LEQUAL */
	/*      GREATER */
	/*      NOTEQUAL */
	/*      GEQUAL */
	/*      ALWAYS */

	/* BlendingFactorDest */
	static __readonly__ var ZERO : number/*GLenum*/;
	       __readonly__ var ZERO : number/*GLenum*/;
	static __readonly__ var ONE : number/*GLenum*/;
	       __readonly__ var ONE : number/*GLenum*/;
	static __readonly__ var SRC_COLOR : number/*GLenum*/;
	       __readonly__ var SRC_COLOR : number/*GLenum*/;
	static __readonly__ var ONE_MINUS_SRC_COLOR : number/*GLenum*/;
	       __readonly__ var ONE_MINUS_SRC_COLOR : number/*GLenum*/;
	static __readonly__ var SRC_ALPHA : number/*GLenum*/;
	       __readonly__ var SRC_ALPHA : number/*GLenum*/;
	static __readonly__ var ONE_MINUS_SRC_ALPHA : number/*GLenum*/;
	       __readonly__ var ONE_MINUS_SRC_ALPHA : number/*GLenum*/;
	static __readonly__ var DST_ALPHA : number/*GLenum*/;
	       __readonly__ var DST_ALPHA : number/*GLenum*/;
	static __readonly__ var ONE_MINUS_DST_ALPHA : number/*GLenum*/;
	       __readonly__ var ONE_MINUS_DST_ALPHA : number/*GLenum*/;
	/* BlendingFactorSrc */
	/*      ZERO */
	/*      ONE */
	static __readonly__ var DST_COLOR : number/*GLenum*/;
	       __readonly__ var DST_COLOR : number/*GLenum*/;
	static __readonly__ var ONE_MINUS_DST_COLOR : number/*GLenum*/;
	       __readonly__ var ONE_MINUS_DST_COLOR : number/*GLenum*/;
	static __readonly__ var SRC_ALPHA_SATURATE : number/*GLenum*/;
	       __readonly__ var SRC_ALPHA_SATURATE : number/*GLenum*/;
	/*      SRC_ALPHA */
	/*      ONE_MINUS_SRC_ALPHA */
	/*      DST_ALPHA */
	/*      ONE_MINUS_DST_ALPHA */

	/* BlendEquationSeparate */
	static __readonly__ var FUNC_ADD : number/*GLenum*/;
	       __readonly__ var FUNC_ADD : number/*GLenum*/;
	static __readonly__ var BLEND_EQUATION : number/*GLenum*/;
	       __readonly__ var BLEND_EQUATION : number/*GLenum*/;
	static __readonly__ var BLEND_EQUATION_RGB : number/*GLenum*/;
	       __readonly__ var BLEND_EQUATION_RGB : number/*GLenum*/;
	/* same as BLEND_EQUATION */
	static __readonly__ var BLEND_EQUATION_ALPHA : number/*GLenum*/;
	       __readonly__ var BLEND_EQUATION_ALPHA : number/*GLenum*/;
	/* BlendSubtract */
	static __readonly__ var FUNC_SUBTRACT : number/*GLenum*/;
	       __readonly__ var FUNC_SUBTRACT : number/*GLenum*/;
	static __readonly__ var FUNC_REVERSE_SUBTRACT : number/*GLenum*/;
	       __readonly__ var FUNC_REVERSE_SUBTRACT : number/*GLenum*/;
	/* Separate Blend Functions */
	static __readonly__ var BLEND_DST_RGB : number/*GLenum*/;
	       __readonly__ var BLEND_DST_RGB : number/*GLenum*/;
	static __readonly__ var BLEND_SRC_RGB : number/*GLenum*/;
	       __readonly__ var BLEND_SRC_RGB : number/*GLenum*/;
	static __readonly__ var BLEND_DST_ALPHA : number/*GLenum*/;
	       __readonly__ var BLEND_DST_ALPHA : number/*GLenum*/;
	static __readonly__ var BLEND_SRC_ALPHA : number/*GLenum*/;
	       __readonly__ var BLEND_SRC_ALPHA : number/*GLenum*/;
	static __readonly__ var CONSTANT_COLOR : number/*GLenum*/;
	       __readonly__ var CONSTANT_COLOR : number/*GLenum*/;
	static __readonly__ var ONE_MINUS_CONSTANT_COLOR : number/*GLenum*/;
	       __readonly__ var ONE_MINUS_CONSTANT_COLOR : number/*GLenum*/;
	static __readonly__ var CONSTANT_ALPHA : number/*GLenum*/;
	       __readonly__ var CONSTANT_ALPHA : number/*GLenum*/;
	static __readonly__ var ONE_MINUS_CONSTANT_ALPHA : number/*GLenum*/;
	       __readonly__ var ONE_MINUS_CONSTANT_ALPHA : number/*GLenum*/;
	static __readonly__ var BLEND_COLOR : number/*GLenum*/;
	       __readonly__ var BLEND_COLOR : number/*GLenum*/;
	/* Buffer Objects */
	static __readonly__ var ARRAY_BUFFER : number/*GLenum*/;
	       __readonly__ var ARRAY_BUFFER : number/*GLenum*/;
	static __readonly__ var ELEMENT_ARRAY_BUFFER : number/*GLenum*/;
	       __readonly__ var ELEMENT_ARRAY_BUFFER : number/*GLenum*/;
	static __readonly__ var ARRAY_BUFFER_BINDING : number/*GLenum*/;
	       __readonly__ var ARRAY_BUFFER_BINDING : number/*GLenum*/;
	static __readonly__ var ELEMENT_ARRAY_BUFFER_BINDING : number/*GLenum*/;
	       __readonly__ var ELEMENT_ARRAY_BUFFER_BINDING : number/*GLenum*/;
	static __readonly__ var STREAM_DRAW : number/*GLenum*/;
	       __readonly__ var STREAM_DRAW : number/*GLenum*/;
	static __readonly__ var STATIC_DRAW : number/*GLenum*/;
	       __readonly__ var STATIC_DRAW : number/*GLenum*/;
	static __readonly__ var DYNAMIC_DRAW : number/*GLenum*/;
	       __readonly__ var DYNAMIC_DRAW : number/*GLenum*/;
	static __readonly__ var BUFFER_SIZE : number/*GLenum*/;
	       __readonly__ var BUFFER_SIZE : number/*GLenum*/;
	static __readonly__ var BUFFER_USAGE : number/*GLenum*/;
	       __readonly__ var BUFFER_USAGE : number/*GLenum*/;
	static __readonly__ var CURRENT_VERTEX_ATTRIB : number/*GLenum*/;
	       __readonly__ var CURRENT_VERTEX_ATTRIB : number/*GLenum*/;
	/* CullFaceMode */
	static __readonly__ var FRONT : number/*GLenum*/;
	       __readonly__ var FRONT : number/*GLenum*/;
	static __readonly__ var BACK : number/*GLenum*/;
	       __readonly__ var BACK : number/*GLenum*/;
	static __readonly__ var FRONT_AND_BACK : number/*GLenum*/;
	       __readonly__ var FRONT_AND_BACK : number/*GLenum*/;
	/* DepthFunction */
	/*      NEVER */
	/*      LESS */
	/*      EQUAL */
	/*      LEQUAL */
	/*      GREATER */
	/*      NOTEQUAL */
	/*      GEQUAL */
	/*      ALWAYS */

	/* EnableCap */
	/* TEXTURE_2D */
	static __readonly__ var CULL_FACE : number/*GLenum*/;
	       __readonly__ var CULL_FACE : number/*GLenum*/;
	static __readonly__ var BLEND : number/*GLenum*/;
	       __readonly__ var BLEND : number/*GLenum*/;
	static __readonly__ var DITHER : number/*GLenum*/;
	       __readonly__ var DITHER : number/*GLenum*/;
	static __readonly__ var STENCIL_TEST : number/*GLenum*/;
	       __readonly__ var STENCIL_TEST : number/*GLenum*/;
	static __readonly__ var DEPTH_TEST : number/*GLenum*/;
	       __readonly__ var DEPTH_TEST : number/*GLenum*/;
	static __readonly__ var SCISSOR_TEST : number/*GLenum*/;
	       __readonly__ var SCISSOR_TEST : number/*GLenum*/;
	static __readonly__ var POLYGON_OFFSET_FILL : number/*GLenum*/;
	       __readonly__ var POLYGON_OFFSET_FILL : number/*GLenum*/;
	static __readonly__ var SAMPLE_ALPHA_TO_COVERAGE : number/*GLenum*/;
	       __readonly__ var SAMPLE_ALPHA_TO_COVERAGE : number/*GLenum*/;
	static __readonly__ var SAMPLE_COVERAGE : number/*GLenum*/;
	       __readonly__ var SAMPLE_COVERAGE : number/*GLenum*/;
	/* ErrorCode */
	static __readonly__ var NO_ERROR : number/*GLenum*/;
	       __readonly__ var NO_ERROR : number/*GLenum*/;
	static __readonly__ var INVALID_ENUM : number/*GLenum*/;
	       __readonly__ var INVALID_ENUM : number/*GLenum*/;
	static __readonly__ var INVALID_VALUE : number/*GLenum*/;
	       __readonly__ var INVALID_VALUE : number/*GLenum*/;
	static __readonly__ var INVALID_OPERATION : number/*GLenum*/;
	       __readonly__ var INVALID_OPERATION : number/*GLenum*/;
	static __readonly__ var OUT_OF_MEMORY : number/*GLenum*/;
	       __readonly__ var OUT_OF_MEMORY : number/*GLenum*/;
	/* FrontFaceDirection */
	static __readonly__ var CW : number/*GLenum*/;
	       __readonly__ var CW : number/*GLenum*/;
	static __readonly__ var CCW : number/*GLenum*/;
	       __readonly__ var CCW : number/*GLenum*/;
	/* GetPName */
	static __readonly__ var LINE_WIDTH : number/*GLenum*/;
	       __readonly__ var LINE_WIDTH : number/*GLenum*/;
	static __readonly__ var ALIASED_POINT_SIZE_RANGE : number/*GLenum*/;
	       __readonly__ var ALIASED_POINT_SIZE_RANGE : number/*GLenum*/;
	static __readonly__ var ALIASED_LINE_WIDTH_RANGE : number/*GLenum*/;
	       __readonly__ var ALIASED_LINE_WIDTH_RANGE : number/*GLenum*/;
	static __readonly__ var CULL_FACE_MODE : number/*GLenum*/;
	       __readonly__ var CULL_FACE_MODE : number/*GLenum*/;
	static __readonly__ var FRONT_FACE : number/*GLenum*/;
	       __readonly__ var FRONT_FACE : number/*GLenum*/;
	static __readonly__ var DEPTH_RANGE : number/*GLenum*/;
	       __readonly__ var DEPTH_RANGE : number/*GLenum*/;
	static __readonly__ var DEPTH_WRITEMASK : number/*GLenum*/;
	       __readonly__ var DEPTH_WRITEMASK : number/*GLenum*/;
	static __readonly__ var DEPTH_CLEAR_VALUE : number/*GLenum*/;
	       __readonly__ var DEPTH_CLEAR_VALUE : number/*GLenum*/;
	static __readonly__ var DEPTH_FUNC : number/*GLenum*/;
	       __readonly__ var DEPTH_FUNC : number/*GLenum*/;
	static __readonly__ var STENCIL_CLEAR_VALUE : number/*GLenum*/;
	       __readonly__ var STENCIL_CLEAR_VALUE : number/*GLenum*/;
	static __readonly__ var STENCIL_FUNC : number/*GLenum*/;
	       __readonly__ var STENCIL_FUNC : number/*GLenum*/;
	static __readonly__ var STENCIL_FAIL : number/*GLenum*/;
	       __readonly__ var STENCIL_FAIL : number/*GLenum*/;
	static __readonly__ var STENCIL_PASS_DEPTH_FAIL : number/*GLenum*/;
	       __readonly__ var STENCIL_PASS_DEPTH_FAIL : number/*GLenum*/;
	static __readonly__ var STENCIL_PASS_DEPTH_PASS : number/*GLenum*/;
	       __readonly__ var STENCIL_PASS_DEPTH_PASS : number/*GLenum*/;
	static __readonly__ var STENCIL_REF : number/*GLenum*/;
	       __readonly__ var STENCIL_REF : number/*GLenum*/;
	static __readonly__ var STENCIL_VALUE_MASK : number/*GLenum*/;
	       __readonly__ var STENCIL_VALUE_MASK : number/*GLenum*/;
	static __readonly__ var STENCIL_WRITEMASK : number/*GLenum*/;
	       __readonly__ var STENCIL_WRITEMASK : number/*GLenum*/;
	static __readonly__ var STENCIL_BACK_FUNC : number/*GLenum*/;
	       __readonly__ var STENCIL_BACK_FUNC : number/*GLenum*/;
	static __readonly__ var STENCIL_BACK_FAIL : number/*GLenum*/;
	       __readonly__ var STENCIL_BACK_FAIL : number/*GLenum*/;
	static __readonly__ var STENCIL_BACK_PASS_DEPTH_FAIL : number/*GLenum*/;
	       __readonly__ var STENCIL_BACK_PASS_DEPTH_FAIL : number/*GLenum*/;
	static __readonly__ var STENCIL_BACK_PASS_DEPTH_PASS : number/*GLenum*/;
	       __readonly__ var STENCIL_BACK_PASS_DEPTH_PASS : number/*GLenum*/;
	static __readonly__ var STENCIL_BACK_REF : number/*GLenum*/;
	       __readonly__ var STENCIL_BACK_REF : number/*GLenum*/;
	static __readonly__ var STENCIL_BACK_VALUE_MASK : number/*GLenum*/;
	       __readonly__ var STENCIL_BACK_VALUE_MASK : number/*GLenum*/;
	static __readonly__ var STENCIL_BACK_WRITEMASK : number/*GLenum*/;
	       __readonly__ var STENCIL_BACK_WRITEMASK : number/*GLenum*/;
	static __readonly__ var VIEWPORT : number/*GLenum*/;
	       __readonly__ var VIEWPORT : number/*GLenum*/;
	static __readonly__ var SCISSOR_BOX : number/*GLenum*/;
	       __readonly__ var SCISSOR_BOX : number/*GLenum*/;
	/*      SCISSOR_TEST */
	static __readonly__ var COLOR_CLEAR_VALUE : number/*GLenum*/;
	       __readonly__ var COLOR_CLEAR_VALUE : number/*GLenum*/;
	static __readonly__ var COLOR_WRITEMASK : number/*GLenum*/;
	       __readonly__ var COLOR_WRITEMASK : number/*GLenum*/;
	static __readonly__ var UNPACK_ALIGNMENT : number/*GLenum*/;
	       __readonly__ var UNPACK_ALIGNMENT : number/*GLenum*/;
	static __readonly__ var PACK_ALIGNMENT : number/*GLenum*/;
	       __readonly__ var PACK_ALIGNMENT : number/*GLenum*/;
	static __readonly__ var MAX_TEXTURE_SIZE : number/*GLenum*/;
	       __readonly__ var MAX_TEXTURE_SIZE : number/*GLenum*/;
	static __readonly__ var MAX_VIEWPORT_DIMS : number/*GLenum*/;
	       __readonly__ var MAX_VIEWPORT_DIMS : number/*GLenum*/;
	static __readonly__ var SUBPIXEL_BITS : number/*GLenum*/;
	       __readonly__ var SUBPIXEL_BITS : number/*GLenum*/;
	static __readonly__ var RED_BITS : number/*GLenum*/;
	       __readonly__ var RED_BITS : number/*GLenum*/;
	static __readonly__ var GREEN_BITS : number/*GLenum*/;
	       __readonly__ var GREEN_BITS : number/*GLenum*/;
	static __readonly__ var BLUE_BITS : number/*GLenum*/;
	       __readonly__ var BLUE_BITS : number/*GLenum*/;
	static __readonly__ var ALPHA_BITS : number/*GLenum*/;
	       __readonly__ var ALPHA_BITS : number/*GLenum*/;
	static __readonly__ var DEPTH_BITS : number/*GLenum*/;
	       __readonly__ var DEPTH_BITS : number/*GLenum*/;
	static __readonly__ var STENCIL_BITS : number/*GLenum*/;
	       __readonly__ var STENCIL_BITS : number/*GLenum*/;
	static __readonly__ var POLYGON_OFFSET_UNITS : number/*GLenum*/;
	       __readonly__ var POLYGON_OFFSET_UNITS : number/*GLenum*/;
	/*      POLYGON_OFFSET_FILL */
	static __readonly__ var POLYGON_OFFSET_FACTOR : number/*GLenum*/;
	       __readonly__ var POLYGON_OFFSET_FACTOR : number/*GLenum*/;
	static __readonly__ var TEXTURE_BINDING_2D : number/*GLenum*/;
	       __readonly__ var TEXTURE_BINDING_2D : number/*GLenum*/;
	static __readonly__ var SAMPLE_BUFFERS : number/*GLenum*/;
	       __readonly__ var SAMPLE_BUFFERS : number/*GLenum*/;
	static __readonly__ var SAMPLES : number/*GLenum*/;
	       __readonly__ var SAMPLES : number/*GLenum*/;
	static __readonly__ var SAMPLE_COVERAGE_VALUE : number/*GLenum*/;
	       __readonly__ var SAMPLE_COVERAGE_VALUE : number/*GLenum*/;
	static __readonly__ var SAMPLE_COVERAGE_INVERT : number/*GLenum*/;
	       __readonly__ var SAMPLE_COVERAGE_INVERT : number/*GLenum*/;
	/* GetTextureParameter */
	/*      TEXTURE_MAG_FILTER */
	/*      TEXTURE_MIN_FILTER */
	/*      TEXTURE_WRAP_S */
	/*      TEXTURE_WRAP_T */

	static __readonly__ var COMPRESSED_TEXTURE_FORMATS : number/*GLenum*/;
	       __readonly__ var COMPRESSED_TEXTURE_FORMATS : number/*GLenum*/;
	/* HintMode */
	static __readonly__ var DONT_CARE : number/*GLenum*/;
	       __readonly__ var DONT_CARE : number/*GLenum*/;
	static __readonly__ var FASTEST : number/*GLenum*/;
	       __readonly__ var FASTEST : number/*GLenum*/;
	static __readonly__ var NICEST : number/*GLenum*/;
	       __readonly__ var NICEST : number/*GLenum*/;
	/* HintTarget */
	static __readonly__ var GENERATE_MIPMAP_HINT : number/*GLenum*/;
	       __readonly__ var GENERATE_MIPMAP_HINT : number/*GLenum*/;
	/* DataType */
	static __readonly__ var BYTE : number/*GLenum*/;
	       __readonly__ var BYTE : number/*GLenum*/;
	static __readonly__ var UNSIGNED_BYTE : number/*GLenum*/;
	       __readonly__ var UNSIGNED_BYTE : number/*GLenum*/;
	static __readonly__ var SHORT : number/*GLenum*/;
	       __readonly__ var SHORT : number/*GLenum*/;
	static __readonly__ var UNSIGNED_SHORT : number/*GLenum*/;
	       __readonly__ var UNSIGNED_SHORT : number/*GLenum*/;
	static __readonly__ var INT : number/*GLenum*/;
	       __readonly__ var INT : number/*GLenum*/;
	static __readonly__ var UNSIGNED_INT : number/*GLenum*/;
	       __readonly__ var UNSIGNED_INT : number/*GLenum*/;
	static __readonly__ var FLOAT : number/*GLenum*/;
	       __readonly__ var FLOAT : number/*GLenum*/;
	/* PixelFormat */
	static __readonly__ var DEPTH_COMPONENT : number/*GLenum*/;
	       __readonly__ var DEPTH_COMPONENT : number/*GLenum*/;
	static __readonly__ var ALPHA : number/*GLenum*/;
	       __readonly__ var ALPHA : number/*GLenum*/;
	static __readonly__ var RGB : number/*GLenum*/;
	       __readonly__ var RGB : number/*GLenum*/;
	static __readonly__ var RGBA : number/*GLenum*/;
	       __readonly__ var RGBA : number/*GLenum*/;
	static __readonly__ var LUMINANCE : number/*GLenum*/;
	       __readonly__ var LUMINANCE : number/*GLenum*/;
	static __readonly__ var LUMINANCE_ALPHA : number/*GLenum*/;
	       __readonly__ var LUMINANCE_ALPHA : number/*GLenum*/;
	/* PixelType */
	/*      UNSIGNED_BYTE */
	static __readonly__ var UNSIGNED_SHORT_4_4_4_4 : number/*GLenum*/;
	       __readonly__ var UNSIGNED_SHORT_4_4_4_4 : number/*GLenum*/;
	static __readonly__ var UNSIGNED_SHORT_5_5_5_1 : number/*GLenum*/;
	       __readonly__ var UNSIGNED_SHORT_5_5_5_1 : number/*GLenum*/;
	static __readonly__ var UNSIGNED_SHORT_5_6_5 : number/*GLenum*/;
	       __readonly__ var UNSIGNED_SHORT_5_6_5 : number/*GLenum*/;
	/* Shaders */
	static __readonly__ var FRAGMENT_SHADER : number/*GLenum*/;
	       __readonly__ var FRAGMENT_SHADER : number/*GLenum*/;
	static __readonly__ var VERTEX_SHADER : number/*GLenum*/;
	       __readonly__ var VERTEX_SHADER : number/*GLenum*/;
	static __readonly__ var MAX_VERTEX_ATTRIBS : number/*GLenum*/;
	       __readonly__ var MAX_VERTEX_ATTRIBS : number/*GLenum*/;
	static __readonly__ var MAX_VERTEX_UNIFORM_VECTORS : number/*GLenum*/;
	       __readonly__ var MAX_VERTEX_UNIFORM_VECTORS : number/*GLenum*/;
	static __readonly__ var MAX_VARYING_VECTORS : number/*GLenum*/;
	       __readonly__ var MAX_VARYING_VECTORS : number/*GLenum*/;
	static __readonly__ var MAX_COMBINED_TEXTURE_IMAGE_UNITS : number/*GLenum*/;
	       __readonly__ var MAX_COMBINED_TEXTURE_IMAGE_UNITS : number/*GLenum*/;
	static __readonly__ var MAX_VERTEX_TEXTURE_IMAGE_UNITS : number/*GLenum*/;
	       __readonly__ var MAX_VERTEX_TEXTURE_IMAGE_UNITS : number/*GLenum*/;
	static __readonly__ var MAX_TEXTURE_IMAGE_UNITS : number/*GLenum*/;
	       __readonly__ var MAX_TEXTURE_IMAGE_UNITS : number/*GLenum*/;
	static __readonly__ var MAX_FRAGMENT_UNIFORM_VECTORS : number/*GLenum*/;
	       __readonly__ var MAX_FRAGMENT_UNIFORM_VECTORS : number/*GLenum*/;
	static __readonly__ var SHADER_TYPE : number/*GLenum*/;
	       __readonly__ var SHADER_TYPE : number/*GLenum*/;
	static __readonly__ var DELETE_STATUS : number/*GLenum*/;
	       __readonly__ var DELETE_STATUS : number/*GLenum*/;
	static __readonly__ var LINK_STATUS : number/*GLenum*/;
	       __readonly__ var LINK_STATUS : number/*GLenum*/;
	static __readonly__ var VALIDATE_STATUS : number/*GLenum*/;
	       __readonly__ var VALIDATE_STATUS : number/*GLenum*/;
	static __readonly__ var ATTACHED_SHADERS : number/*GLenum*/;
	       __readonly__ var ATTACHED_SHADERS : number/*GLenum*/;
	static __readonly__ var ACTIVE_UNIFORMS : number/*GLenum*/;
	       __readonly__ var ACTIVE_UNIFORMS : number/*GLenum*/;
	static __readonly__ var ACTIVE_ATTRIBUTES : number/*GLenum*/;
	       __readonly__ var ACTIVE_ATTRIBUTES : number/*GLenum*/;
	static __readonly__ var SHADING_LANGUAGE_VERSION : number/*GLenum*/;
	       __readonly__ var SHADING_LANGUAGE_VERSION : number/*GLenum*/;
	static __readonly__ var CURRENT_PROGRAM : number/*GLenum*/;
	       __readonly__ var CURRENT_PROGRAM : number/*GLenum*/;
	/* StencilFunction */
	static __readonly__ var NEVER : number/*GLenum*/;
	       __readonly__ var NEVER : number/*GLenum*/;
	static __readonly__ var LESS : number/*GLenum*/;
	       __readonly__ var LESS : number/*GLenum*/;
	static __readonly__ var EQUAL : number/*GLenum*/;
	       __readonly__ var EQUAL : number/*GLenum*/;
	static __readonly__ var LEQUAL : number/*GLenum*/;
	       __readonly__ var LEQUAL : number/*GLenum*/;
	static __readonly__ var GREATER : number/*GLenum*/;
	       __readonly__ var GREATER : number/*GLenum*/;
	static __readonly__ var NOTEQUAL : number/*GLenum*/;
	       __readonly__ var NOTEQUAL : number/*GLenum*/;
	static __readonly__ var GEQUAL : number/*GLenum*/;
	       __readonly__ var GEQUAL : number/*GLenum*/;
	static __readonly__ var ALWAYS : number/*GLenum*/;
	       __readonly__ var ALWAYS : number/*GLenum*/;
	/* StencilOp */
	/*      ZERO */
	static __readonly__ var KEEP : number/*GLenum*/;
	       __readonly__ var KEEP : number/*GLenum*/;
	static __readonly__ var REPLACE : number/*GLenum*/;
	       __readonly__ var REPLACE : number/*GLenum*/;
	static __readonly__ var INCR : number/*GLenum*/;
	       __readonly__ var INCR : number/*GLenum*/;
	static __readonly__ var DECR : number/*GLenum*/;
	       __readonly__ var DECR : number/*GLenum*/;
	static __readonly__ var INVERT : number/*GLenum*/;
	       __readonly__ var INVERT : number/*GLenum*/;
	static __readonly__ var INCR_WRAP : number/*GLenum*/;
	       __readonly__ var INCR_WRAP : number/*GLenum*/;
	static __readonly__ var DECR_WRAP : number/*GLenum*/;
	       __readonly__ var DECR_WRAP : number/*GLenum*/;
	/* StringName */
	static __readonly__ var VENDOR : number/*GLenum*/;
	       __readonly__ var VENDOR : number/*GLenum*/;
	static __readonly__ var RENDERER : number/*GLenum*/;
	       __readonly__ var RENDERER : number/*GLenum*/;
	static __readonly__ var VERSION : number/*GLenum*/;
	       __readonly__ var VERSION : number/*GLenum*/;
	/* TextureMagFilter */
	static __readonly__ var NEAREST : number/*GLenum*/;
	       __readonly__ var NEAREST : number/*GLenum*/;
	static __readonly__ var LINEAR : number/*GLenum*/;
	       __readonly__ var LINEAR : number/*GLenum*/;
	/* TextureMinFilter */
	/*      NEAREST */
	/*      LINEAR */
	static __readonly__ var NEAREST_MIPMAP_NEAREST : number/*GLenum*/;
	       __readonly__ var NEAREST_MIPMAP_NEAREST : number/*GLenum*/;
	static __readonly__ var LINEAR_MIPMAP_NEAREST : number/*GLenum*/;
	       __readonly__ var LINEAR_MIPMAP_NEAREST : number/*GLenum*/;
	static __readonly__ var NEAREST_MIPMAP_LINEAR : number/*GLenum*/;
	       __readonly__ var NEAREST_MIPMAP_LINEAR : number/*GLenum*/;
	static __readonly__ var LINEAR_MIPMAP_LINEAR : number/*GLenum*/;
	       __readonly__ var LINEAR_MIPMAP_LINEAR : number/*GLenum*/;
	/* TextureParameterName */
	static __readonly__ var TEXTURE_MAG_FILTER : number/*GLenum*/;
	       __readonly__ var TEXTURE_MAG_FILTER : number/*GLenum*/;
	static __readonly__ var TEXTURE_MIN_FILTER : number/*GLenum*/;
	       __readonly__ var TEXTURE_MIN_FILTER : number/*GLenum*/;
	static __readonly__ var TEXTURE_WRAP_S : number/*GLenum*/;
	       __readonly__ var TEXTURE_WRAP_S : number/*GLenum*/;
	static __readonly__ var TEXTURE_WRAP_T : number/*GLenum*/;
	       __readonly__ var TEXTURE_WRAP_T : number/*GLenum*/;
	/* TextureTarget */
	static __readonly__ var TEXTURE_2D : number/*GLenum*/;
	       __readonly__ var TEXTURE_2D : number/*GLenum*/;
	static __readonly__ var TEXTURE : number/*GLenum*/;
	       __readonly__ var TEXTURE : number/*GLenum*/;
	static __readonly__ var TEXTURE_CUBE_MAP : number/*GLenum*/;
	       __readonly__ var TEXTURE_CUBE_MAP : number/*GLenum*/;
	static __readonly__ var TEXTURE_BINDING_CUBE_MAP : number/*GLenum*/;
	       __readonly__ var TEXTURE_BINDING_CUBE_MAP : number/*GLenum*/;
	static __readonly__ var TEXTURE_CUBE_MAP_POSITIVE_X : number/*GLenum*/;
	       __readonly__ var TEXTURE_CUBE_MAP_POSITIVE_X : number/*GLenum*/;
	static __readonly__ var TEXTURE_CUBE_MAP_NEGATIVE_X : number/*GLenum*/;
	       __readonly__ var TEXTURE_CUBE_MAP_NEGATIVE_X : number/*GLenum*/;
	static __readonly__ var TEXTURE_CUBE_MAP_POSITIVE_Y : number/*GLenum*/;
	       __readonly__ var TEXTURE_CUBE_MAP_POSITIVE_Y : number/*GLenum*/;
	static __readonly__ var TEXTURE_CUBE_MAP_NEGATIVE_Y : number/*GLenum*/;
	       __readonly__ var TEXTURE_CUBE_MAP_NEGATIVE_Y : number/*GLenum*/;
	static __readonly__ var TEXTURE_CUBE_MAP_POSITIVE_Z : number/*GLenum*/;
	       __readonly__ var TEXTURE_CUBE_MAP_POSITIVE_Z : number/*GLenum*/;
	static __readonly__ var TEXTURE_CUBE_MAP_NEGATIVE_Z : number/*GLenum*/;
	       __readonly__ var TEXTURE_CUBE_MAP_NEGATIVE_Z : number/*GLenum*/;
	static __readonly__ var MAX_CUBE_MAP_TEXTURE_SIZE : number/*GLenum*/;
	       __readonly__ var MAX_CUBE_MAP_TEXTURE_SIZE : number/*GLenum*/;
	/* TextureUnit */
	static __readonly__ var TEXTURE0 : number/*GLenum*/;
	       __readonly__ var TEXTURE0 : number/*GLenum*/;
	static __readonly__ var TEXTURE1 : number/*GLenum*/;
	       __readonly__ var TEXTURE1 : number/*GLenum*/;
	static __readonly__ var TEXTURE2 : number/*GLenum*/;
	       __readonly__ var TEXTURE2 : number/*GLenum*/;
	static __readonly__ var TEXTURE3 : number/*GLenum*/;
	       __readonly__ var TEXTURE3 : number/*GLenum*/;
	static __readonly__ var TEXTURE4 : number/*GLenum*/;
	       __readonly__ var TEXTURE4 : number/*GLenum*/;
	static __readonly__ var TEXTURE5 : number/*GLenum*/;
	       __readonly__ var TEXTURE5 : number/*GLenum*/;
	static __readonly__ var TEXTURE6 : number/*GLenum*/;
	       __readonly__ var TEXTURE6 : number/*GLenum*/;
	static __readonly__ var TEXTURE7 : number/*GLenum*/;
	       __readonly__ var TEXTURE7 : number/*GLenum*/;
	static __readonly__ var TEXTURE8 : number/*GLenum*/;
	       __readonly__ var TEXTURE8 : number/*GLenum*/;
	static __readonly__ var TEXTURE9 : number/*GLenum*/;
	       __readonly__ var TEXTURE9 : number/*GLenum*/;
	static __readonly__ var TEXTURE10 : number/*GLenum*/;
	       __readonly__ var TEXTURE10 : number/*GLenum*/;
	static __readonly__ var TEXTURE11 : number/*GLenum*/;
	       __readonly__ var TEXTURE11 : number/*GLenum*/;
	static __readonly__ var TEXTURE12 : number/*GLenum*/;
	       __readonly__ var TEXTURE12 : number/*GLenum*/;
	static __readonly__ var TEXTURE13 : number/*GLenum*/;
	       __readonly__ var TEXTURE13 : number/*GLenum*/;
	static __readonly__ var TEXTURE14 : number/*GLenum*/;
	       __readonly__ var TEXTURE14 : number/*GLenum*/;
	static __readonly__ var TEXTURE15 : number/*GLenum*/;
	       __readonly__ var TEXTURE15 : number/*GLenum*/;
	static __readonly__ var TEXTURE16 : number/*GLenum*/;
	       __readonly__ var TEXTURE16 : number/*GLenum*/;
	static __readonly__ var TEXTURE17 : number/*GLenum*/;
	       __readonly__ var TEXTURE17 : number/*GLenum*/;
	static __readonly__ var TEXTURE18 : number/*GLenum*/;
	       __readonly__ var TEXTURE18 : number/*GLenum*/;
	static __readonly__ var TEXTURE19 : number/*GLenum*/;
	       __readonly__ var TEXTURE19 : number/*GLenum*/;
	static __readonly__ var TEXTURE20 : number/*GLenum*/;
	       __readonly__ var TEXTURE20 : number/*GLenum*/;
	static __readonly__ var TEXTURE21 : number/*GLenum*/;
	       __readonly__ var TEXTURE21 : number/*GLenum*/;
	static __readonly__ var TEXTURE22 : number/*GLenum*/;
	       __readonly__ var TEXTURE22 : number/*GLenum*/;
	static __readonly__ var TEXTURE23 : number/*GLenum*/;
	       __readonly__ var TEXTURE23 : number/*GLenum*/;
	static __readonly__ var TEXTURE24 : number/*GLenum*/;
	       __readonly__ var TEXTURE24 : number/*GLenum*/;
	static __readonly__ var TEXTURE25 : number/*GLenum*/;
	       __readonly__ var TEXTURE25 : number/*GLenum*/;
	static __readonly__ var TEXTURE26 : number/*GLenum*/;
	       __readonly__ var TEXTURE26 : number/*GLenum*/;
	static __readonly__ var TEXTURE27 : number/*GLenum*/;
	       __readonly__ var TEXTURE27 : number/*GLenum*/;
	static __readonly__ var TEXTURE28 : number/*GLenum*/;
	       __readonly__ var TEXTURE28 : number/*GLenum*/;
	static __readonly__ var TEXTURE29 : number/*GLenum*/;
	       __readonly__ var TEXTURE29 : number/*GLenum*/;
	static __readonly__ var TEXTURE30 : number/*GLenum*/;
	       __readonly__ var TEXTURE30 : number/*GLenum*/;
	static __readonly__ var TEXTURE31 : number/*GLenum*/;
	       __readonly__ var TEXTURE31 : number/*GLenum*/;
	static __readonly__ var ACTIVE_TEXTURE : number/*GLenum*/;
	       __readonly__ var ACTIVE_TEXTURE : number/*GLenum*/;
	/* TextureWrapMode */
	static __readonly__ var REPEAT : number/*GLenum*/;
	       __readonly__ var REPEAT : number/*GLenum*/;
	static __readonly__ var CLAMP_TO_EDGE : number/*GLenum*/;
	       __readonly__ var CLAMP_TO_EDGE : number/*GLenum*/;
	static __readonly__ var MIRRORED_REPEAT : number/*GLenum*/;
	       __readonly__ var MIRRORED_REPEAT : number/*GLenum*/;
	/* Uniform Types */
	static __readonly__ var FLOAT_VEC2 : number/*GLenum*/;
	       __readonly__ var FLOAT_VEC2 : number/*GLenum*/;
	static __readonly__ var FLOAT_VEC3 : number/*GLenum*/;
	       __readonly__ var FLOAT_VEC3 : number/*GLenum*/;
	static __readonly__ var FLOAT_VEC4 : number/*GLenum*/;
	       __readonly__ var FLOAT_VEC4 : number/*GLenum*/;
	static __readonly__ var INT_VEC2 : number/*GLenum*/;
	       __readonly__ var INT_VEC2 : number/*GLenum*/;
	static __readonly__ var INT_VEC3 : number/*GLenum*/;
	       __readonly__ var INT_VEC3 : number/*GLenum*/;
	static __readonly__ var INT_VEC4 : number/*GLenum*/;
	       __readonly__ var INT_VEC4 : number/*GLenum*/;
	static __readonly__ var BOOL : number/*GLenum*/;
	       __readonly__ var BOOL : number/*GLenum*/;
	static __readonly__ var BOOL_VEC2 : number/*GLenum*/;
	       __readonly__ var BOOL_VEC2 : number/*GLenum*/;
	static __readonly__ var BOOL_VEC3 : number/*GLenum*/;
	       __readonly__ var BOOL_VEC3 : number/*GLenum*/;
	static __readonly__ var BOOL_VEC4 : number/*GLenum*/;
	       __readonly__ var BOOL_VEC4 : number/*GLenum*/;
	static __readonly__ var FLOAT_MAT2 : number/*GLenum*/;
	       __readonly__ var FLOAT_MAT2 : number/*GLenum*/;
	static __readonly__ var FLOAT_MAT3 : number/*GLenum*/;
	       __readonly__ var FLOAT_MAT3 : number/*GLenum*/;
	static __readonly__ var FLOAT_MAT4 : number/*GLenum*/;
	       __readonly__ var FLOAT_MAT4 : number/*GLenum*/;
	static __readonly__ var SAMPLER_2D : number/*GLenum*/;
	       __readonly__ var SAMPLER_2D : number/*GLenum*/;
	static __readonly__ var SAMPLER_CUBE : number/*GLenum*/;
	       __readonly__ var SAMPLER_CUBE : number/*GLenum*/;
	/* Vertex Arrays */
	static __readonly__ var VERTEX_ATTRIB_ARRAY_ENABLED : number/*GLenum*/;
	       __readonly__ var VERTEX_ATTRIB_ARRAY_ENABLED : number/*GLenum*/;
	static __readonly__ var VERTEX_ATTRIB_ARRAY_SIZE : number/*GLenum*/;
	       __readonly__ var VERTEX_ATTRIB_ARRAY_SIZE : number/*GLenum*/;
	static __readonly__ var VERTEX_ATTRIB_ARRAY_STRIDE : number/*GLenum*/;
	       __readonly__ var VERTEX_ATTRIB_ARRAY_STRIDE : number/*GLenum*/;
	static __readonly__ var VERTEX_ATTRIB_ARRAY_TYPE : number/*GLenum*/;
	       __readonly__ var VERTEX_ATTRIB_ARRAY_TYPE : number/*GLenum*/;
	static __readonly__ var VERTEX_ATTRIB_ARRAY_NORMALIZED : number/*GLenum*/;
	       __readonly__ var VERTEX_ATTRIB_ARRAY_NORMALIZED : number/*GLenum*/;
	static __readonly__ var VERTEX_ATTRIB_ARRAY_POINTER : number/*GLenum*/;
	       __readonly__ var VERTEX_ATTRIB_ARRAY_POINTER : number/*GLenum*/;
	static __readonly__ var VERTEX_ATTRIB_ARRAY_BUFFER_BINDING : number/*GLenum*/;
	       __readonly__ var VERTEX_ATTRIB_ARRAY_BUFFER_BINDING : number/*GLenum*/;
	/* Shader Source */
	static __readonly__ var COMPILE_STATUS : number/*GLenum*/;
	       __readonly__ var COMPILE_STATUS : number/*GLenum*/;
	/* Shader Precision-Specified Types */
	static __readonly__ var LOW_FLOAT : number/*GLenum*/;
	       __readonly__ var LOW_FLOAT : number/*GLenum*/;
	static __readonly__ var MEDIUM_FLOAT : number/*GLenum*/;
	       __readonly__ var MEDIUM_FLOAT : number/*GLenum*/;
	static __readonly__ var HIGH_FLOAT : number/*GLenum*/;
	       __readonly__ var HIGH_FLOAT : number/*GLenum*/;
	static __readonly__ var LOW_INT : number/*GLenum*/;
	       __readonly__ var LOW_INT : number/*GLenum*/;
	static __readonly__ var MEDIUM_INT : number/*GLenum*/;
	       __readonly__ var MEDIUM_INT : number/*GLenum*/;
	static __readonly__ var HIGH_INT : number/*GLenum*/;
	       __readonly__ var HIGH_INT : number/*GLenum*/;
	/* Framebuffer Object. */
	static __readonly__ var FRAMEBUFFER : number/*GLenum*/;
	       __readonly__ var FRAMEBUFFER : number/*GLenum*/;
	static __readonly__ var RENDERBUFFER : number/*GLenum*/;
	       __readonly__ var RENDERBUFFER : number/*GLenum*/;
	static __readonly__ var RGBA4 : number/*GLenum*/;
	       __readonly__ var RGBA4 : number/*GLenum*/;
	static __readonly__ var RGB5_A1 : number/*GLenum*/;
	       __readonly__ var RGB5_A1 : number/*GLenum*/;
	static __readonly__ var RGB565 : number/*GLenum*/;
	       __readonly__ var RGB565 : number/*GLenum*/;
	static __readonly__ var DEPTH_COMPONENT16 : number/*GLenum*/;
	       __readonly__ var DEPTH_COMPONENT16 : number/*GLenum*/;
	static __readonly__ var STENCIL_INDEX : number/*GLenum*/;
	       __readonly__ var STENCIL_INDEX : number/*GLenum*/;
	static __readonly__ var STENCIL_INDEX8 : number/*GLenum*/;
	       __readonly__ var STENCIL_INDEX8 : number/*GLenum*/;
	static __readonly__ var DEPTH_STENCIL : number/*GLenum*/;
	       __readonly__ var DEPTH_STENCIL : number/*GLenum*/;
	static __readonly__ var RENDERBUFFER_WIDTH : number/*GLenum*/;
	       __readonly__ var RENDERBUFFER_WIDTH : number/*GLenum*/;
	static __readonly__ var RENDERBUFFER_HEIGHT : number/*GLenum*/;
	       __readonly__ var RENDERBUFFER_HEIGHT : number/*GLenum*/;
	static __readonly__ var RENDERBUFFER_INTERNAL_FORMAT : number/*GLenum*/;
	       __readonly__ var RENDERBUFFER_INTERNAL_FORMAT : number/*GLenum*/;
	static __readonly__ var RENDERBUFFER_RED_SIZE : number/*GLenum*/;
	       __readonly__ var RENDERBUFFER_RED_SIZE : number/*GLenum*/;
	static __readonly__ var RENDERBUFFER_GREEN_SIZE : number/*GLenum*/;
	       __readonly__ var RENDERBUFFER_GREEN_SIZE : number/*GLenum*/;
	static __readonly__ var RENDERBUFFER_BLUE_SIZE : number/*GLenum*/;
	       __readonly__ var RENDERBUFFER_BLUE_SIZE : number/*GLenum*/;
	static __readonly__ var RENDERBUFFER_ALPHA_SIZE : number/*GLenum*/;
	       __readonly__ var RENDERBUFFER_ALPHA_SIZE : number/*GLenum*/;
	static __readonly__ var RENDERBUFFER_DEPTH_SIZE : number/*GLenum*/;
	       __readonly__ var RENDERBUFFER_DEPTH_SIZE : number/*GLenum*/;
	static __readonly__ var RENDERBUFFER_STENCIL_SIZE : number/*GLenum*/;
	       __readonly__ var RENDERBUFFER_STENCIL_SIZE : number/*GLenum*/;
	static __readonly__ var FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE : number/*GLenum*/;
	       __readonly__ var FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE : number/*GLenum*/;
	static __readonly__ var FRAMEBUFFER_ATTACHMENT_OBJECT_NAME : number/*GLenum*/;
	       __readonly__ var FRAMEBUFFER_ATTACHMENT_OBJECT_NAME : number/*GLenum*/;
	static __readonly__ var FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL : number/*GLenum*/;
	       __readonly__ var FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL : number/*GLenum*/;
	static __readonly__ var FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE : number/*GLenum*/;
	       __readonly__ var FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE : number/*GLenum*/;
	static __readonly__ var COLOR_ATTACHMENT0 : number/*GLenum*/;
	       __readonly__ var COLOR_ATTACHMENT0 : number/*GLenum*/;
	static __readonly__ var DEPTH_ATTACHMENT : number/*GLenum*/;
	       __readonly__ var DEPTH_ATTACHMENT : number/*GLenum*/;
	static __readonly__ var STENCIL_ATTACHMENT : number/*GLenum*/;
	       __readonly__ var STENCIL_ATTACHMENT : number/*GLenum*/;
	static __readonly__ var DEPTH_STENCIL_ATTACHMENT : number/*GLenum*/;
	       __readonly__ var DEPTH_STENCIL_ATTACHMENT : number/*GLenum*/;
	static __readonly__ var NONE : number/*GLenum*/;
	       __readonly__ var NONE : number/*GLenum*/;
	static __readonly__ var FRAMEBUFFER_COMPLETE : number/*GLenum*/;
	       __readonly__ var FRAMEBUFFER_COMPLETE : number/*GLenum*/;
	static __readonly__ var FRAMEBUFFER_INCOMPLETE_ATTACHMENT : number/*GLenum*/;
	       __readonly__ var FRAMEBUFFER_INCOMPLETE_ATTACHMENT : number/*GLenum*/;
	static __readonly__ var FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT : number/*GLenum*/;
	       __readonly__ var FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT : number/*GLenum*/;
	static __readonly__ var FRAMEBUFFER_INCOMPLETE_DIMENSIONS : number/*GLenum*/;
	       __readonly__ var FRAMEBUFFER_INCOMPLETE_DIMENSIONS : number/*GLenum*/;
	static __readonly__ var FRAMEBUFFER_UNSUPPORTED : number/*GLenum*/;
	       __readonly__ var FRAMEBUFFER_UNSUPPORTED : number/*GLenum*/;
	static __readonly__ var FRAMEBUFFER_BINDING : number/*GLenum*/;
	       __readonly__ var FRAMEBUFFER_BINDING : number/*GLenum*/;
	static __readonly__ var RENDERBUFFER_BINDING : number/*GLenum*/;
	       __readonly__ var RENDERBUFFER_BINDING : number/*GLenum*/;
	static __readonly__ var MAX_RENDERBUFFER_SIZE : number/*GLenum*/;
	       __readonly__ var MAX_RENDERBUFFER_SIZE : number/*GLenum*/;
	static __readonly__ var INVALID_FRAMEBUFFER_OPERATION : number/*GLenum*/;
	       __readonly__ var INVALID_FRAMEBUFFER_OPERATION : number/*GLenum*/;
	/* WebGL-specific enums */
	static __readonly__ var UNPACK_FLIP_Y_WEBGL : number/*GLenum*/;
	       __readonly__ var UNPACK_FLIP_Y_WEBGL : number/*GLenum*/;
	static __readonly__ var UNPACK_PREMULTIPLY_ALPHA_WEBGL : number/*GLenum*/;
	       __readonly__ var UNPACK_PREMULTIPLY_ALPHA_WEBGL : number/*GLenum*/;
	static __readonly__ var CONTEXT_LOST_WEBGL : number/*GLenum*/;
	       __readonly__ var CONTEXT_LOST_WEBGL : number/*GLenum*/;
	static __readonly__ var UNPACK_COLORSPACE_CONVERSION_WEBGL : number/*GLenum*/;
	       __readonly__ var UNPACK_COLORSPACE_CONVERSION_WEBGL : number/*GLenum*/;
	static __readonly__ var BROWSER_DEFAULT_WEBGL : number/*GLenum*/;
	       __readonly__ var BROWSER_DEFAULT_WEBGL : number/*GLenum*/;
	__readonly__ var canvas : HTMLCanvasElement;
	__readonly__ var drawingBufferWidth : number/*GLsizei*/;
	__readonly__ var drawingBufferHeight : number/*GLsizei*/;
	function getContextAttributes() : Nullable.<WebGLContextAttributes>;
	function isContextLost() : boolean;
	function getSupportedExtensions() : Nullable.<string[]>/*sequence<DOMString>?*/;
	function getExtension(
		name : string/*DOMString*/
	) : Nullable.<Object>/*object?*/;
	function activeTexture(texture : number/*GLenum*/) : void;
	function attachShader(
		program : Nullable.<WebGLProgram>,
		shader : Nullable.<WebGLShader>
	) : void;
	function bindAttribLocation(
		program : Nullable.<WebGLProgram>,
		index : number/*GLuint*/,
		name : string/*DOMString*/
	) : void;
	function bindBuffer(
		target : number/*GLenum*/,
		buffer : Nullable.<WebGLBuffer>
	) : void;
	function bindFramebuffer(
		target : number/*GLenum*/,
		framebuffer : Nullable.<WebGLFramebuffer>
	) : void;
	function bindRenderbuffer(
		target : number/*GLenum*/,
		renderbuffer : Nullable.<WebGLRenderbuffer>
	) : void;
	function bindTexture(
		target : number/*GLenum*/,
		texture : Nullable.<WebGLTexture>
	) : void;
	function blendColor(
		red : number/*GLclampf*/,
		green : number/*GLclampf*/,
		blue : number/*GLclampf*/,
		alpha : number/*GLclampf*/
	) : void;
	function blendEquation(mode : number/*GLenum*/) : void;
	function blendEquationSeparate(
		modeRGB : number/*GLenum*/,
		modeAlpha : number/*GLenum*/
	) : void;
	function blendFunc(
		sfactor : number/*GLenum*/,
		dfactor : number/*GLenum*/
	) : void;
	function blendFuncSeparate(
		srcRGB : number/*GLenum*/,
		dstRGB : number/*GLenum*/,
		srcAlpha : number/*GLenum*/,
		dstAlpha : number/*GLenum*/
	) : void;
	function bufferData(
		target : number/*GLenum*/,
		size : number/*GLsizeiptr*/,
		usage : number/*GLenum*/
	) : void;
	function bufferData(
		target : number/*GLenum*/,
		data : ArrayBufferView,
		usage : number/*GLenum*/
	) : void;
	function bufferData(
		target : number/*GLenum*/,
		data : Nullable.<ArrayBuffer>,
		usage : number/*GLenum*/
	) : void;
	function bufferSubData(
		target : number/*GLenum*/,
		offset : number/*GLintptr*/,
		data : ArrayBufferView
	) : void;
	function bufferSubData(
		target : number/*GLenum*/,
		offset : number/*GLintptr*/,
		data : Nullable.<ArrayBuffer>
	) : void;
	function checkFramebufferStatus(
		target : number/*GLenum*/
	) : number/*GLenum*/;
	function clear(mask : number/*GLbitfield*/) : void;
	function clearColor(
		red : number/*GLclampf*/,
		green : number/*GLclampf*/,
		blue : number/*GLclampf*/,
		alpha : number/*GLclampf*/
	) : void;
	function clearDepth(depth : number/*GLclampf*/) : void;
	function clearStencil(s : number/*GLint*/) : void;
	function colorMask(
		red : boolean/*GLboolean*/,
		green : boolean/*GLboolean*/,
		blue : boolean/*GLboolean*/,
		alpha : boolean/*GLboolean*/
	) : void;
	function compileShader(shader : Nullable.<WebGLShader>) : void;
	function compressedTexImage2D(
		target : number/*GLenum*/,
		level : number/*GLint*/,
		internalformat : number/*GLenum*/,
		width : number/*GLsizei*/,
		height : number/*GLsizei*/,
		border : number/*GLint*/,
		data : ArrayBufferView
	) : void;
	function compressedTexSubImage2D(
		target : number/*GLenum*/,
		level : number/*GLint*/,
		xoffset : number/*GLint*/,
		yoffset : number/*GLint*/,
		width : number/*GLsizei*/,
		height : number/*GLsizei*/,
		format : number/*GLenum*/,
		data : ArrayBufferView
	) : void;
	function copyTexImage2D(
		target : number/*GLenum*/,
		level : number/*GLint*/,
		internalformat : number/*GLenum*/,
		x : number/*GLint*/,
		y : number/*GLint*/,
		width : number/*GLsizei*/,
		height : number/*GLsizei*/,
		border : number/*GLint*/
	) : void;
	function copyTexSubImage2D(
		target : number/*GLenum*/,
		level : number/*GLint*/,
		xoffset : number/*GLint*/,
		yoffset : number/*GLint*/,
		x : number/*GLint*/,
		y : number/*GLint*/,
		width : number/*GLsizei*/,
		height : number/*GLsizei*/
	) : void;
	function createBuffer() : Nullable.<WebGLBuffer>;
	function createFramebuffer() : Nullable.<WebGLFramebuffer>;
	function createProgram() : Nullable.<WebGLProgram>;
	function createRenderbuffer() : Nullable.<WebGLRenderbuffer>;
	function createShader(
		type : number/*GLenum*/
	) : Nullable.<WebGLShader>;
	function createTexture() : Nullable.<WebGLTexture>;
	function cullFace(mode : number/*GLenum*/) : void;
	function deleteBuffer(buffer : Nullable.<WebGLBuffer>) : void;
	function deleteFramebuffer(
		framebuffer : Nullable.<WebGLFramebuffer>
	) : void;
	function deleteProgram(program : Nullable.<WebGLProgram>) : void;
	function deleteRenderbuffer(
		renderbuffer : Nullable.<WebGLRenderbuffer>
	) : void;
	function deleteShader(shader : Nullable.<WebGLShader>) : void;
	function deleteTexture(texture : Nullable.<WebGLTexture>) : void;
	function depthFunc(func : number/*GLenum*/) : void;
	function depthMask(flag : boolean/*GLboolean*/) : void;
	function depthRange(
		zNear : number/*GLclampf*/,
		zFar : number/*GLclampf*/
	) : void;
	function detachShader(
		program : Nullable.<WebGLProgram>,
		shader : Nullable.<WebGLShader>
	) : void;
	function disable(cap : number/*GLenum*/) : void;
	function disableVertexAttribArray(index : number/*GLuint*/) : void;
	function drawArrays(
		mode : number/*GLenum*/,
		first : number/*GLint*/,
		count : number/*GLsizei*/
	) : void;
	function drawElements(
		mode : number/*GLenum*/,
		count : number/*GLsizei*/,
		type : number/*GLenum*/,
		offset : number/*GLintptr*/
	) : void;
	function enable(cap : number/*GLenum*/) : void;
	function enableVertexAttribArray(index : number/*GLuint*/) : void;
	function finish() : void;
	function flush() : void;
	function framebufferRenderbuffer(
		target : number/*GLenum*/,
		attachment : number/*GLenum*/,
		renderbuffertarget : number/*GLenum*/,
		renderbuffer : Nullable.<WebGLRenderbuffer>
	) : void;
	function framebufferTexture2D(
		target : number/*GLenum*/,
		attachment : number/*GLenum*/,
		textarget : number/*GLenum*/,
		texture : Nullable.<WebGLTexture>,
		level : number/*GLint*/
	) : void;
	function frontFace(mode : number/*GLenum*/) : void;
	function generateMipmap(target : number/*GLenum*/) : void;
	function getActiveAttrib(
		program : Nullable.<WebGLProgram>,
		index : number/*GLuint*/
	) : Nullable.<WebGLActiveInfo>;
	function getActiveUniform(
		program : Nullable.<WebGLProgram>,
		index : number/*GLuint*/
	) : Nullable.<WebGLActiveInfo>;
	function getAttachedShaders(
		program : Nullable.<WebGLProgram>
	) : Nullable.<WebGLShader[]>;
	function getAttribLocation(
		program : Nullable.<WebGLProgram>,
		name : string/*DOMString*/
	) : number/*GLint*/;
	function getBufferParameter(
		target : number/*GLenum*/,
		pname : number/*GLenum*/
	) : variant/*any*/;
	function getParameter(pname : number/*GLenum*/) : variant/*any*/;
	function getError() : number/*GLenum*/;
	function getFramebufferAttachmentParameter(
		target : number/*GLenum*/,
		attachment : number/*GLenum*/,
		pname : number/*GLenum*/
	) : variant/*any*/;
	function getProgramParameter(
		program : Nullable.<WebGLProgram>,
		pname : number/*GLenum*/
	) : variant/*any*/;
	function getProgramInfoLog(
		program : Nullable.<WebGLProgram>
	) : Nullable.<string>/*DOMString?*/;
	function getRenderbufferParameter(
		target : number/*GLenum*/,
		pname : number/*GLenum*/
	) : variant/*any*/;
	function getShaderParameter(
		shader : Nullable.<WebGLShader>,
		pname : number/*GLenum*/
	) : variant/*any*/;
	function getShaderPrecisionFormat(
		shadertype : number/*GLenum*/,
		precisiontype : number/*GLenum*/
	) : Nullable.<WebGLShaderPrecisionFormat>;
	function getShaderInfoLog(
		shader : Nullable.<WebGLShader>
	) : Nullable.<string>/*DOMString?*/;
	function getShaderSource(
		shader : Nullable.<WebGLShader>
	) : Nullable.<string>/*DOMString?*/;
	function getTexParameter(
		target : number/*GLenum*/,
		pname : number/*GLenum*/
	) : variant/*any*/;
	function getUniform(
		program : Nullable.<WebGLProgram>,
		location : Nullable.<WebGLUniformLocation>
	) : variant/*any*/;
	function getUniformLocation(
		program : Nullable.<WebGLProgram>,
		name : string/*DOMString*/
	) : Nullable.<WebGLUniformLocation>;
	function getVertexAttrib(
		index : number/*GLuint*/,
		pname : number/*GLenum*/
	) : variant/*any*/;
	function getVertexAttribOffset(
		index : number/*GLuint*/,
		pname : number/*GLenum*/
	) : number/*GLsizeiptr*/;
	function hint(
		target : number/*GLenum*/,
		mode : number/*GLenum*/
	) : void;
	function isBuffer(
		buffer : Nullable.<WebGLBuffer>
	) : boolean/*GLboolean*/;
	function isEnabled(cap : number/*GLenum*/) : boolean/*GLboolean*/;
	function isFramebuffer(
		framebuffer : Nullable.<WebGLFramebuffer>
	) : boolean/*GLboolean*/;
	function isProgram(
		program : Nullable.<WebGLProgram>
	) : boolean/*GLboolean*/;
	function isRenderbuffer(
		renderbuffer : Nullable.<WebGLRenderbuffer>
	) : boolean/*GLboolean*/;
	function isShader(
		shader : Nullable.<WebGLShader>
	) : boolean/*GLboolean*/;
	function isTexture(
		texture : Nullable.<WebGLTexture>
	) : boolean/*GLboolean*/;
	function lineWidth(width : number/*GLfloat*/) : void;
	function linkProgram(program : Nullable.<WebGLProgram>) : void;
	function pixelStorei(
		pname : number/*GLenum*/,
		param : number/*GLint*/
	) : void;
	function polygonOffset(
		factor : number/*GLfloat*/,
		units : number/*GLfloat*/
	) : void;
	function readPixels(
		x : number/*GLint*/,
		y : number/*GLint*/,
		width : number/*GLsizei*/,
		height : number/*GLsizei*/,
		format : number/*GLenum*/,
		type : number/*GLenum*/,
		pixels : Nullable.<ArrayBufferView>
	) : void;
	function renderbufferStorage(
		target : number/*GLenum*/,
		internalformat : number/*GLenum*/,
		width : number/*GLsizei*/,
		height : number/*GLsizei*/
	) : void;
	function sampleCoverage(
		value : number/*GLclampf*/,
		invert : boolean/*GLboolean*/
	) : void;
	function scissor(
		x : number/*GLint*/,
		y : number/*GLint*/,
		width : number/*GLsizei*/,
		height : number/*GLsizei*/
	) : void;
	function shaderSource(
		shader : Nullable.<WebGLShader>,
		source : string/*DOMString*/
	) : void;
	function stencilFunc(
		func : number/*GLenum*/,
		ref : number/*GLint*/,
		mask : number/*GLuint*/
	) : void;
	function stencilFuncSeparate(
		face : number/*GLenum*/,
		func : number/*GLenum*/,
		ref : number/*GLint*/,
		mask : number/*GLuint*/
	) : void;
	function stencilMask(mask : number/*GLuint*/) : void;
	function stencilMaskSeparate(
		face : number/*GLenum*/,
		mask : number/*GLuint*/
	) : void;
	function stencilOp(
		fail : number/*GLenum*/,
		zfail : number/*GLenum*/,
		zpass : number/*GLenum*/
	) : void;
	function stencilOpSeparate(
		face : number/*GLenum*/,
		fail : number/*GLenum*/,
		zfail : number/*GLenum*/,
		zpass : number/*GLenum*/
	) : void;
	function texImage2D(
		target : number/*GLenum*/,
		level : number/*GLint*/,
		internalformat : number/*GLenum*/,
		width : number/*GLsizei*/,
		height : number/*GLsizei*/,
		border : number/*GLint*/,
		format : number/*GLenum*/,
		type : number/*GLenum*/,
		pixels : Nullable.<ArrayBufferView>
	) : void;
	function texImage2D(
		target : number/*GLenum*/,
		level : number/*GLint*/,
		internalformat : number/*GLenum*/,
		format : number/*GLenum*/,
		type : number/*GLenum*/,
		pixels : Nullable.<ImageData>
	) : void;
	function texImage2D(
		target : number/*GLenum*/,
		level : number/*GLint*/,
		internalformat : number/*GLenum*/,
		format : number/*GLenum*/,
		type : number/*GLenum*/,
		image : HTMLImageElement
	) : void;
	// May throw DOMException
	function texImage2D(
		target : number/*GLenum*/,
		level : number/*GLint*/,
		internalformat : number/*GLenum*/,
		format : number/*GLenum*/,
		type : number/*GLenum*/,
		canvas : HTMLCanvasElement
	) : void;
	// May throw DOMException
	function texImage2D(
		target : number/*GLenum*/,
		level : number/*GLint*/,
		internalformat : number/*GLenum*/,
		format : number/*GLenum*/,
		type : number/*GLenum*/,
		video : HTMLVideoElement
	) : void;
	// May throw DOMException

	function texParameterf(
		target : number/*GLenum*/,
		pname : number/*GLenum*/,
		param : number/*GLfloat*/
	) : void;
	function texParameteri(
		target : number/*GLenum*/,
		pname : number/*GLenum*/,
		param : number/*GLint*/
	) : void;
	function texSubImage2D(
		target : number/*GLenum*/,
		level : number/*GLint*/,
		xoffset : number/*GLint*/,
		yoffset : number/*GLint*/,
		width : number/*GLsizei*/,
		height : number/*GLsizei*/,
		format : number/*GLenum*/,
		type : number/*GLenum*/,
		pixels : Nullable.<ArrayBufferView>
	) : void;
	function texSubImage2D(
		target : number/*GLenum*/,
		level : number/*GLint*/,
		xoffset : number/*GLint*/,
		yoffset : number/*GLint*/,
		format : number/*GLenum*/,
		type : number/*GLenum*/,
		pixels : Nullable.<ImageData>
	) : void;
	function texSubImage2D(
		target : number/*GLenum*/,
		level : number/*GLint*/,
		xoffset : number/*GLint*/,
		yoffset : number/*GLint*/,
		format : number/*GLenum*/,
		type : number/*GLenum*/,
		image : HTMLImageElement
	) : void;
	// May throw DOMException
	function texSubImage2D(
		target : number/*GLenum*/,
		level : number/*GLint*/,
		xoffset : number/*GLint*/,
		yoffset : number/*GLint*/,
		format : number/*GLenum*/,
		type : number/*GLenum*/,
		canvas : HTMLCanvasElement
	) : void;
	// May throw DOMException
	function texSubImage2D(
		target : number/*GLenum*/,
		level : number/*GLint*/,
		xoffset : number/*GLint*/,
		yoffset : number/*GLint*/,
		format : number/*GLenum*/,
		type : number/*GLenum*/,
		video : HTMLVideoElement
	) : void;
	// May throw DOMException

	function uniform1f(
		location : Nullable.<WebGLUniformLocation>,
		x : number/*GLfloat*/
	) : void;
	function uniform1fv(
		location : Nullable.<WebGLUniformLocation>,
		v : Float32Array
	) : void;
	function uniform1fv(
		location : Nullable.<WebGLUniformLocation>,
		v : number[]/*sequence<GLfloat>*/
	) : void;
	function uniform1fv(
		location : Nullable.<WebGLUniformLocation>,
		v : int[]/*sequence<GLfloat>*/
	) : void;
	function uniform1i(
		location : Nullable.<WebGLUniformLocation>,
		x : number/*GLint*/
	) : void;
	function uniform1iv(
		location : Nullable.<WebGLUniformLocation>,
		v : Int32Array
	) : void;
	function uniform1iv(
		location : Nullable.<WebGLUniformLocation>,
		v : number[]/*sequence<long>*/
	) : void;
	function uniform1iv(
		location : Nullable.<WebGLUniformLocation>,
		v : int[]/*sequence<long>*/
	) : void;
	function uniform2f(
		location : Nullable.<WebGLUniformLocation>,
		x : number/*GLfloat*/,
		y : number/*GLfloat*/
	) : void;
	function uniform2fv(
		location : Nullable.<WebGLUniformLocation>,
		v : Float32Array
	) : void;
	function uniform2fv(
		location : Nullable.<WebGLUniformLocation>,
		v : number[]/*sequence<GLfloat>*/
	) : void;
	function uniform2fv(
		location : Nullable.<WebGLUniformLocation>,
		v : int[]/*sequence<GLfloat>*/
	) : void;
	function uniform2i(
		location : Nullable.<WebGLUniformLocation>,
		x : number/*GLint*/,
		y : number/*GLint*/
	) : void;
	function uniform2iv(
		location : Nullable.<WebGLUniformLocation>,
		v : Int32Array
	) : void;
	function uniform2iv(
		location : Nullable.<WebGLUniformLocation>,
		v : number[]/*sequence<long>*/
	) : void;
	function uniform2iv(
		location : Nullable.<WebGLUniformLocation>,
		v : int[]/*sequence<long>*/
	) : void;
	function uniform3f(
		location : Nullable.<WebGLUniformLocation>,
		x : number/*GLfloat*/,
		y : number/*GLfloat*/,
		z : number/*GLfloat*/
	) : void;
	function uniform3fv(
		location : Nullable.<WebGLUniformLocation>,
		v : Float32Array
	) : void;
	function uniform3fv(
		location : Nullable.<WebGLUniformLocation>,
		v : number[]/*sequence<GLfloat>*/
	) : void;
	function uniform3fv(
		location : Nullable.<WebGLUniformLocation>,
		v : int[]/*sequence<GLfloat>*/
	) : void;
	function uniform3i(
		location : Nullable.<WebGLUniformLocation>,
		x : number/*GLint*/,
		y : number/*GLint*/,
		z : number/*GLint*/
	) : void;
	function uniform3iv(
		location : Nullable.<WebGLUniformLocation>,
		v : Int32Array
	) : void;
	function uniform3iv(
		location : Nullable.<WebGLUniformLocation>,
		v : number[]/*sequence<long>*/
	) : void;
	function uniform3iv(
		location : Nullable.<WebGLUniformLocation>,
		v : int[]/*sequence<long>*/
	) : void;
	function uniform4f(
		location : Nullable.<WebGLUniformLocation>,
		x : number/*GLfloat*/,
		y : number/*GLfloat*/,
		z : number/*GLfloat*/,
		w : number/*GLfloat*/
	) : void;
	function uniform4fv(
		location : Nullable.<WebGLUniformLocation>,
		v : Float32Array
	) : void;
	function uniform4fv(
		location : Nullable.<WebGLUniformLocation>,
		v : number[]/*sequence<GLfloat>*/
	) : void;
	function uniform4fv(
		location : Nullable.<WebGLUniformLocation>,
		v : int[]/*sequence<GLfloat>*/
	) : void;
	function uniform4i(
		location : Nullable.<WebGLUniformLocation>,
		x : number/*GLint*/,
		y : number/*GLint*/,
		z : number/*GLint*/,
		w : number/*GLint*/
	) : void;
	function uniform4iv(
		location : Nullable.<WebGLUniformLocation>,
		v : Int32Array
	) : void;
	function uniform4iv(
		location : Nullable.<WebGLUniformLocation>,
		v : number[]/*sequence<long>*/
	) : void;
	function uniform4iv(
		location : Nullable.<WebGLUniformLocation>,
		v : int[]/*sequence<long>*/
	) : void;
	function uniformMatrix2fv(
		location : Nullable.<WebGLUniformLocation>,
		transpose : boolean/*GLboolean*/,
		value : Float32Array
	) : void;
	function uniformMatrix2fv(
		location : Nullable.<WebGLUniformLocation>,
		transpose : boolean/*GLboolean*/,
		value : number[]/*sequence<GLfloat>*/
	) : void;
	function uniformMatrix2fv(
		location : Nullable.<WebGLUniformLocation>,
		transpose : boolean/*GLboolean*/,
		value : int[]/*sequence<GLfloat>*/
	) : void;
	function uniformMatrix3fv(
		location : Nullable.<WebGLUniformLocation>,
		transpose : boolean/*GLboolean*/,
		value : Float32Array
	) : void;
	function uniformMatrix3fv(
		location : Nullable.<WebGLUniformLocation>,
		transpose : boolean/*GLboolean*/,
		value : number[]/*sequence<GLfloat>*/
	) : void;
	function uniformMatrix3fv(
		location : Nullable.<WebGLUniformLocation>,
		transpose : boolean/*GLboolean*/,
		value : int[]/*sequence<GLfloat>*/
	) : void;
	function uniformMatrix4fv(
		location : Nullable.<WebGLUniformLocation>,
		transpose : boolean/*GLboolean*/,
		value : Float32Array
	) : void;
	function uniformMatrix4fv(
		location : Nullable.<WebGLUniformLocation>,
		transpose : boolean/*GLboolean*/,
		value : number[]/*sequence<GLfloat>*/
	) : void;
	function uniformMatrix4fv(
		location : Nullable.<WebGLUniformLocation>,
		transpose : boolean/*GLboolean*/,
		value : int[]/*sequence<GLfloat>*/
	) : void;
	function useProgram(program : Nullable.<WebGLProgram>) : void;
	function validateProgram(program : Nullable.<WebGLProgram>) : void;
	function vertexAttrib1f(
		indx : number/*GLuint*/,
		x : number/*GLfloat*/
	) : void;
	function vertexAttrib1fv(
		indx : number/*GLuint*/,
		values : Float32Array
	) : void;
	function vertexAttrib1fv(
		indx : number/*GLuint*/,
		values : number[]/*sequence<GLfloat>*/
	) : void;
	function vertexAttrib1fv(
		indx : number/*GLuint*/,
		values : int[]/*sequence<GLfloat>*/
	) : void;
	function vertexAttrib2f(
		indx : number/*GLuint*/,
		x : number/*GLfloat*/,
		y : number/*GLfloat*/
	) : void;
	function vertexAttrib2fv(
		indx : number/*GLuint*/,
		values : Float32Array
	) : void;
	function vertexAttrib2fv(
		indx : number/*GLuint*/,
		values : number[]/*sequence<GLfloat>*/
	) : void;
	function vertexAttrib2fv(
		indx : number/*GLuint*/,
		values : int[]/*sequence<GLfloat>*/
	) : void;
	function vertexAttrib3f(
		indx : number/*GLuint*/,
		x : number/*GLfloat*/,
		y : number/*GLfloat*/,
		z : number/*GLfloat*/
	) : void;
	function vertexAttrib3fv(
		indx : number/*GLuint*/,
		values : Float32Array
	) : void;
	function vertexAttrib3fv(
		indx : number/*GLuint*/,
		values : number[]/*sequence<GLfloat>*/
	) : void;
	function vertexAttrib3fv(
		indx : number/*GLuint*/,
		values : int[]/*sequence<GLfloat>*/
	) : void;
	function vertexAttrib4f(
		indx : number/*GLuint*/,
		x : number/*GLfloat*/,
		y : number/*GLfloat*/,
		z : number/*GLfloat*/,
		w : number/*GLfloat*/
	) : void;
	function vertexAttrib4fv(
		indx : number/*GLuint*/,
		values : Float32Array
	) : void;
	function vertexAttrib4fv(
		indx : number/*GLuint*/,
		values : number[]/*sequence<GLfloat>*/
	) : void;
	function vertexAttrib4fv(
		indx : number/*GLuint*/,
		values : int[]/*sequence<GLfloat>*/
	) : void;
	function vertexAttribPointer(
		indx : number/*GLuint*/,
		size : number/*GLint*/,
		type : number/*GLenum*/,
		normalized : boolean/*GLboolean*/,
		stride : number/*GLsizei*/,
		offset : number/*GLintptr*/
	) : void;
	function viewport(
		x : number/*GLint*/,
		y : number/*GLint*/,
		width : number/*GLsizei*/,
		height : number/*GLsizei*/
	) : void;

} // end of WebGLRenderingContext

/** @see https://www.khronos.org/registry/webgl/specs/latest/webgl.idl */
native final class WebGLContextEvent extends Event {

	function constructor(type : string/*DOMString*/);
	function constructor(
		type : string/*DOMString*/,
		eventInit : WebGLContextEventInit
	);

	__readonly__ var statusMessage : string/*DOMString*/;

} // end of WebGLContextEvent

/** @see https://www.khronos.org/registry/webgl/specs/latest/webgl.idl */
native final class WebGLContextEventInit extends EventInit {

	var statusMessage : string/*DOMString*/;

} // end of WebGLContextEventInit

/** @see https://wiki.mozilla.org/GamepadAPI */
native final class nsIDOMGamepad extends Object/*nsISupports*/ {

	__readonly__ var id : string/*DOMString*/;
	__readonly__ var connected : boolean;
	__readonly__ var buttons : variant/*nsIVariant*/;
	__readonly__ var axes : variant/*nsIVariant*/;
	__readonly__ var index : number/*unsigned long*/;

} // end of nsIDOMGamepad

/** @see https://wiki.mozilla.org/GamepadAPI */
native final class nsIDOMGamepadConnectionEvent extends Event/*nsIDOMEvent*/ {

	__readonly__ var gamepad : nsIDOMGamepad;

} // end of nsIDOMGamepadConnectionEvent

/** @see https://wiki.mozilla.org/GamepadAPI */
native final class nsIDOMGamepadButtonEvent extends Event/*nsIDOMEvent*/ {

	__readonly__ var button : number/*unsigned long*/;
	__readonly__ var gamepad : nsIDOMGamepad;

} // end of nsIDOMGamepadButtonEvent

/** @see https://wiki.mozilla.org/GamepadAPI */
native final class nsIDOMGamepadAxisMoveEvent extends Event/*nsIDOMEvent*/ {

	__readonly__ var axis : number/*unsigned long*/;
	__readonly__ var value : number/*float*/;
	__readonly__ var gamepad : nsIDOMGamepad;

} // end of nsIDOMGamepadAxisMoveEvent

native __fake__ class WindowAnimationTiming {

	function requestAnimationFrame(
		callback : function(time:number/*DOMTimeStamp*/):void/*FrameRequestCallback*/
	) : number/*long*/;
	function cancelAnimationFrame(handle : number/*long*/) : void;
	// vender's extension
	function webkitRequestAnimationFrame(
		callback : function(time:number/*DOMTimeStamp*/):void/*FrameRequestCallback*/
	) : number/*long*/;
	function webkitCancelAnimationFrame(handle : number/*long*/) : void;
	function mozRequestAnimationFrame(
		callback : function(time:number/*DOMTimeStamp*/):void/*FrameRequestCallback*/
	) : number/*long*/;
	function mozCancelAnimationFrame(handle : number/*long*/) : void;

} // end of WindowAnimationTiming

native final class webkitURL extends URL {
}

native final class webkitAudioContext extends AudioContext {
}

native final class webkitIntent extends Intent {
}

native final class webkitIDBCursor extends IDBCursor {
}

native final class webkitIDBDatabase extends IDBDatabase {
}

native final class webkitIDBFactory extends IDBFactory {
}

native final class webkitIDBIndex extends IDBIndex {
}

native final class webkitIDBKeyRange extends IDBKeyRange {
}

native final class webkitIDBObjectStore extends IDBObjectStore {
}

native final class webkitIDBRequest extends IDBRequest {
}

native final class webkitIDBTransaction extends IDBTransaction {
}

native final class DeviceOrientationEvent extends Event {

	function constructor(type : string/*DOMString*/);
	function constructor(
		type : string/*DOMString*/,
		eventInitDict : DeviceOrientationEventInit
	);

	__readonly__ var alpha : Nullable.<number>/*double?*/;
	__readonly__ var beta : Nullable.<number>/*double?*/;
	__readonly__ var gamma : Nullable.<number>/*double?*/;
	__readonly__ var absolute : boolean;

} // end of DeviceOrientationEvent

native final class DeviceOrientationEventInit extends EventInit {

	var alpha : Nullable.<number>/*double?*/;
	var beta : Nullable.<number>/*double?*/;
	var gamma : Nullable.<number>/*double?*/;
	var absolute : boolean;

} // end of DeviceOrientationEventInit

native final __fake__ class DeviceAcceleration {

	__readonly__ var x : Nullable.<number>/*double?*/;
	__readonly__ var y : Nullable.<number>/*double?*/;
	__readonly__ var z : Nullable.<number>/*double?*/;

} // end of DeviceAcceleration

native final __fake__ class DeviceRotationRate {

	__readonly__ var alpha : Nullable.<number>/*double?*/;
	__readonly__ var beta : Nullable.<number>/*double?*/;
	__readonly__ var gamma : Nullable.<number>/*double?*/;

} // end of DeviceRotationRate

native final class DeviceMotionEvent extends Event {

	function constructor(type : string/*DOMString*/);
	function constructor(
		type : string/*DOMString*/,
		eventInitDict : DeviceMotionEventInit
	);

	__readonly__ var acceleration : Nullable.<DeviceAcceleration>;
	__readonly__ var accelerationIncludingGravity : Nullable.<DeviceAcceleration>;
	__readonly__ var rotationRate : Nullable.<DeviceRotationRate>;
	__readonly__ var interval : Nullable.<number>/*double?*/;

} // end of DeviceMotionEvent

native final class DeviceMotionEventInit extends EventInit {

	var acceleration : Nullable.<DeviceAcceleration>;
	var accelerationIncludingGravity : Nullable.<DeviceAcceleration>;
	var rotationRate : Nullable.<DeviceRotationRate>;
	var interval : Nullable.<number>/*double?*/;

} // end of DeviceMotionEventInit

native final class SVGMatrix {
}

native final __fake__ class CanvasPixelArray {

	__readonly__ var length : number/*unsigned long*/;
	function __native_index_operator__(
		index : number/*unsigned long*/
	) : Nullable.<number>/*octet*/;

} // end of CanvasPixelArray

native final class CSSRuleList {

	__readonly__ var length : number/*long*/;
	function __native_index_operator__(
		index : number/*long*/
	) : Nullable.<CSSRule>;
	/* getter */
	function item(index : number/*long*/) : Nullable.<CSSRule>;

} // end of CSSRuleList

native final class StyleSheetList {

	__readonly__ var length : number/*long*/;
	function __native_index_operator__(
		index : number/*long*/
	) : Nullable.<StyleSheet>;
	/* getter */
	function item(index : number/*long*/) : Nullable.<StyleSheet>;

} // end of StyleSheetList


